/* IconView.c generated by valac 0.56.17, the Vala compiler
 * generated from IconView.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2017-2022 elementary, Inc. (https://elementary.io)
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtksourceview/gtksource.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <granite-7.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ICON_VIEW (icon_view_get_type ())
#define ICON_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_VIEW, IconView))
#define ICON_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_VIEW, IconViewClass))
#define IS_ICON_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_VIEW))
#define IS_ICON_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_VIEW))
#define ICON_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_VIEW, IconViewClass))

typedef struct _IconView IconView;
typedef struct _IconViewClass IconViewClass;
typedef struct _IconViewPrivate IconViewPrivate;
typedef enum  {
	ICON_COLLECTION_CATEGORY_ACTIONS,
	ICON_COLLECTION_CATEGORY_APPS,
	ICON_COLLECTION_CATEGORY_CATEGORIES,
	ICON_COLLECTION_CATEGORY_DEVICES,
	ICON_COLLECTION_CATEGORY_EMBLEMS,
	ICON_COLLECTION_CATEGORY_EMOTES,
	ICON_COLLECTION_CATEGORY_MIMES,
	ICON_COLLECTION_CATEGORY_PLACES,
	ICON_COLLECTION_CATEGORY_STATUS
} IconCollectionCategory;

#define ICON_COLLECTION_TYPE_CATEGORY (icon_collection_category_get_type ())
enum  {
	ICON_VIEW_0_PROPERTY,
	ICON_VIEW_ICON_NAME_PROPERTY,
	ICON_VIEW_DESCRIPTION_PROPERTY,
	ICON_VIEW_CATEGORY_PROPERTY,
	ICON_VIEW_NUM_PROPERTIES
};
static GParamSpec* icon_view_properties[ICON_VIEW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define ICON_VIEW_TYPE_ICON_CHILD (icon_view_icon_child_get_type ())
#define ICON_VIEW_ICON_CHILD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ICON_VIEW_TYPE_ICON_CHILD, IconViewIconChild))
#define ICON_VIEW_ICON_CHILD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ICON_VIEW_TYPE_ICON_CHILD, IconViewIconChildClass))
#define ICON_VIEW_IS_ICON_CHILD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ICON_VIEW_TYPE_ICON_CHILD))
#define ICON_VIEW_IS_ICON_CHILD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ICON_VIEW_TYPE_ICON_CHILD))
#define ICON_VIEW_ICON_CHILD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ICON_VIEW_TYPE_ICON_CHILD, IconViewIconChildClass))

typedef struct _IconViewIconChild IconViewIconChild;
typedef struct _IconViewIconChildClass IconViewIconChildClass;
typedef struct _IconViewIconChildPrivate IconViewIconChildPrivate;
enum  {
	ICON_VIEW_ICON_CHILD_0_PROPERTY,
	ICON_VIEW_ICON_CHILD_ICON_SIZE_PROPERTY,
	ICON_VIEW_ICON_CHILD_ICON_NAME_PROPERTY,
	ICON_VIEW_ICON_CHILD_NUM_PROPERTIES
};
static GParamSpec* icon_view_icon_child_properties[ICON_VIEW_ICON_CHILD_NUM_PROPERTIES];
typedef struct _Block2Data Block2Data;

struct _IconView {
	GtkBox parent_instance;
	IconViewPrivate * priv;
};

struct _IconViewClass {
	GtkBoxClass parent_class;
};

struct _IconViewPrivate {
	gchar* _icon_name;
	gchar* _description;
	IconCollectionCategory _category;
	GtkSourceBuffer* source_buffer;
	GtkButton* copy_button;
};

struct _IconViewIconChild {
	GtkFlowBoxChild parent_instance;
	IconViewIconChildPrivate * priv;
};

struct _IconViewIconChildClass {
	GtkFlowBoxChildClass parent_class;
};

struct _IconViewIconChildPrivate {
	gint _icon_size;
	gchar* _icon_name;
};

struct _Block2Data {
	int _ref_count_;
	IconView* self;
	GtkFlowBox* color_row;
	GtkFlowBox* symbolic_row;
	GtkSettings* gtk_settings;
};

static gint IconView_private_offset;
static gpointer icon_view_parent_class = NULL;
static gint IconViewIconChild_private_offset;
static gpointer icon_view_icon_child_parent_class = NULL;

VALA_EXTERN GType icon_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IconView, g_object_unref)
VALA_EXTERN GType icon_collection_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN IconView* icon_view_new (void);
VALA_EXTERN IconView* icon_view_construct (GType object_type);
static void icon_view_child_activated (IconView* self,
                                GtkFlowBoxChild* child);
static GType icon_view_icon_child_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IconViewIconChild, g_object_unref)
static gint icon_view_icon_child_get_icon_size (IconViewIconChild* self);
static const gchar* icon_view_icon_child_get_icon_name (IconViewIconChild* self);
static void icon_view_copy_button_clicked (IconView* self);
static void __lambda4_ (IconView* self);
static void ___lambda4__gsource_once_func (gpointer self);
static void icon_view_fill_icon_row (IconView* self,
                              const gchar* _icon_name,
                              GtkFlowBox* row);
VALA_EXTERN IconCollectionCategory icon_view_get_category (IconView* self);
static IconViewIconChild* icon_view_icon_child_new (const gchar* icon_name,
                                             gint icon_size);
static IconViewIconChild* icon_view_icon_child_construct (GType object_type,
                                                   const gchar* icon_name,
                                                   gint icon_size);
VALA_EXTERN const gchar* icon_view_get_icon_name (IconView* self);
VALA_EXTERN void icon_view_set_icon_name (IconView* self,
                              const gchar* value);
VALA_EXTERN const gchar* icon_view_get_description (IconView* self);
VALA_EXTERN void icon_view_set_description (IconView* self,
                                const gchar* value);
VALA_EXTERN void icon_view_set_category (IconView* self,
                             IconCollectionCategory value);
static void icon_view_icon_child_set_icon_size (IconViewIconChild* self,
                                         gint value);
static void icon_view_icon_child_set_icon_name (IconViewIconChild* self,
                                         const gchar* value);
static GObject * icon_view_icon_child_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void icon_view_icon_child_finalize (GObject * obj);
static GType icon_view_icon_child_get_type_once (void);
static void _vala_icon_view_icon_child_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_icon_view_icon_child_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static GObject * icon_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _icon_view___lambda5_ (Block2Data* _data2_);
static void __icon_view___lambda5__g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self);
static void _icon_view___lambda6_ (Block2Data* _data2_);
static void __icon_view___lambda6__g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self);
static void _icon_view___lambda7_ (Block2Data* _data2_,
                            GtkFlowBoxChild* child);
static void __icon_view___lambda7__gtk_flow_box_child_activated (GtkFlowBox* _sender,
                                                          GtkFlowBoxChild* child,
                                                          gpointer self);
static void _icon_view___lambda8_ (Block2Data* _data2_,
                            GtkFlowBoxChild* child);
static void __icon_view___lambda8__gtk_flow_box_child_activated (GtkFlowBox* _sender,
                                                          GtkFlowBoxChild* child,
                                                          gpointer self);
static void _icon_view_copy_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void icon_view_finalize (GObject * obj);
static GType icon_view_get_type_once (void);
static void _vala_icon_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_icon_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
icon_view_get_instance_private (IconView* self)
{
	return G_STRUCT_MEMBER_P (self, IconView_private_offset);
}

IconView*
icon_view_construct (GType object_type)
{
	IconView * self = NULL;
	self = (IconView*) g_object_new (object_type, "icon-name", "address-book-new", "description", _ ("Create a new address book"), "category", ICON_COLLECTION_CATEGORY_ACTIONS, NULL);
	return self;
}

IconView*
icon_view_new (void)
{
	return icon_view_construct (TYPE_ICON_VIEW);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
icon_view_child_activated (IconView* self,
                           GtkFlowBoxChild* child)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (child != NULL);
	if (ICON_VIEW_IS_ICON_CHILD (child)) {
		IconViewIconChild* icon = NULL;
		IconViewIconChild* _tmp0_;
		IconViewIconChild* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, ICON_VIEW_TYPE_ICON_CHILD, IconViewIconChild));
		icon = _tmp0_;
		_tmp1_ = icon;
		_tmp2_ = icon_view_icon_child_get_icon_size (_tmp1_);
		_tmp3_ = _tmp2_;
		if (_tmp3_ > 16) {
			GtkSourceBuffer* _tmp4_;
			IconViewIconChild* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			IconViewIconChild* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			_tmp4_ = self->priv->source_buffer;
			_tmp5_ = icon;
			_tmp6_ = icon_view_icon_child_get_icon_name (_tmp5_);
			_tmp7_ = _tmp6_;
			_tmp8_ = icon;
			_tmp9_ = icon_view_icon_child_get_icon_size (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = g_strdup_printf ("var icon = new Gtk.Image.from_icon_name (\"%s\") {\n" \
"    pixel_size = %i\n" \
"};", _tmp7_, _tmp10_);
			_tmp12_ = _tmp11_;
			g_object_set ((GtkTextBuffer*) _tmp4_, "text", _tmp12_, NULL);
			_g_free0 (_tmp12_);
		} else {
			GtkSourceBuffer* _tmp13_;
			IconViewIconChild* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			_tmp13_ = self->priv->source_buffer;
			_tmp14_ = icon;
			_tmp15_ = icon_view_icon_child_get_icon_name (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = g_strdup_printf ("var icon = new Gtk.Image.from_icon_name (\"%s\");", _tmp16_);
			_tmp18_ = _tmp17_;
			g_object_set ((GtkTextBuffer*) _tmp13_, "text", _tmp18_, NULL);
			_g_free0 (_tmp18_);
		}
		_g_object_unref0 (icon);
	}
}

static void
__lambda4_ (IconView* self)
{
	GtkButton* _tmp0_;
	_tmp0_ = self->priv->copy_button;
	gtk_button_set_label (_tmp0_, _ ("Copy"));
}

static void
___lambda4__gsource_once_func (gpointer self)
{
	__lambda4_ ((IconView*) self);
}

static void
icon_view_copy_button_clicked (IconView* self)
{
	GdkClipboard* clipboard = NULL;
	GdkClipboard* _tmp0_;
	GtkSourceBuffer* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkButton* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_clipboard ((GtkWidget*) self);
	clipboard = _tmp0_;
	_tmp1_ = self->priv->source_buffer;
	g_object_get ((GtkTextBuffer*) _tmp1_, "text", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	gdk_clipboard_set_text (clipboard, _tmp4_);
	_g_free0 (_tmp4_);
	_tmp5_ = self->priv->copy_button;
	gtk_button_set_label (_tmp5_, _ ("Copied!"));
	g_timeout_add_once ((guint) 1000, ___lambda4__gsource_once_func, self);
}

static void
icon_view_fill_icon_row (IconView* self,
                         const gchar* _icon_name,
                         GtkFlowBox* row)
{
	GtkIconTheme* icon_theme = NULL;
	gchar* _tmp2_;
	GtkIconTheme* _tmp3_ = NULL;
	GtkIconTheme* _tmp4_;
	gint* sizes = NULL;
	gint sizes_length1 = 0;
	gint _sizes_size_ = 0;
	IconCollectionCategory _tmp9_;
	gint* _tmp13_;
	gint _tmp13__length1;
	gint* _tmp14_;
	gint _tmp14__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_icon_name != NULL);
	g_return_if_fail (row != NULL);
	while (TRUE) {
		GtkWidget* _tmp0_;
		GtkWidget* _tmp1_;
		_tmp0_ = gtk_widget_get_first_child ((GtkWidget*) row);
		if (!(_tmp0_ != NULL)) {
			break;
		}
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) row);
		gtk_flow_box_remove (row, _tmp1_);
	}
	_tmp2_ = g_strdup ("elementary");
	_tmp3_ = gtk_icon_theme_new ();
	gtk_icon_theme_set_theme_name (_tmp3_, _tmp2_);
	_g_free0 (_tmp2_);
	icon_theme = _tmp3_;
	_tmp4_ = icon_theme;
	if (!gtk_icon_theme_has_icon (_tmp4_, _icon_name)) {
		GtkLabel* not_has_label = NULL;
		GtkLabel* _tmp5_ = NULL;
		GtkLabel* _tmp6_;
		GtkLabel* _tmp7_;
		GtkLabel* _tmp8_;
		_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Unavailable"));
		gtk_widget_set_hexpand ((GtkWidget*) _tmp5_, TRUE);
		g_object_ref_sink (_tmp5_);
		not_has_label = _tmp5_;
		_tmp6_ = not_has_label;
		gtk_widget_add_css_class ((GtkWidget*) _tmp6_, GRANITE_STYLE_CLASS_DIM_LABEL);
		_tmp7_ = not_has_label;
		gtk_widget_add_css_class ((GtkWidget*) _tmp7_, GRANITE_STYLE_CLASS_H3_LABEL);
		_tmp8_ = not_has_label;
		gtk_flow_box_append (row, (GtkWidget*) _tmp8_);
		gtk_flow_box_set_max_children_per_line (row, (guint) 1);
		gtk_widget_set_can_target ((GtkWidget*) row, FALSE);
		_g_object_unref0 (not_has_label);
		_g_object_unref0 (icon_theme);
		return;
	}
	_tmp9_ = self->priv->_category;
	switch (_tmp9_) {
		case ICON_COLLECTION_CATEGORY_ACTIONS:
		case ICON_COLLECTION_CATEGORY_EMBLEMS:
		{
			gint* _tmp10_;
			_tmp10_ = g_new0 (gint, 4);
			_tmp10_[0] = 16;
			_tmp10_[1] = 24;
			_tmp10_[2] = 32;
			_tmp10_[3] = 48;
			sizes = (g_free (sizes), NULL);
			sizes = _tmp10_;
			sizes_length1 = 4;
			_sizes_size_ = sizes_length1;
			break;
		}
		case ICON_COLLECTION_CATEGORY_EMOTES:
		{
			gint* _tmp11_;
			_tmp11_ = g_new0 (gint, 1);
			_tmp11_[0] = 16;
			sizes = (g_free (sizes), NULL);
			sizes = _tmp11_;
			sizes_length1 = 1;
			_sizes_size_ = sizes_length1;
			break;
		}
		default:
		{
			gint* _tmp12_;
			_tmp12_ = g_new0 (gint, 6);
			_tmp12_[0] = 16;
			_tmp12_[1] = 24;
			_tmp12_[2] = 32;
			_tmp12_[3] = 48;
			_tmp12_[4] = 64;
			_tmp12_[5] = 128;
			sizes = (g_free (sizes), NULL);
			sizes = _tmp12_;
			sizes_length1 = 6;
			_sizes_size_ = sizes_length1;
			break;
		}
	}
	gtk_widget_set_can_target ((GtkWidget*) row, TRUE);
	_tmp13_ = sizes;
	_tmp13__length1 = sizes_length1;
	gtk_flow_box_set_max_children_per_line (row, (guint) _tmp13__length1);
	_tmp14_ = sizes;
	_tmp14__length1 = sizes_length1;
	{
		gint* size_collection = NULL;
		gint size_collection_length1 = 0;
		gint _size_collection_size_ = 0;
		gint size_it = 0;
		size_collection = _tmp14_;
		size_collection_length1 = _tmp14__length1;
		for (size_it = 0; size_it < size_collection_length1; size_it = size_it + 1) {
			gint size = 0;
			size = size_collection[size_it];
			{
				IconViewIconChild* icon_child = NULL;
				IconViewIconChild* _tmp15_;
				IconViewIconChild* _tmp16_;
				_tmp15_ = icon_view_icon_child_new (_icon_name, size);
				g_object_ref_sink (_tmp15_);
				icon_child = _tmp15_;
				_tmp16_ = icon_child;
				gtk_flow_box_append (row, (GtkWidget*) _tmp16_);
				_g_object_unref0 (icon_child);
			}
		}
	}
	sizes = (g_free (sizes), NULL);
	_g_object_unref0 (icon_theme);
}

const gchar*
icon_view_get_icon_name (IconView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

void
icon_view_set_icon_name (IconView* self,
                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = icon_view_get_icon_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, icon_view_properties[ICON_VIEW_ICON_NAME_PROPERTY]);
	}
}

const gchar*
icon_view_get_description (IconView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_description;
	result = _tmp0_;
	return result;
}

void
icon_view_set_description (IconView* self,
                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = icon_view_get_description (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_description);
		self->priv->_description = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, icon_view_properties[ICON_VIEW_DESCRIPTION_PROPERTY]);
	}
}

IconCollectionCategory
icon_view_get_category (IconView* self)
{
	IconCollectionCategory result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_category;
	return result;
}

void
icon_view_set_category (IconView* self,
                        IconCollectionCategory value)
{
	IconCollectionCategory old_value;
	g_return_if_fail (self != NULL);
	old_value = icon_view_get_category (self);
	if (old_value != value) {
		self->priv->_category = value;
		g_object_notify_by_pspec ((GObject *) self, icon_view_properties[ICON_VIEW_CATEGORY_PROPERTY]);
	}
}

static inline gpointer
icon_view_icon_child_get_instance_private (IconViewIconChild* self)
{
	return G_STRUCT_MEMBER_P (self, IconViewIconChild_private_offset);
}

static IconViewIconChild*
icon_view_icon_child_construct (GType object_type,
                                const gchar* icon_name,
                                gint icon_size)
{
	IconViewIconChild * self = NULL;
	g_return_val_if_fail (icon_name != NULL, NULL);
	self = (IconViewIconChild*) g_object_new (object_type, "icon-name", icon_name, "icon-size", icon_size, NULL);
	return self;
}

static IconViewIconChild*
icon_view_icon_child_new (const gchar* icon_name,
                          gint icon_size)
{
	return icon_view_icon_child_construct (ICON_VIEW_TYPE_ICON_CHILD, icon_name, icon_size);
}

static gint
icon_view_icon_child_get_icon_size (IconViewIconChild* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_icon_size;
	return result;
}

static void
icon_view_icon_child_set_icon_size (IconViewIconChild* self,
                                    gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = icon_view_icon_child_get_icon_size (self);
	if (old_value != value) {
		self->priv->_icon_size = value;
		g_object_notify_by_pspec ((GObject *) self, icon_view_icon_child_properties[ICON_VIEW_ICON_CHILD_ICON_SIZE_PROPERTY]);
	}
}

static const gchar*
icon_view_icon_child_get_icon_name (IconViewIconChild* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

static void
icon_view_icon_child_set_icon_name (IconViewIconChild* self,
                                    const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = icon_view_icon_child_get_icon_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, icon_view_icon_child_properties[ICON_VIEW_ICON_CHILD_ICON_NAME_PROPERTY]);
	}
}

static GObject *
icon_view_icon_child_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	IconViewIconChild * self;
	GtkImage* icon = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	GtkImage* _tmp2_ = NULL;
	GtkLabel* label = NULL;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkBox* box = NULL;
	GtkBox* _tmp8_ = NULL;
	GtkBox* _tmp9_;
	GtkImage* _tmp10_;
	GtkBox* _tmp11_;
	GtkLabel* _tmp12_;
	GtkBox* _tmp13_;
	parent_class = G_OBJECT_CLASS (icon_view_icon_child_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ICON_VIEW_TYPE_ICON_CHILD, IconViewIconChild);
	_tmp0_ = self->priv->_icon_name;
	_tmp1_ = self->priv->_icon_size;
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_);
	gtk_image_set_pixel_size (_tmp2_, _tmp1_);
	g_object_set (_tmp2_, "use-fallback", TRUE, NULL);
	g_object_ref_sink (_tmp2_);
	icon = _tmp2_;
	_tmp3_ = self->priv->_icon_size;
	_tmp4_ = g_strdup_printf ("%ipx", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	label = _tmp7_;
	_tmp8_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp8_, 6);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp8_, 6);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp8_, 6);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp8_, 6);
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp8_);
	box = _tmp8_;
	_tmp9_ = box;
	_tmp10_ = icon;
	gtk_box_append (_tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = box;
	_tmp12_ = label;
	gtk_box_append (_tmp11_, (GtkWidget*) _tmp12_);
	_tmp13_ = box;
	gtk_flow_box_child_set_child ((GtkFlowBoxChild*) self, (GtkWidget*) _tmp13_);
	_g_object_unref0 (box);
	_g_object_unref0 (label);
	_g_object_unref0 (icon);
	return obj;
}

static void
icon_view_icon_child_class_init (IconViewIconChildClass * klass,
                                 gpointer klass_data)
{
	icon_view_icon_child_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &IconViewIconChild_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_icon_view_icon_child_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_icon_view_icon_child_set_property;
	G_OBJECT_CLASS (klass)->constructor = icon_view_icon_child_constructor;
	G_OBJECT_CLASS (klass)->finalize = icon_view_icon_child_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_VIEW_ICON_CHILD_ICON_SIZE_PROPERTY, icon_view_icon_child_properties[ICON_VIEW_ICON_CHILD_ICON_SIZE_PROPERTY] = g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_VIEW_ICON_CHILD_ICON_NAME_PROPERTY, icon_view_icon_child_properties[ICON_VIEW_ICON_CHILD_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
icon_view_icon_child_instance_init (IconViewIconChild * self,
                                    gpointer klass)
{
	self->priv = icon_view_icon_child_get_instance_private (self);
}

static void
icon_view_icon_child_finalize (GObject * obj)
{
	IconViewIconChild * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ICON_VIEW_TYPE_ICON_CHILD, IconViewIconChild);
	_g_free0 (self->priv->_icon_name);
	G_OBJECT_CLASS (icon_view_icon_child_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
icon_view_icon_child_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconViewIconChildClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_view_icon_child_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconViewIconChild), 0, (GInstanceInitFunc) icon_view_icon_child_instance_init, NULL };
	GType icon_view_icon_child_type_id;
	icon_view_icon_child_type_id = g_type_register_static (gtk_flow_box_child_get_type (), "IconViewIconChild", &g_define_type_info, 0);
	IconViewIconChild_private_offset = g_type_add_instance_private (icon_view_icon_child_type_id, sizeof (IconViewIconChildPrivate));
	return icon_view_icon_child_type_id;
}

static GType
icon_view_icon_child_get_type (void)
{
	static gsize icon_view_icon_child_type_id__once = 0;
	if (g_once_init_enter (&icon_view_icon_child_type_id__once)) {
		GType icon_view_icon_child_type_id;
		icon_view_icon_child_type_id = icon_view_icon_child_get_type_once ();
		g_once_init_leave (&icon_view_icon_child_type_id__once, icon_view_icon_child_type_id);
	}
	return icon_view_icon_child_type_id__once;
}

static void
_vala_icon_view_icon_child_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	IconViewIconChild * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ICON_VIEW_TYPE_ICON_CHILD, IconViewIconChild);
	switch (property_id) {
		case ICON_VIEW_ICON_CHILD_ICON_SIZE_PROPERTY:
		g_value_set_int (value, icon_view_icon_child_get_icon_size (self));
		break;
		case ICON_VIEW_ICON_CHILD_ICON_NAME_PROPERTY:
		g_value_set_string (value, icon_view_icon_child_get_icon_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_icon_view_icon_child_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	IconViewIconChild * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ICON_VIEW_TYPE_ICON_CHILD, IconViewIconChild);
	switch (property_id) {
		case ICON_VIEW_ICON_CHILD_ICON_SIZE_PROPERTY:
		icon_view_icon_child_set_icon_size (self, g_value_get_int (value));
		break;
		case ICON_VIEW_ICON_CHILD_ICON_NAME_PROPERTY:
		icon_view_icon_child_set_icon_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		IconView* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->gtk_settings);
		_g_object_unref0 (_data2_->symbolic_row);
		_g_object_unref0 (_data2_->color_row);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
_icon_view___lambda5_ (Block2Data* _data2_)
{
	IconView* self;
	GtkSettings* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data2_->self;
	_tmp0_ = _data2_->gtk_settings;
	g_object_get (_tmp0_, "gtk-application-prefer-dark-theme", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkSourceBuffer* _tmp3_;
		GtkSourceStyleSchemeManager* _tmp4_;
		GtkSourceStyleSchemeManager* _tmp5_;
		GtkSourceStyleScheme* _tmp6_;
		_tmp3_ = self->priv->source_buffer;
		_tmp4_ = gtk_source_style_scheme_manager_new ();
		_tmp5_ = _tmp4_;
		_tmp6_ = gtk_source_style_scheme_manager_get_scheme (_tmp5_, "solarized-dark");
		gtk_source_buffer_set_style_scheme (_tmp3_, _tmp6_);
		_g_object_unref0 (_tmp5_);
	} else {
		GtkSourceBuffer* _tmp7_;
		GtkSourceStyleSchemeManager* _tmp8_;
		GtkSourceStyleSchemeManager* _tmp9_;
		GtkSourceStyleScheme* _tmp10_;
		_tmp7_ = self->priv->source_buffer;
		_tmp8_ = gtk_source_style_scheme_manager_new ();
		_tmp9_ = _tmp8_;
		_tmp10_ = gtk_source_style_scheme_manager_get_scheme (_tmp9_, "solarized-light");
		gtk_source_buffer_set_style_scheme (_tmp7_, _tmp10_);
		_g_object_unref0 (_tmp9_);
	}
}

static void
__icon_view___lambda5__g_object_notify (GObject* _sender,
                                        GParamSpec* pspec,
                                        gpointer self)
{
	_icon_view___lambda5_ (self);
}

static void
_icon_view___lambda6_ (Block2Data* _data2_)
{
	IconView* self;
	const gchar* _tmp0_;
	GtkFlowBox* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkFlowBox* _tmp5_;
	GtkFlowBoxChild* first_color_child = NULL;
	GtkFlowBox* _tmp6_;
	GtkFlowBoxChild* _tmp7_;
	GtkFlowBoxChild* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GtkFlowBoxChild* _tmp10_;
	self = _data2_->self;
	_tmp0_ = self->priv->_icon_name;
	_tmp1_ = _data2_->color_row;
	icon_view_fill_icon_row (self, _tmp0_, _tmp1_);
	_tmp2_ = self->priv->_icon_name;
	_tmp3_ = g_strconcat (_tmp2_, "-symbolic", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = _data2_->symbolic_row;
	icon_view_fill_icon_row (self, _tmp4_, _tmp5_);
	_g_free0 (_tmp4_);
	_tmp6_ = _data2_->color_row;
	_tmp7_ = gtk_flow_box_get_child_at_index (_tmp6_, 0);
	_tmp8_ = _g_object_ref0 (_tmp7_);
	first_color_child = _tmp8_;
	_tmp10_ = first_color_child;
	if (_tmp10_ != NULL) {
		GtkFlowBoxChild* _tmp11_;
		_tmp11_ = first_color_child;
		_tmp9_ = ICON_VIEW_IS_ICON_CHILD (_tmp11_);
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		GtkFlowBoxChild* _tmp12_;
		_tmp12_ = first_color_child;
		g_signal_emit_by_name (_tmp12_, "activate");
	} else {
		GtkFlowBox* _tmp13_;
		GtkFlowBoxChild* _tmp14_;
		_tmp13_ = _data2_->symbolic_row;
		_tmp14_ = gtk_flow_box_get_child_at_index (_tmp13_, 0);
		g_signal_emit_by_name (_tmp14_, "activate");
	}
	_g_object_unref0 (first_color_child);
}

static void
__icon_view___lambda6__g_object_notify (GObject* _sender,
                                        GParamSpec* pspec,
                                        gpointer self)
{
	_icon_view___lambda6_ (self);
}

static void
_icon_view___lambda7_ (Block2Data* _data2_,
                       GtkFlowBoxChild* child)
{
	IconView* self;
	GtkFlowBox* _tmp0_;
	self = _data2_->self;
	g_return_if_fail (child != NULL);
	_tmp0_ = _data2_->symbolic_row;
	gtk_flow_box_unselect_all (_tmp0_);
	icon_view_child_activated (self, child);
}

static void
__icon_view___lambda7__gtk_flow_box_child_activated (GtkFlowBox* _sender,
                                                     GtkFlowBoxChild* child,
                                                     gpointer self)
{
	_icon_view___lambda7_ (self, child);
}

static void
_icon_view___lambda8_ (Block2Data* _data2_,
                       GtkFlowBoxChild* child)
{
	IconView* self;
	GtkFlowBox* _tmp0_;
	self = _data2_->self;
	g_return_if_fail (child != NULL);
	_tmp0_ = _data2_->color_row;
	gtk_flow_box_unselect_all (_tmp0_);
	icon_view_child_activated (self, child);
}

static void
__icon_view___lambda8__gtk_flow_box_child_activated (GtkFlowBox* _sender,
                                                     GtkFlowBoxChild* child,
                                                     gpointer self)
{
	_icon_view___lambda8_ (self, child);
}

static void
_icon_view_copy_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
	icon_view_copy_button_clicked ((IconView*) self);
}

static GObject *
icon_view_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	IconView * self;
	Block2Data* _data2_;
	GtkImage* header_icon = NULL;
	const gchar* _tmp0_;
	GtkImage* _tmp1_ = NULL;
	GtkLabel* title_label = NULL;
	const gchar* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel* _tmp4_;
	GtkLabel* description_label = NULL;
	const gchar* _tmp5_;
	GtkLabel* _tmp6_ = NULL;
	GtkWindowControls* window_controls = NULL;
	GtkWindowControls* _tmp7_ = NULL;
	GtkGrid* header_area = NULL;
	GtkGrid* _tmp8_;
	GtkGrid* _tmp9_;
	GtkGrid* _tmp10_;
	GtkLabel* _tmp11_;
	GtkGrid* _tmp12_;
	GtkImage* _tmp13_;
	GtkGrid* _tmp14_;
	GtkLabel* _tmp15_;
	GtkGrid* _tmp16_;
	GtkWindowControls* _tmp17_;
	GtkWindowHandle* header_handle = NULL;
	GtkGrid* _tmp18_;
	GtkWidget* _tmp19_;
	GtkWindowHandle* _tmp20_ = NULL;
	GtkWindowHandle* _tmp21_;
	GraniteHeaderLabel* color_title = NULL;
	GraniteHeaderLabel* _tmp22_;
	GtkFlowBox* _tmp23_ = NULL;
	GraniteHeaderLabel* symbolic_title = NULL;
	GraniteHeaderLabel* _tmp24_ = NULL;
	GtkFlowBox* _tmp25_ = NULL;
	GtkSizeGroup* size_group = NULL;
	GtkSizeGroup* _tmp26_;
	GtkSizeGroup* _tmp27_;
	GtkFlowBox* _tmp28_;
	GtkSizeGroup* _tmp29_;
	GtkFlowBox* _tmp30_;
	GraniteHeaderLabel* snippet_title = NULL;
	GraniteHeaderLabel* _tmp31_ = NULL;
	GtkSourceLanguageManager* _tmp32_;
	GtkSourceLanguage* _tmp33_;
	GtkSourceLanguage* _tmp34_;
	GtkSourceBuffer* _tmp35_ = NULL;
	GtkSourceView* source_view = NULL;
	GtkSourceBuffer* _tmp36_;
	GtkTextBuffer* _tmp37_;
	GtkSourceView* _tmp38_ = NULL;
	GtkSourceView* _tmp39_;
	GtkSourceView* _tmp40_;
	GtkButton* _tmp41_ = NULL;
	GtkButton* _tmp42_;
	GtkRevealer* copy_button_revealer = NULL;
	GtkButton* _tmp43_;
	GtkWidget* _tmp44_;
	GtkRevealer* _tmp45_ = NULL;
	GtkEventControllerMotion* copy_controller_motion = NULL;
	GtkEventControllerMotion* _tmp46_;
	GtkEventControllerMotion* _tmp47_;
	GtkRevealer* _tmp48_;
	GtkEventControllerFocus* copy_controller_focus = NULL;
	GtkEventControllerFocus* _tmp49_;
	GtkEventControllerFocus* _tmp50_;
	GtkRevealer* _tmp51_;
	GtkOverlay* source_overlay = NULL;
	GtkSourceView* _tmp52_;
	GtkWidget* _tmp53_;
	GtkOverlay* _tmp54_ = NULL;
	GtkOverlay* _tmp55_;
	GtkRevealer* _tmp56_;
	GtkOverlay* _tmp57_;
	GtkEventControllerMotion* _tmp58_;
	GtkEventController* _tmp59_;
	GtkOverlay* _tmp60_;
	GtkEventControllerFocus* _tmp61_;
	GtkEventController* _tmp62_;
	GtkBox* content_area = NULL;
	GtkBox* _tmp63_ = NULL;
	GtkBox* _tmp64_;
	GtkBox* _tmp65_;
	GraniteHeaderLabel* _tmp66_;
	GtkBox* _tmp67_;
	GtkFlowBox* _tmp68_;
	GtkBox* _tmp69_;
	GraniteHeaderLabel* _tmp70_;
	GtkBox* _tmp71_;
	GtkFlowBox* _tmp72_;
	GtkBox* _tmp73_;
	GraniteHeaderLabel* _tmp74_;
	GtkBox* _tmp75_;
	GtkOverlay* _tmp76_;
	GtkScrolledWindow* scrolled = NULL;
	GtkBox* _tmp77_;
	GtkWidget* _tmp78_;
	GtkScrolledWindow* _tmp79_ = NULL;
	GtkWindowHandle* _tmp80_;
	GtkScrolledWindow* _tmp81_;
	GtkSettings* _tmp82_;
	GtkSettings* _tmp83_;
	GtkSettings* _tmp84_;
	gboolean _tmp85_;
	gboolean _tmp86_;
	GtkSettings* _tmp95_;
	GtkImage* _tmp96_;
	GtkLabel* _tmp97_;
	GtkLabel* _tmp98_;
	GtkFlowBox* _tmp99_;
	GtkFlowBox* _tmp100_;
	GtkButton* _tmp101_;
	parent_class = G_OBJECT_CLASS (icon_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_VIEW, IconView);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = self->priv->_icon_name;
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_);
	gtk_image_set_icon_size (_tmp1_, GTK_ICON_SIZE_LARGE);
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp1_);
	header_icon = _tmp1_;
	_tmp2_ = self->priv->_icon_name;
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
	gtk_label_set_selectable (_tmp3_, TRUE);
	gtk_label_set_wrap (_tmp3_, TRUE);
	gtk_label_set_xalign (_tmp3_, (gfloat) 0);
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp3_);
	title_label = _tmp3_;
	_tmp4_ = title_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp4_, GRANITE_STYLE_CLASS_H2_LABEL);
	_tmp5_ = self->priv->_description;
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
	gtk_label_set_selectable (_tmp6_, TRUE);
	gtk_label_set_wrap (_tmp6_, TRUE);
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_START);
	gtk_label_set_xalign (_tmp6_, (gfloat) 0);
	gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp6_);
	description_label = _tmp6_;
	_tmp7_ = (GtkWindowControls*) gtk_window_controls_new (GTK_PACK_END);
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_END);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp7_, TRUE);
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp7_);
	window_controls = _tmp7_;
	_tmp8_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp8_);
	header_area = _tmp8_;
	_tmp9_ = header_area;
	gtk_widget_add_css_class ((GtkWidget*) _tmp9_, "header-area");
	_tmp10_ = header_area;
	_tmp11_ = title_label;
	gtk_grid_attach (_tmp10_, (GtkWidget*) _tmp11_, 1, 0, 1, 1);
	_tmp12_ = header_area;
	_tmp13_ = header_icon;
	gtk_grid_attach (_tmp12_, (GtkWidget*) _tmp13_, 0, 0, 1, 2);
	_tmp14_ = header_area;
	_tmp15_ = description_label;
	gtk_grid_attach (_tmp14_, (GtkWidget*) _tmp15_, 1, 1, 2, 1);
	_tmp16_ = header_area;
	_tmp17_ = window_controls;
	gtk_grid_attach (_tmp16_, (GtkWidget*) _tmp17_, 2, 0, 1, 2);
	_tmp18_ = header_area;
	_tmp19_ = _g_object_ref0 ((GtkWidget*) _tmp18_);
	_tmp20_ = (GtkWindowHandle*) gtk_window_handle_new ();
	gtk_window_handle_set_child (_tmp20_, _tmp19_);
	_g_object_unref0 (_tmp19_);
	g_object_ref_sink (_tmp20_);
	header_handle = _tmp20_;
	_tmp21_ = header_handle;
	gtk_widget_add_css_class ((GtkWidget*) _tmp21_, "titlebar");
	_tmp22_ = granite_header_label_new (_ ("Color Icons"));
	g_object_ref_sink (_tmp22_);
	color_title = _tmp22_;
	_tmp23_ = (GtkFlowBox*) gtk_flow_box_new ();
	gtk_flow_box_set_column_spacing (_tmp23_, (guint) 24);
	gtk_flow_box_set_row_spacing (_tmp23_, (guint) 12);
	g_object_ref_sink (_tmp23_);
	_data2_->color_row = _tmp23_;
	_tmp24_ = granite_header_label_new (_ ("Symbolic Icons"));
	gtk_widget_set_margin_top ((GtkWidget*) _tmp24_, 12);
	g_object_ref_sink (_tmp24_);
	symbolic_title = _tmp24_;
	_tmp25_ = (GtkFlowBox*) gtk_flow_box_new ();
	gtk_flow_box_set_column_spacing (_tmp25_, (guint) 24);
	gtk_flow_box_set_row_spacing (_tmp25_, (guint) 12);
	g_object_ref_sink (_tmp25_);
	_data2_->symbolic_row = _tmp25_;
	_tmp26_ = gtk_size_group_new (GTK_SIZE_GROUP_VERTICAL);
	size_group = _tmp26_;
	_tmp27_ = size_group;
	_tmp28_ = _data2_->color_row;
	gtk_size_group_add_widget (_tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = size_group;
	_tmp30_ = _data2_->symbolic_row;
	gtk_size_group_add_widget (_tmp29_, (GtkWidget*) _tmp30_);
	_tmp31_ = granite_header_label_new (_ ("Code Sample"));
	gtk_widget_set_margin_top ((GtkWidget*) _tmp31_, 12);
	g_object_ref_sink (_tmp31_);
	snippet_title = _tmp31_;
	_tmp32_ = gtk_source_language_manager_get_default ();
	_tmp33_ = gtk_source_language_manager_get_language (_tmp32_, "vala");
	_tmp34_ = _g_object_ref0 (_tmp33_);
	_tmp35_ = gtk_source_buffer_new (NULL);
	gtk_source_buffer_set_highlight_syntax (_tmp35_, TRUE);
	gtk_source_buffer_set_language (_tmp35_, _tmp34_);
	_g_object_unref0 (_tmp34_);
	_g_object_unref0 (self->priv->source_buffer);
	self->priv->source_buffer = _tmp35_;
	_tmp36_ = self->priv->source_buffer;
	_tmp37_ = _g_object_ref0 ((GtkTextBuffer*) _tmp36_);
	_tmp38_ = (GtkSourceView*) gtk_source_view_new ();
	gtk_text_view_set_buffer ((GtkTextView*) _tmp38_, _tmp37_);
	_g_object_unref0 (_tmp37_);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp38_, TRUE);
	gtk_text_view_set_editable ((GtkTextView*) _tmp38_, FALSE);
	gtk_text_view_set_monospace ((GtkTextView*) _tmp38_, TRUE);
	gtk_source_view_set_show_line_numbers (_tmp38_, TRUE);
	gtk_text_view_set_left_margin ((GtkTextView*) _tmp38_, 12);
	gtk_text_view_set_right_margin ((GtkTextView*) _tmp38_, 12);
	gtk_text_view_set_bottom_margin ((GtkTextView*) _tmp38_, 12);
	gtk_text_view_set_top_margin ((GtkTextView*) _tmp38_, 12);
	gtk_text_view_set_pixels_above_lines ((GtkTextView*) _tmp38_, 3);
	gtk_text_view_set_pixels_below_lines ((GtkTextView*) _tmp38_, 3);
	gtk_text_view_set_wrap_mode ((GtkTextView*) _tmp38_, GTK_WRAP_WORD);
	g_object_ref_sink (_tmp38_);
	source_view = _tmp38_;
	_tmp39_ = source_view;
	gtk_widget_add_css_class ((GtkWidget*) _tmp39_, GRANITE_STYLE_CLASS_CARD);
	_tmp40_ = source_view;
	gtk_widget_add_css_class ((GtkWidget*) _tmp40_, GRANITE_STYLE_CLASS_ROUNDED);
	_tmp41_ = (GtkButton*) gtk_button_new_with_label (_ ("Copy"));
	gtk_widget_set_valign ((GtkWidget*) _tmp41_, GTK_ALIGN_START);
	gtk_widget_set_halign ((GtkWidget*) _tmp41_, GTK_ALIGN_END);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp41_, 6);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp41_, 6);
	g_object_ref_sink (_tmp41_);
	_g_object_unref0 (self->priv->copy_button);
	self->priv->copy_button = _tmp41_;
	_tmp42_ = self->priv->copy_button;
	gtk_widget_add_css_class ((GtkWidget*) _tmp42_, GRANITE_STYLE_CLASS_SMALL_LABEL);
	_tmp43_ = self->priv->copy_button;
	_tmp44_ = _g_object_ref0 ((GtkWidget*) _tmp43_);
	_tmp45_ = (GtkRevealer*) gtk_revealer_new ();
	gtk_revealer_set_child (_tmp45_, _tmp44_);
	_g_object_unref0 (_tmp44_);
	gtk_widget_set_valign ((GtkWidget*) _tmp45_, GTK_ALIGN_START);
	gtk_widget_set_halign ((GtkWidget*) _tmp45_, GTK_ALIGN_END);
	gtk_revealer_set_transition_type (_tmp45_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	gtk_widget_set_overflow ((GtkWidget*) _tmp45_, GTK_OVERFLOW_VISIBLE);
	g_object_ref_sink (_tmp45_);
	copy_button_revealer = _tmp45_;
	_tmp46_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ();
	copy_controller_motion = _tmp46_;
	_tmp47_ = copy_controller_motion;
	_tmp48_ = copy_button_revealer;
	g_object_bind_property_with_closures ((GObject*) _tmp47_, "contains-pointer", (GObject*) _tmp48_, "reveal-child", G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp49_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
	copy_controller_focus = _tmp49_;
	_tmp50_ = copy_controller_focus;
	_tmp51_ = copy_button_revealer;
	g_object_bind_property_with_closures ((GObject*) _tmp50_, "contains-focus", (GObject*) _tmp51_, "reveal-child", G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp52_ = source_view;
	_tmp53_ = _g_object_ref0 ((GtkWidget*) _tmp52_);
	_tmp54_ = (GtkOverlay*) gtk_overlay_new ();
	gtk_overlay_set_child (_tmp54_, _tmp53_);
	_g_object_unref0 (_tmp53_);
	g_object_ref_sink (_tmp54_);
	source_overlay = _tmp54_;
	_tmp55_ = source_overlay;
	_tmp56_ = copy_button_revealer;
	gtk_overlay_add_overlay (_tmp55_, (GtkWidget*) _tmp56_);
	_tmp57_ = source_overlay;
	_tmp58_ = copy_controller_motion;
	_tmp59_ = _g_object_ref0 ((GtkEventController*) _tmp58_);
	gtk_widget_add_controller ((GtkWidget*) _tmp57_, _tmp59_);
	_tmp60_ = source_overlay;
	_tmp61_ = copy_controller_focus;
	_tmp62_ = _g_object_ref0 ((GtkEventController*) _tmp61_);
	gtk_widget_add_controller ((GtkWidget*) _tmp60_, _tmp62_);
	_tmp63_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp63_, TRUE);
	g_object_ref_sink (_tmp63_);
	content_area = _tmp63_;
	_tmp64_ = content_area;
	gtk_widget_add_css_class ((GtkWidget*) _tmp64_, "content-area");
	_tmp65_ = content_area;
	_tmp66_ = color_title;
	gtk_box_append (_tmp65_, (GtkWidget*) _tmp66_);
	_tmp67_ = content_area;
	_tmp68_ = _data2_->color_row;
	gtk_box_append (_tmp67_, (GtkWidget*) _tmp68_);
	_tmp69_ = content_area;
	_tmp70_ = symbolic_title;
	gtk_box_append (_tmp69_, (GtkWidget*) _tmp70_);
	_tmp71_ = content_area;
	_tmp72_ = _data2_->symbolic_row;
	gtk_box_append (_tmp71_, (GtkWidget*) _tmp72_);
	_tmp73_ = content_area;
	_tmp74_ = snippet_title;
	gtk_box_append (_tmp73_, (GtkWidget*) _tmp74_);
	_tmp75_ = content_area;
	_tmp76_ = source_overlay;
	gtk_box_append (_tmp75_, (GtkWidget*) _tmp76_);
	_tmp77_ = content_area;
	_tmp78_ = _g_object_ref0 ((GtkWidget*) _tmp77_);
	_tmp79_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
	gtk_scrolled_window_set_child (_tmp79_, _tmp78_);
	_g_object_unref0 (_tmp78_);
	g_object_set (_tmp79_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	g_object_ref_sink (_tmp79_);
	scrolled = _tmp79_;
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp80_ = header_handle;
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp80_);
	_tmp81_ = scrolled;
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp81_);
	_tmp82_ = gtk_settings_get_default ();
	_tmp83_ = _g_object_ref0 (_tmp82_);
	_data2_->gtk_settings = _tmp83_;
	_tmp84_ = _data2_->gtk_settings;
	g_object_get (_tmp84_, "gtk-application-prefer-dark-theme", &_tmp85_, NULL);
	_tmp86_ = _tmp85_;
	if (_tmp86_) {
		GtkSourceBuffer* _tmp87_;
		GtkSourceStyleSchemeManager* _tmp88_;
		GtkSourceStyleSchemeManager* _tmp89_;
		GtkSourceStyleScheme* _tmp90_;
		_tmp87_ = self->priv->source_buffer;
		_tmp88_ = gtk_source_style_scheme_manager_new ();
		_tmp89_ = _tmp88_;
		_tmp90_ = gtk_source_style_scheme_manager_get_scheme (_tmp89_, "solarized-dark");
		gtk_source_buffer_set_style_scheme (_tmp87_, _tmp90_);
		_g_object_unref0 (_tmp89_);
	} else {
		GtkSourceBuffer* _tmp91_;
		GtkSourceStyleSchemeManager* _tmp92_;
		GtkSourceStyleSchemeManager* _tmp93_;
		GtkSourceStyleScheme* _tmp94_;
		_tmp91_ = self->priv->source_buffer;
		_tmp92_ = gtk_source_style_scheme_manager_new ();
		_tmp93_ = _tmp92_;
		_tmp94_ = gtk_source_style_scheme_manager_get_scheme (_tmp93_, "solarized-light");
		gtk_source_buffer_set_style_scheme (_tmp91_, _tmp94_);
		_g_object_unref0 (_tmp93_);
	}
	_tmp95_ = _data2_->gtk_settings;
	g_signal_connect_data ((GObject*) _tmp95_, "notify::gtk-application-prefer-dark-theme", (GCallback) __icon_view___lambda5__g_object_notify, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp96_ = header_icon;
	g_object_bind_property_with_closures ((GObject*) self, "icon-name", (GObject*) _tmp96_, "icon-name", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp97_ = title_label;
	g_object_bind_property_with_closures ((GObject*) self, "icon-name", (GObject*) _tmp97_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp98_ = description_label;
	g_object_bind_property_with_closures ((GObject*) self, "description", (GObject*) _tmp98_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	g_signal_connect_data ((GObject*) self, "notify::icon-name", (GCallback) __icon_view___lambda6__g_object_notify, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp99_ = _data2_->color_row;
	g_signal_connect_data (_tmp99_, "child-activated", (GCallback) __icon_view___lambda7__gtk_flow_box_child_activated, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp100_ = _data2_->symbolic_row;
	g_signal_connect_data (_tmp100_, "child-activated", (GCallback) __icon_view___lambda8__gtk_flow_box_child_activated, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp101_ = self->priv->copy_button;
	g_signal_connect_object (_tmp101_, "clicked", (GCallback) _icon_view_copy_button_clicked_gtk_button_clicked, self, 0);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (content_area);
	_g_object_unref0 (source_overlay);
	_g_object_unref0 (copy_controller_focus);
	_g_object_unref0 (copy_controller_motion);
	_g_object_unref0 (copy_button_revealer);
	_g_object_unref0 (source_view);
	_g_object_unref0 (snippet_title);
	_g_object_unref0 (size_group);
	_g_object_unref0 (symbolic_title);
	_g_object_unref0 (color_title);
	_g_object_unref0 (header_handle);
	_g_object_unref0 (header_area);
	_g_object_unref0 (window_controls);
	_g_object_unref0 (description_label);
	_g_object_unref0 (title_label);
	_g_object_unref0 (header_icon);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return obj;
}

static void
icon_view_class_init (IconViewClass * klass,
                      gpointer klass_data)
{
	icon_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &IconView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_icon_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_icon_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = icon_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = icon_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_VIEW_ICON_NAME_PROPERTY, icon_view_properties[ICON_VIEW_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_VIEW_DESCRIPTION_PROPERTY, icon_view_properties[ICON_VIEW_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_VIEW_CATEGORY_PROPERTY, icon_view_properties[ICON_VIEW_CATEGORY_PROPERTY] = g_param_spec_enum ("category", "category", "category", ICON_COLLECTION_TYPE_CATEGORY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}

static void
icon_view_instance_init (IconView * self,
                         gpointer klass)
{
	self->priv = icon_view_get_instance_private (self);
}

static void
icon_view_finalize (GObject * obj)
{
	IconView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_VIEW, IconView);
	_g_free0 (self->priv->_icon_name);
	_g_free0 (self->priv->_description);
	_g_object_unref0 (self->priv->source_buffer);
	_g_object_unref0 (self->priv->copy_button);
	G_OBJECT_CLASS (icon_view_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
icon_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconView), 0, (GInstanceInitFunc) icon_view_instance_init, NULL };
	GType icon_view_type_id;
	icon_view_type_id = g_type_register_static (gtk_box_get_type (), "IconView", &g_define_type_info, 0);
	IconView_private_offset = g_type_add_instance_private (icon_view_type_id, sizeof (IconViewPrivate));
	return icon_view_type_id;
}

GType
icon_view_get_type (void)
{
	static gsize icon_view_type_id__once = 0;
	if (g_once_init_enter (&icon_view_type_id__once)) {
		GType icon_view_type_id;
		icon_view_type_id = icon_view_get_type_once ();
		g_once_init_leave (&icon_view_type_id__once, icon_view_type_id);
	}
	return icon_view_type_id__once;
}

static void
_vala_icon_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	IconView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON_VIEW, IconView);
	switch (property_id) {
		case ICON_VIEW_ICON_NAME_PROPERTY:
		g_value_set_string (value, icon_view_get_icon_name (self));
		break;
		case ICON_VIEW_DESCRIPTION_PROPERTY:
		g_value_set_string (value, icon_view_get_description (self));
		break;
		case ICON_VIEW_CATEGORY_PROPERTY:
		g_value_set_enum (value, icon_view_get_category (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_icon_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	IconView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON_VIEW, IconView);
	switch (property_id) {
		case ICON_VIEW_ICON_NAME_PROPERTY:
		icon_view_set_icon_name (self, g_value_get_string (value));
		break;
		case ICON_VIEW_DESCRIPTION_PROPERTY:
		icon_view_set_description (self, g_value_get_string (value));
		break;
		case ICON_VIEW_CATEGORY_PROPERTY:
		icon_view_set_category (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

