/* IconCollection.c generated by valac 0.56.17, the Vala compiler
 * generated from IconCollection.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2017-2022 elementary, Inc. (https://elementary.io)
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ICON_COLLECTION (icon_collection_get_type ())
#define ICON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_COLLECTION, IconCollection))
#define ICON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_COLLECTION, IconCollectionClass))
#define IS_ICON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_COLLECTION))
#define IS_ICON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_COLLECTION))
#define ICON_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_COLLECTION, IconCollectionClass))

typedef struct _IconCollection IconCollection;
typedef struct _IconCollectionClass IconCollectionClass;
typedef struct _IconCollectionPrivate IconCollectionPrivate;
typedef enum  {
	ICON_COLLECTION_CATEGORY_ACTIONS,
	ICON_COLLECTION_CATEGORY_APPS,
	ICON_COLLECTION_CATEGORY_CATEGORIES,
	ICON_COLLECTION_CATEGORY_DEVICES,
	ICON_COLLECTION_CATEGORY_EMBLEMS,
	ICON_COLLECTION_CATEGORY_EMOTES,
	ICON_COLLECTION_CATEGORY_MIMES,
	ICON_COLLECTION_CATEGORY_PLACES,
	ICON_COLLECTION_CATEGORY_STATUS
} IconCollectionCategory;

#define ICON_COLLECTION_TYPE_CATEGORY (icon_collection_category_get_type ())

#define ICON_COLLECTION_TYPE_ICON (icon_collection_icon_get_type ())
typedef struct _IconCollectionIcon IconCollectionIcon;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecIconCollection ParamSpecIconCollection;

struct _IconCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	IconCollectionPrivate * priv;
};

struct _IconCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (IconCollection *self);
};

struct _IconCollectionIcon {
	gchar* name;
	gchar* description;
	IconCollectionCategory category;
};

struct _ParamSpecIconCollection {
	GParamSpec parent_instance;
};

static gpointer icon_collection_parent_class = NULL;

VALA_EXTERN gpointer icon_collection_ref (gpointer instance);
VALA_EXTERN void icon_collection_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_icon_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_icon_collection (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_icon_collection (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_icon_collection (const GValue* value);
VALA_EXTERN GType icon_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IconCollection, icon_collection_unref)
VALA_EXTERN GType icon_collection_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* icon_collection_category_to_string (IconCollectionCategory self);
VALA_EXTERN IconCollectionCategory* icon_collection_category_all (gint* result_length1);
VALA_EXTERN GType icon_collection_icon_get_type (void) G_GNUC_CONST ;
VALA_EXTERN IconCollectionIcon* icon_collection_icon_dup (const IconCollectionIcon* self);
VALA_EXTERN void icon_collection_icon_free (IconCollectionIcon* self);
VALA_EXTERN void icon_collection_icon_copy (const IconCollectionIcon* self,
                                IconCollectionIcon* dest);
VALA_EXTERN void icon_collection_icon_destroy (IconCollectionIcon* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (IconCollectionIcon, icon_collection_icon_destroy)
VALA_EXTERN IconCollectionIcon* icon_collection_icons (gint* result_length1);
VALA_EXTERN IconCollection* icon_collection_new (void);
VALA_EXTERN IconCollection* icon_collection_construct (GType object_type);
static void icon_collection_finalize (IconCollection * obj);
static GType icon_collection_get_type_once (void);

gchar*
icon_collection_category_to_string (IconCollectionCategory self)
{
	gchar* result;
	switch (self) {
		case ICON_COLLECTION_CATEGORY_ACTIONS:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Actions"));
			result = _tmp0_;
			return result;
		}
		case ICON_COLLECTION_CATEGORY_APPS:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Applications"));
			result = _tmp1_;
			return result;
		}
		case ICON_COLLECTION_CATEGORY_CATEGORIES:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Categories"));
			result = _tmp2_;
			return result;
		}
		case ICON_COLLECTION_CATEGORY_DEVICES:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Devices"));
			result = _tmp3_;
			return result;
		}
		case ICON_COLLECTION_CATEGORY_EMBLEMS:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Emblems"));
			result = _tmp4_;
			return result;
		}
		case ICON_COLLECTION_CATEGORY_EMOTES:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Emotes"));
			result = _tmp5_;
			return result;
		}
		case ICON_COLLECTION_CATEGORY_MIMES:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Media Types"));
			result = _tmp6_;
			return result;
		}
		case ICON_COLLECTION_CATEGORY_PLACES:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Places"));
			result = _tmp7_;
			return result;
		}
		case ICON_COLLECTION_CATEGORY_STATUS:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("Status"));
			result = _tmp8_;
			return result;
		}
		default:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup (_ ("OTHER"));
			result = _tmp9_;
			return result;
		}
	}
}

IconCollectionCategory*
icon_collection_category_all (gint* result_length1)
{
	IconCollectionCategory* _tmp0_;
	IconCollectionCategory* _tmp1_;
	gint _tmp1__length1;
	IconCollectionCategory* result;
	_tmp0_ = g_new0 (IconCollectionCategory, 9);
	_tmp0_[0] = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp0_[1] = ICON_COLLECTION_CATEGORY_APPS;
	_tmp0_[2] = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp0_[3] = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp0_[4] = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp0_[5] = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp0_[6] = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp0_[7] = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp0_[8] = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = 9;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

 G_GNUC_NO_INLINE static GType
icon_collection_category_get_type_once (void)
{
	static const GEnumValue values[] = {{ICON_COLLECTION_CATEGORY_ACTIONS, "ICON_COLLECTION_CATEGORY_ACTIONS", "actions"}, {ICON_COLLECTION_CATEGORY_APPS, "ICON_COLLECTION_CATEGORY_APPS", "apps"}, {ICON_COLLECTION_CATEGORY_CATEGORIES, "ICON_COLLECTION_CATEGORY_CATEGORIES", "categories"}, {ICON_COLLECTION_CATEGORY_DEVICES, "ICON_COLLECTION_CATEGORY_DEVICES", "devices"}, {ICON_COLLECTION_CATEGORY_EMBLEMS, "ICON_COLLECTION_CATEGORY_EMBLEMS", "emblems"}, {ICON_COLLECTION_CATEGORY_EMOTES, "ICON_COLLECTION_CATEGORY_EMOTES", "emotes"}, {ICON_COLLECTION_CATEGORY_MIMES, "ICON_COLLECTION_CATEGORY_MIMES", "mimes"}, {ICON_COLLECTION_CATEGORY_PLACES, "ICON_COLLECTION_CATEGORY_PLACES", "places"}, {ICON_COLLECTION_CATEGORY_STATUS, "ICON_COLLECTION_CATEGORY_STATUS", "status"}, {0, NULL, NULL}};
	GType icon_collection_category_type_id;
	icon_collection_category_type_id = g_enum_register_static ("IconCollectionCategory", values);
	return icon_collection_category_type_id;
}

GType
icon_collection_category_get_type (void)
{
	static gsize icon_collection_category_type_id__once = 0;
	if (g_once_init_enter (&icon_collection_category_type_id__once)) {
		GType icon_collection_category_type_id;
		icon_collection_category_type_id = icon_collection_category_get_type_once ();
		g_once_init_leave (&icon_collection_category_type_id__once, icon_collection_category_type_id);
	}
	return icon_collection_category_type_id__once;
}

IconCollectionIcon*
icon_collection_icons (gint* result_length1)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	IconCollectionIcon _tmp2_ = {0};
	gchar* _tmp3_;
	gchar* _tmp4_;
	IconCollectionIcon _tmp5_ = {0};
	gchar* _tmp6_;
	gchar* _tmp7_;
	IconCollectionIcon _tmp8_ = {0};
	gchar* _tmp9_;
	gchar* _tmp10_;
	IconCollectionIcon _tmp11_ = {0};
	gchar* _tmp12_;
	gchar* _tmp13_;
	IconCollectionIcon _tmp14_ = {0};
	gchar* _tmp15_;
	gchar* _tmp16_;
	IconCollectionIcon _tmp17_ = {0};
	gchar* _tmp18_;
	gchar* _tmp19_;
	IconCollectionIcon _tmp20_ = {0};
	gchar* _tmp21_;
	gchar* _tmp22_;
	IconCollectionIcon _tmp23_ = {0};
	gchar* _tmp24_;
	gchar* _tmp25_;
	IconCollectionIcon _tmp26_ = {0};
	gchar* _tmp27_;
	gchar* _tmp28_;
	IconCollectionIcon _tmp29_ = {0};
	gchar* _tmp30_;
	gchar* _tmp31_;
	IconCollectionIcon _tmp32_ = {0};
	gchar* _tmp33_;
	gchar* _tmp34_;
	IconCollectionIcon _tmp35_ = {0};
	gchar* _tmp36_;
	gchar* _tmp37_;
	IconCollectionIcon _tmp38_ = {0};
	gchar* _tmp39_;
	gchar* _tmp40_;
	IconCollectionIcon _tmp41_ = {0};
	gchar* _tmp42_;
	gchar* _tmp43_;
	IconCollectionIcon _tmp44_ = {0};
	gchar* _tmp45_;
	gchar* _tmp46_;
	IconCollectionIcon _tmp47_ = {0};
	gchar* _tmp48_;
	gchar* _tmp49_;
	IconCollectionIcon _tmp50_ = {0};
	gchar* _tmp51_;
	gchar* _tmp52_;
	IconCollectionIcon _tmp53_ = {0};
	gchar* _tmp54_;
	gchar* _tmp55_;
	IconCollectionIcon _tmp56_ = {0};
	gchar* _tmp57_;
	gchar* _tmp58_;
	IconCollectionIcon _tmp59_ = {0};
	gchar* _tmp60_;
	gchar* _tmp61_;
	IconCollectionIcon _tmp62_ = {0};
	gchar* _tmp63_;
	gchar* _tmp64_;
	IconCollectionIcon _tmp65_ = {0};
	gchar* _tmp66_;
	gchar* _tmp67_;
	IconCollectionIcon _tmp68_ = {0};
	gchar* _tmp69_;
	gchar* _tmp70_;
	IconCollectionIcon _tmp71_ = {0};
	gchar* _tmp72_;
	gchar* _tmp73_;
	IconCollectionIcon _tmp74_ = {0};
	gchar* _tmp75_;
	gchar* _tmp76_;
	IconCollectionIcon _tmp77_ = {0};
	gchar* _tmp78_;
	gchar* _tmp79_;
	IconCollectionIcon _tmp80_ = {0};
	gchar* _tmp81_;
	gchar* _tmp82_;
	IconCollectionIcon _tmp83_ = {0};
	gchar* _tmp84_;
	gchar* _tmp85_;
	IconCollectionIcon _tmp86_ = {0};
	gchar* _tmp87_;
	gchar* _tmp88_;
	IconCollectionIcon _tmp89_ = {0};
	gchar* _tmp90_;
	gchar* _tmp91_;
	IconCollectionIcon _tmp92_ = {0};
	gchar* _tmp93_;
	gchar* _tmp94_;
	IconCollectionIcon _tmp95_ = {0};
	gchar* _tmp96_;
	gchar* _tmp97_;
	IconCollectionIcon _tmp98_ = {0};
	gchar* _tmp99_;
	gchar* _tmp100_;
	IconCollectionIcon _tmp101_ = {0};
	gchar* _tmp102_;
	gchar* _tmp103_;
	IconCollectionIcon _tmp104_ = {0};
	gchar* _tmp105_;
	gchar* _tmp106_;
	IconCollectionIcon _tmp107_ = {0};
	gchar* _tmp108_;
	gchar* _tmp109_;
	IconCollectionIcon _tmp110_ = {0};
	gchar* _tmp111_;
	gchar* _tmp112_;
	IconCollectionIcon _tmp113_ = {0};
	gchar* _tmp114_;
	gchar* _tmp115_;
	IconCollectionIcon _tmp116_ = {0};
	gchar* _tmp117_;
	gchar* _tmp118_;
	IconCollectionIcon _tmp119_ = {0};
	gchar* _tmp120_;
	gchar* _tmp121_;
	IconCollectionIcon _tmp122_ = {0};
	gchar* _tmp123_;
	gchar* _tmp124_;
	IconCollectionIcon _tmp125_ = {0};
	gchar* _tmp126_;
	gchar* _tmp127_;
	IconCollectionIcon _tmp128_ = {0};
	gchar* _tmp129_;
	gchar* _tmp130_;
	IconCollectionIcon _tmp131_ = {0};
	gchar* _tmp132_;
	gchar* _tmp133_;
	IconCollectionIcon _tmp134_ = {0};
	gchar* _tmp135_;
	gchar* _tmp136_;
	IconCollectionIcon _tmp137_ = {0};
	gchar* _tmp138_;
	gchar* _tmp139_;
	IconCollectionIcon _tmp140_ = {0};
	gchar* _tmp141_;
	gchar* _tmp142_;
	IconCollectionIcon _tmp143_ = {0};
	gchar* _tmp144_;
	gchar* _tmp145_;
	IconCollectionIcon _tmp146_ = {0};
	gchar* _tmp147_;
	gchar* _tmp148_;
	IconCollectionIcon _tmp149_ = {0};
	gchar* _tmp150_;
	gchar* _tmp151_;
	IconCollectionIcon _tmp152_ = {0};
	gchar* _tmp153_;
	gchar* _tmp154_;
	IconCollectionIcon _tmp155_ = {0};
	gchar* _tmp156_;
	gchar* _tmp157_;
	IconCollectionIcon _tmp158_ = {0};
	gchar* _tmp159_;
	gchar* _tmp160_;
	IconCollectionIcon _tmp161_ = {0};
	gchar* _tmp162_;
	gchar* _tmp163_;
	IconCollectionIcon _tmp164_ = {0};
	gchar* _tmp165_;
	gchar* _tmp166_;
	IconCollectionIcon _tmp167_ = {0};
	gchar* _tmp168_;
	gchar* _tmp169_;
	IconCollectionIcon _tmp170_ = {0};
	gchar* _tmp171_;
	gchar* _tmp172_;
	IconCollectionIcon _tmp173_ = {0};
	gchar* _tmp174_;
	gchar* _tmp175_;
	IconCollectionIcon _tmp176_ = {0};
	gchar* _tmp177_;
	gchar* _tmp178_;
	IconCollectionIcon _tmp179_ = {0};
	gchar* _tmp180_;
	gchar* _tmp181_;
	IconCollectionIcon _tmp182_ = {0};
	gchar* _tmp183_;
	gchar* _tmp184_;
	IconCollectionIcon _tmp185_ = {0};
	gchar* _tmp186_;
	gchar* _tmp187_;
	IconCollectionIcon _tmp188_ = {0};
	gchar* _tmp189_;
	gchar* _tmp190_;
	IconCollectionIcon _tmp191_ = {0};
	gchar* _tmp192_;
	gchar* _tmp193_;
	IconCollectionIcon _tmp194_ = {0};
	gchar* _tmp195_;
	gchar* _tmp196_;
	IconCollectionIcon _tmp197_ = {0};
	gchar* _tmp198_;
	gchar* _tmp199_;
	IconCollectionIcon _tmp200_ = {0};
	gchar* _tmp201_;
	gchar* _tmp202_;
	IconCollectionIcon _tmp203_ = {0};
	gchar* _tmp204_;
	gchar* _tmp205_;
	IconCollectionIcon _tmp206_ = {0};
	gchar* _tmp207_;
	gchar* _tmp208_;
	IconCollectionIcon _tmp209_ = {0};
	gchar* _tmp210_;
	gchar* _tmp211_;
	IconCollectionIcon _tmp212_ = {0};
	gchar* _tmp213_;
	gchar* _tmp214_;
	IconCollectionIcon _tmp215_ = {0};
	gchar* _tmp216_;
	gchar* _tmp217_;
	IconCollectionIcon _tmp218_ = {0};
	gchar* _tmp219_;
	gchar* _tmp220_;
	IconCollectionIcon _tmp221_ = {0};
	gchar* _tmp222_;
	gchar* _tmp223_;
	IconCollectionIcon _tmp224_ = {0};
	gchar* _tmp225_;
	gchar* _tmp226_;
	IconCollectionIcon _tmp227_ = {0};
	gchar* _tmp228_;
	gchar* _tmp229_;
	IconCollectionIcon _tmp230_ = {0};
	gchar* _tmp231_;
	gchar* _tmp232_;
	IconCollectionIcon _tmp233_ = {0};
	gchar* _tmp234_;
	gchar* _tmp235_;
	IconCollectionIcon _tmp236_ = {0};
	gchar* _tmp237_;
	gchar* _tmp238_;
	IconCollectionIcon _tmp239_ = {0};
	gchar* _tmp240_;
	gchar* _tmp241_;
	IconCollectionIcon _tmp242_ = {0};
	gchar* _tmp243_;
	gchar* _tmp244_;
	IconCollectionIcon _tmp245_ = {0};
	gchar* _tmp246_;
	gchar* _tmp247_;
	IconCollectionIcon _tmp248_ = {0};
	gchar* _tmp249_;
	gchar* _tmp250_;
	IconCollectionIcon _tmp251_ = {0};
	gchar* _tmp252_;
	gchar* _tmp253_;
	IconCollectionIcon _tmp254_ = {0};
	gchar* _tmp255_;
	gchar* _tmp256_;
	IconCollectionIcon _tmp257_ = {0};
	gchar* _tmp258_;
	gchar* _tmp259_;
	IconCollectionIcon _tmp260_ = {0};
	gchar* _tmp261_;
	gchar* _tmp262_;
	IconCollectionIcon _tmp263_ = {0};
	gchar* _tmp264_;
	gchar* _tmp265_;
	IconCollectionIcon _tmp266_ = {0};
	gchar* _tmp267_;
	gchar* _tmp268_;
	IconCollectionIcon _tmp269_ = {0};
	gchar* _tmp270_;
	gchar* _tmp271_;
	IconCollectionIcon _tmp272_ = {0};
	gchar* _tmp273_;
	gchar* _tmp274_;
	IconCollectionIcon _tmp275_ = {0};
	gchar* _tmp276_;
	gchar* _tmp277_;
	IconCollectionIcon _tmp278_ = {0};
	gchar* _tmp279_;
	gchar* _tmp280_;
	IconCollectionIcon _tmp281_ = {0};
	gchar* _tmp282_;
	gchar* _tmp283_;
	IconCollectionIcon _tmp284_ = {0};
	gchar* _tmp285_;
	gchar* _tmp286_;
	IconCollectionIcon _tmp287_ = {0};
	gchar* _tmp288_;
	gchar* _tmp289_;
	IconCollectionIcon _tmp290_ = {0};
	gchar* _tmp291_;
	gchar* _tmp292_;
	IconCollectionIcon _tmp293_ = {0};
	gchar* _tmp294_;
	gchar* _tmp295_;
	IconCollectionIcon _tmp296_ = {0};
	gchar* _tmp297_;
	gchar* _tmp298_;
	IconCollectionIcon _tmp299_ = {0};
	gchar* _tmp300_;
	gchar* _tmp301_;
	IconCollectionIcon _tmp302_ = {0};
	gchar* _tmp303_;
	gchar* _tmp304_;
	IconCollectionIcon _tmp305_ = {0};
	gchar* _tmp306_;
	gchar* _tmp307_;
	IconCollectionIcon _tmp308_ = {0};
	gchar* _tmp309_;
	gchar* _tmp310_;
	IconCollectionIcon _tmp311_ = {0};
	gchar* _tmp312_;
	gchar* _tmp313_;
	IconCollectionIcon _tmp314_ = {0};
	gchar* _tmp315_;
	gchar* _tmp316_;
	IconCollectionIcon _tmp317_ = {0};
	gchar* _tmp318_;
	gchar* _tmp319_;
	IconCollectionIcon _tmp320_ = {0};
	gchar* _tmp321_;
	gchar* _tmp322_;
	IconCollectionIcon _tmp323_ = {0};
	gchar* _tmp324_;
	gchar* _tmp325_;
	IconCollectionIcon _tmp326_ = {0};
	gchar* _tmp327_;
	gchar* _tmp328_;
	IconCollectionIcon _tmp329_ = {0};
	gchar* _tmp330_;
	gchar* _tmp331_;
	IconCollectionIcon _tmp332_ = {0};
	gchar* _tmp333_;
	gchar* _tmp334_;
	IconCollectionIcon _tmp335_ = {0};
	gchar* _tmp336_;
	gchar* _tmp337_;
	IconCollectionIcon _tmp338_ = {0};
	gchar* _tmp339_;
	gchar* _tmp340_;
	IconCollectionIcon _tmp341_ = {0};
	gchar* _tmp342_;
	gchar* _tmp343_;
	IconCollectionIcon _tmp344_ = {0};
	gchar* _tmp345_;
	gchar* _tmp346_;
	IconCollectionIcon _tmp347_ = {0};
	gchar* _tmp348_;
	gchar* _tmp349_;
	IconCollectionIcon _tmp350_ = {0};
	gchar* _tmp351_;
	gchar* _tmp352_;
	IconCollectionIcon _tmp353_ = {0};
	gchar* _tmp354_;
	gchar* _tmp355_;
	IconCollectionIcon _tmp356_ = {0};
	gchar* _tmp357_;
	gchar* _tmp358_;
	IconCollectionIcon _tmp359_ = {0};
	gchar* _tmp360_;
	gchar* _tmp361_;
	IconCollectionIcon _tmp362_ = {0};
	gchar* _tmp363_;
	gchar* _tmp364_;
	IconCollectionIcon _tmp365_ = {0};
	gchar* _tmp366_;
	gchar* _tmp367_;
	IconCollectionIcon _tmp368_ = {0};
	gchar* _tmp369_;
	gchar* _tmp370_;
	IconCollectionIcon _tmp371_ = {0};
	gchar* _tmp372_;
	gchar* _tmp373_;
	IconCollectionIcon _tmp374_ = {0};
	gchar* _tmp375_;
	gchar* _tmp376_;
	IconCollectionIcon _tmp377_ = {0};
	gchar* _tmp378_;
	gchar* _tmp379_;
	IconCollectionIcon _tmp380_ = {0};
	gchar* _tmp381_;
	gchar* _tmp382_;
	IconCollectionIcon _tmp383_ = {0};
	gchar* _tmp384_;
	gchar* _tmp385_;
	IconCollectionIcon _tmp386_ = {0};
	gchar* _tmp387_;
	gchar* _tmp388_;
	IconCollectionIcon _tmp389_ = {0};
	gchar* _tmp390_;
	gchar* _tmp391_;
	IconCollectionIcon _tmp392_ = {0};
	gchar* _tmp393_;
	gchar* _tmp394_;
	IconCollectionIcon _tmp395_ = {0};
	gchar* _tmp396_;
	gchar* _tmp397_;
	IconCollectionIcon _tmp398_ = {0};
	gchar* _tmp399_;
	gchar* _tmp400_;
	IconCollectionIcon _tmp401_ = {0};
	gchar* _tmp402_;
	gchar* _tmp403_;
	IconCollectionIcon _tmp404_ = {0};
	gchar* _tmp405_;
	gchar* _tmp406_;
	IconCollectionIcon _tmp407_ = {0};
	gchar* _tmp408_;
	gchar* _tmp409_;
	IconCollectionIcon _tmp410_ = {0};
	gchar* _tmp411_;
	gchar* _tmp412_;
	IconCollectionIcon _tmp413_ = {0};
	gchar* _tmp414_;
	gchar* _tmp415_;
	IconCollectionIcon _tmp416_ = {0};
	gchar* _tmp417_;
	gchar* _tmp418_;
	IconCollectionIcon _tmp419_ = {0};
	gchar* _tmp420_;
	gchar* _tmp421_;
	IconCollectionIcon _tmp422_ = {0};
	gchar* _tmp423_;
	gchar* _tmp424_;
	IconCollectionIcon _tmp425_ = {0};
	gchar* _tmp426_;
	gchar* _tmp427_;
	IconCollectionIcon _tmp428_ = {0};
	gchar* _tmp429_;
	gchar* _tmp430_;
	IconCollectionIcon _tmp431_ = {0};
	gchar* _tmp432_;
	gchar* _tmp433_;
	IconCollectionIcon _tmp434_ = {0};
	gchar* _tmp435_;
	gchar* _tmp436_;
	IconCollectionIcon _tmp437_ = {0};
	gchar* _tmp438_;
	gchar* _tmp439_;
	IconCollectionIcon _tmp440_ = {0};
	gchar* _tmp441_;
	gchar* _tmp442_;
	IconCollectionIcon _tmp443_ = {0};
	gchar* _tmp444_;
	gchar* _tmp445_;
	IconCollectionIcon _tmp446_ = {0};
	gchar* _tmp447_;
	gchar* _tmp448_;
	IconCollectionIcon _tmp449_ = {0};
	gchar* _tmp450_;
	gchar* _tmp451_;
	IconCollectionIcon _tmp452_ = {0};
	gchar* _tmp453_;
	gchar* _tmp454_;
	IconCollectionIcon _tmp455_ = {0};
	gchar* _tmp456_;
	gchar* _tmp457_;
	IconCollectionIcon _tmp458_ = {0};
	gchar* _tmp459_;
	gchar* _tmp460_;
	IconCollectionIcon _tmp461_ = {0};
	gchar* _tmp462_;
	gchar* _tmp463_;
	IconCollectionIcon _tmp464_ = {0};
	gchar* _tmp465_;
	gchar* _tmp466_;
	IconCollectionIcon _tmp467_ = {0};
	gchar* _tmp468_;
	gchar* _tmp469_;
	IconCollectionIcon _tmp470_ = {0};
	gchar* _tmp471_;
	gchar* _tmp472_;
	IconCollectionIcon _tmp473_ = {0};
	gchar* _tmp474_;
	gchar* _tmp475_;
	IconCollectionIcon _tmp476_ = {0};
	gchar* _tmp477_;
	gchar* _tmp478_;
	IconCollectionIcon _tmp479_ = {0};
	gchar* _tmp480_;
	gchar* _tmp481_;
	IconCollectionIcon _tmp482_ = {0};
	gchar* _tmp483_;
	gchar* _tmp484_;
	IconCollectionIcon _tmp485_ = {0};
	gchar* _tmp486_;
	gchar* _tmp487_;
	IconCollectionIcon _tmp488_ = {0};
	gchar* _tmp489_;
	gchar* _tmp490_;
	IconCollectionIcon _tmp491_ = {0};
	gchar* _tmp492_;
	gchar* _tmp493_;
	IconCollectionIcon _tmp494_ = {0};
	gchar* _tmp495_;
	gchar* _tmp496_;
	IconCollectionIcon _tmp497_ = {0};
	gchar* _tmp498_;
	gchar* _tmp499_;
	IconCollectionIcon _tmp500_ = {0};
	gchar* _tmp501_;
	gchar* _tmp502_;
	IconCollectionIcon _tmp503_ = {0};
	gchar* _tmp504_;
	gchar* _tmp505_;
	IconCollectionIcon _tmp506_ = {0};
	gchar* _tmp507_;
	gchar* _tmp508_;
	IconCollectionIcon _tmp509_ = {0};
	gchar* _tmp510_;
	gchar* _tmp511_;
	IconCollectionIcon _tmp512_ = {0};
	gchar* _tmp513_;
	gchar* _tmp514_;
	IconCollectionIcon _tmp515_ = {0};
	gchar* _tmp516_;
	gchar* _tmp517_;
	IconCollectionIcon _tmp518_ = {0};
	gchar* _tmp519_;
	gchar* _tmp520_;
	IconCollectionIcon _tmp521_ = {0};
	gchar* _tmp522_;
	gchar* _tmp523_;
	IconCollectionIcon _tmp524_ = {0};
	gchar* _tmp525_;
	gchar* _tmp526_;
	IconCollectionIcon _tmp527_ = {0};
	gchar* _tmp528_;
	gchar* _tmp529_;
	IconCollectionIcon _tmp530_ = {0};
	gchar* _tmp531_;
	gchar* _tmp532_;
	IconCollectionIcon _tmp533_ = {0};
	gchar* _tmp534_;
	gchar* _tmp535_;
	IconCollectionIcon _tmp536_ = {0};
	gchar* _tmp537_;
	gchar* _tmp538_;
	IconCollectionIcon _tmp539_ = {0};
	gchar* _tmp540_;
	gchar* _tmp541_;
	IconCollectionIcon _tmp542_ = {0};
	gchar* _tmp543_;
	gchar* _tmp544_;
	IconCollectionIcon _tmp545_ = {0};
	gchar* _tmp546_;
	gchar* _tmp547_;
	IconCollectionIcon _tmp548_ = {0};
	gchar* _tmp549_;
	gchar* _tmp550_;
	IconCollectionIcon _tmp551_ = {0};
	gchar* _tmp552_;
	gchar* _tmp553_;
	IconCollectionIcon _tmp554_ = {0};
	gchar* _tmp555_;
	gchar* _tmp556_;
	IconCollectionIcon _tmp557_ = {0};
	gchar* _tmp558_;
	gchar* _tmp559_;
	IconCollectionIcon _tmp560_ = {0};
	gchar* _tmp561_;
	gchar* _tmp562_;
	IconCollectionIcon _tmp563_ = {0};
	gchar* _tmp564_;
	gchar* _tmp565_;
	IconCollectionIcon _tmp566_ = {0};
	gchar* _tmp567_;
	gchar* _tmp568_;
	IconCollectionIcon _tmp569_ = {0};
	gchar* _tmp570_;
	gchar* _tmp571_;
	IconCollectionIcon _tmp572_ = {0};
	gchar* _tmp573_;
	gchar* _tmp574_;
	IconCollectionIcon _tmp575_ = {0};
	gchar* _tmp576_;
	gchar* _tmp577_;
	IconCollectionIcon _tmp578_ = {0};
	gchar* _tmp579_;
	gchar* _tmp580_;
	IconCollectionIcon _tmp581_ = {0};
	gchar* _tmp582_;
	gchar* _tmp583_;
	IconCollectionIcon _tmp584_ = {0};
	gchar* _tmp585_;
	gchar* _tmp586_;
	IconCollectionIcon _tmp587_ = {0};
	gchar* _tmp588_;
	gchar* _tmp589_;
	IconCollectionIcon _tmp590_ = {0};
	gchar* _tmp591_;
	gchar* _tmp592_;
	IconCollectionIcon _tmp593_ = {0};
	gchar* _tmp594_;
	gchar* _tmp595_;
	IconCollectionIcon _tmp596_ = {0};
	gchar* _tmp597_;
	gchar* _tmp598_;
	IconCollectionIcon _tmp599_ = {0};
	gchar* _tmp600_;
	gchar* _tmp601_;
	IconCollectionIcon _tmp602_ = {0};
	gchar* _tmp603_;
	gchar* _tmp604_;
	IconCollectionIcon _tmp605_ = {0};
	gchar* _tmp606_;
	gchar* _tmp607_;
	IconCollectionIcon _tmp608_ = {0};
	gchar* _tmp609_;
	gchar* _tmp610_;
	IconCollectionIcon _tmp611_ = {0};
	gchar* _tmp612_;
	gchar* _tmp613_;
	IconCollectionIcon _tmp614_ = {0};
	gchar* _tmp615_;
	gchar* _tmp616_;
	IconCollectionIcon _tmp617_ = {0};
	gchar* _tmp618_;
	gchar* _tmp619_;
	IconCollectionIcon _tmp620_ = {0};
	gchar* _tmp621_;
	gchar* _tmp622_;
	IconCollectionIcon _tmp623_ = {0};
	gchar* _tmp624_;
	gchar* _tmp625_;
	IconCollectionIcon _tmp626_ = {0};
	gchar* _tmp627_;
	gchar* _tmp628_;
	IconCollectionIcon _tmp629_ = {0};
	gchar* _tmp630_;
	gchar* _tmp631_;
	IconCollectionIcon _tmp632_ = {0};
	gchar* _tmp633_;
	gchar* _tmp634_;
	IconCollectionIcon _tmp635_ = {0};
	gchar* _tmp636_;
	gchar* _tmp637_;
	IconCollectionIcon _tmp638_ = {0};
	gchar* _tmp639_;
	gchar* _tmp640_;
	IconCollectionIcon _tmp641_ = {0};
	gchar* _tmp642_;
	gchar* _tmp643_;
	IconCollectionIcon _tmp644_ = {0};
	gchar* _tmp645_;
	gchar* _tmp646_;
	IconCollectionIcon _tmp647_ = {0};
	gchar* _tmp648_;
	gchar* _tmp649_;
	IconCollectionIcon _tmp650_ = {0};
	gchar* _tmp651_;
	gchar* _tmp652_;
	IconCollectionIcon _tmp653_ = {0};
	gchar* _tmp654_;
	gchar* _tmp655_;
	IconCollectionIcon _tmp656_ = {0};
	gchar* _tmp657_;
	gchar* _tmp658_;
	IconCollectionIcon _tmp659_ = {0};
	gchar* _tmp660_;
	gchar* _tmp661_;
	IconCollectionIcon _tmp662_ = {0};
	gchar* _tmp663_;
	gchar* _tmp664_;
	IconCollectionIcon _tmp665_ = {0};
	gchar* _tmp666_;
	gchar* _tmp667_;
	IconCollectionIcon _tmp668_ = {0};
	gchar* _tmp669_;
	gchar* _tmp670_;
	IconCollectionIcon _tmp671_ = {0};
	gchar* _tmp672_;
	gchar* _tmp673_;
	IconCollectionIcon _tmp674_ = {0};
	gchar* _tmp675_;
	gchar* _tmp676_;
	IconCollectionIcon _tmp677_ = {0};
	gchar* _tmp678_;
	gchar* _tmp679_;
	IconCollectionIcon _tmp680_ = {0};
	gchar* _tmp681_;
	gchar* _tmp682_;
	IconCollectionIcon _tmp683_ = {0};
	gchar* _tmp684_;
	gchar* _tmp685_;
	IconCollectionIcon _tmp686_ = {0};
	gchar* _tmp687_;
	gchar* _tmp688_;
	IconCollectionIcon _tmp689_ = {0};
	gchar* _tmp690_;
	gchar* _tmp691_;
	IconCollectionIcon _tmp692_ = {0};
	gchar* _tmp693_;
	gchar* _tmp694_;
	IconCollectionIcon _tmp695_ = {0};
	gchar* _tmp696_;
	gchar* _tmp697_;
	IconCollectionIcon _tmp698_ = {0};
	gchar* _tmp699_;
	gchar* _tmp700_;
	IconCollectionIcon _tmp701_ = {0};
	gchar* _tmp702_;
	gchar* _tmp703_;
	IconCollectionIcon _tmp704_ = {0};
	gchar* _tmp705_;
	gchar* _tmp706_;
	IconCollectionIcon _tmp707_ = {0};
	gchar* _tmp708_;
	gchar* _tmp709_;
	IconCollectionIcon _tmp710_ = {0};
	gchar* _tmp711_;
	gchar* _tmp712_;
	IconCollectionIcon _tmp713_ = {0};
	gchar* _tmp714_;
	gchar* _tmp715_;
	IconCollectionIcon _tmp716_ = {0};
	gchar* _tmp717_;
	gchar* _tmp718_;
	IconCollectionIcon _tmp719_ = {0};
	gchar* _tmp720_;
	gchar* _tmp721_;
	IconCollectionIcon _tmp722_ = {0};
	gchar* _tmp723_;
	gchar* _tmp724_;
	IconCollectionIcon _tmp725_ = {0};
	gchar* _tmp726_;
	gchar* _tmp727_;
	IconCollectionIcon _tmp728_ = {0};
	gchar* _tmp729_;
	gchar* _tmp730_;
	IconCollectionIcon _tmp731_ = {0};
	gchar* _tmp732_;
	gchar* _tmp733_;
	IconCollectionIcon _tmp734_ = {0};
	gchar* _tmp735_;
	gchar* _tmp736_;
	IconCollectionIcon _tmp737_ = {0};
	gchar* _tmp738_;
	gchar* _tmp739_;
	IconCollectionIcon _tmp740_ = {0};
	gchar* _tmp741_;
	gchar* _tmp742_;
	IconCollectionIcon _tmp743_ = {0};
	gchar* _tmp744_;
	gchar* _tmp745_;
	IconCollectionIcon _tmp746_ = {0};
	gchar* _tmp747_;
	gchar* _tmp748_;
	IconCollectionIcon _tmp749_ = {0};
	gchar* _tmp750_;
	gchar* _tmp751_;
	IconCollectionIcon _tmp752_ = {0};
	gchar* _tmp753_;
	gchar* _tmp754_;
	IconCollectionIcon _tmp755_ = {0};
	gchar* _tmp756_;
	gchar* _tmp757_;
	IconCollectionIcon _tmp758_ = {0};
	gchar* _tmp759_;
	gchar* _tmp760_;
	IconCollectionIcon _tmp761_ = {0};
	gchar* _tmp762_;
	gchar* _tmp763_;
	IconCollectionIcon _tmp764_ = {0};
	gchar* _tmp765_;
	gchar* _tmp766_;
	IconCollectionIcon _tmp767_ = {0};
	gchar* _tmp768_;
	gchar* _tmp769_;
	IconCollectionIcon _tmp770_ = {0};
	gchar* _tmp771_;
	gchar* _tmp772_;
	IconCollectionIcon _tmp773_ = {0};
	gchar* _tmp774_;
	gchar* _tmp775_;
	IconCollectionIcon _tmp776_ = {0};
	gchar* _tmp777_;
	gchar* _tmp778_;
	IconCollectionIcon _tmp779_ = {0};
	gchar* _tmp780_;
	gchar* _tmp781_;
	IconCollectionIcon _tmp782_ = {0};
	gchar* _tmp783_;
	gchar* _tmp784_;
	IconCollectionIcon _tmp785_ = {0};
	gchar* _tmp786_;
	gchar* _tmp787_;
	IconCollectionIcon _tmp788_ = {0};
	gchar* _tmp789_;
	gchar* _tmp790_;
	IconCollectionIcon _tmp791_ = {0};
	gchar* _tmp792_;
	gchar* _tmp793_;
	IconCollectionIcon _tmp794_ = {0};
	gchar* _tmp795_;
	gchar* _tmp796_;
	IconCollectionIcon _tmp797_ = {0};
	gchar* _tmp798_;
	gchar* _tmp799_;
	IconCollectionIcon _tmp800_ = {0};
	gchar* _tmp801_;
	gchar* _tmp802_;
	IconCollectionIcon _tmp803_ = {0};
	gchar* _tmp804_;
	gchar* _tmp805_;
	IconCollectionIcon _tmp806_ = {0};
	gchar* _tmp807_;
	gchar* _tmp808_;
	IconCollectionIcon _tmp809_ = {0};
	gchar* _tmp810_;
	gchar* _tmp811_;
	IconCollectionIcon _tmp812_ = {0};
	gchar* _tmp813_;
	gchar* _tmp814_;
	IconCollectionIcon _tmp815_ = {0};
	gchar* _tmp816_;
	gchar* _tmp817_;
	IconCollectionIcon _tmp818_ = {0};
	gchar* _tmp819_;
	gchar* _tmp820_;
	IconCollectionIcon _tmp821_ = {0};
	gchar* _tmp822_;
	gchar* _tmp823_;
	IconCollectionIcon _tmp824_ = {0};
	gchar* _tmp825_;
	gchar* _tmp826_;
	IconCollectionIcon _tmp827_ = {0};
	gchar* _tmp828_;
	gchar* _tmp829_;
	IconCollectionIcon _tmp830_ = {0};
	gchar* _tmp831_;
	gchar* _tmp832_;
	IconCollectionIcon _tmp833_ = {0};
	gchar* _tmp834_;
	gchar* _tmp835_;
	IconCollectionIcon _tmp836_ = {0};
	gchar* _tmp837_;
	gchar* _tmp838_;
	IconCollectionIcon _tmp839_ = {0};
	gchar* _tmp840_;
	gchar* _tmp841_;
	IconCollectionIcon _tmp842_ = {0};
	gchar* _tmp843_;
	gchar* _tmp844_;
	IconCollectionIcon _tmp845_ = {0};
	gchar* _tmp846_;
	gchar* _tmp847_;
	IconCollectionIcon _tmp848_ = {0};
	gchar* _tmp849_;
	gchar* _tmp850_;
	IconCollectionIcon _tmp851_ = {0};
	gchar* _tmp852_;
	gchar* _tmp853_;
	IconCollectionIcon _tmp854_ = {0};
	gchar* _tmp855_;
	gchar* _tmp856_;
	IconCollectionIcon _tmp857_ = {0};
	gchar* _tmp858_;
	gchar* _tmp859_;
	IconCollectionIcon _tmp860_ = {0};
	gchar* _tmp861_;
	gchar* _tmp862_;
	IconCollectionIcon _tmp863_ = {0};
	gchar* _tmp864_;
	gchar* _tmp865_;
	IconCollectionIcon _tmp866_ = {0};
	gchar* _tmp867_;
	gchar* _tmp868_;
	IconCollectionIcon _tmp869_ = {0};
	gchar* _tmp870_;
	gchar* _tmp871_;
	IconCollectionIcon _tmp872_ = {0};
	gchar* _tmp873_;
	gchar* _tmp874_;
	IconCollectionIcon _tmp875_ = {0};
	gchar* _tmp876_;
	gchar* _tmp877_;
	IconCollectionIcon _tmp878_ = {0};
	gchar* _tmp879_;
	gchar* _tmp880_;
	IconCollectionIcon _tmp881_ = {0};
	gchar* _tmp882_;
	gchar* _tmp883_;
	IconCollectionIcon _tmp884_ = {0};
	gchar* _tmp885_;
	gchar* _tmp886_;
	IconCollectionIcon _tmp887_ = {0};
	gchar* _tmp888_;
	gchar* _tmp889_;
	IconCollectionIcon _tmp890_ = {0};
	gchar* _tmp891_;
	gchar* _tmp892_;
	IconCollectionIcon _tmp893_ = {0};
	gchar* _tmp894_;
	gchar* _tmp895_;
	IconCollectionIcon _tmp896_ = {0};
	gchar* _tmp897_;
	gchar* _tmp898_;
	IconCollectionIcon _tmp899_ = {0};
	gchar* _tmp900_;
	gchar* _tmp901_;
	IconCollectionIcon _tmp902_ = {0};
	gchar* _tmp903_;
	gchar* _tmp904_;
	IconCollectionIcon _tmp905_ = {0};
	gchar* _tmp906_;
	gchar* _tmp907_;
	IconCollectionIcon _tmp908_ = {0};
	gchar* _tmp909_;
	gchar* _tmp910_;
	IconCollectionIcon _tmp911_ = {0};
	gchar* _tmp912_;
	gchar* _tmp913_;
	IconCollectionIcon _tmp914_ = {0};
	gchar* _tmp915_;
	gchar* _tmp916_;
	IconCollectionIcon _tmp917_ = {0};
	gchar* _tmp918_;
	gchar* _tmp919_;
	IconCollectionIcon _tmp920_ = {0};
	gchar* _tmp921_;
	gchar* _tmp922_;
	IconCollectionIcon _tmp923_ = {0};
	gchar* _tmp924_;
	gchar* _tmp925_;
	IconCollectionIcon _tmp926_ = {0};
	gchar* _tmp927_;
	gchar* _tmp928_;
	IconCollectionIcon _tmp929_ = {0};
	gchar* _tmp930_;
	gchar* _tmp931_;
	IconCollectionIcon _tmp932_ = {0};
	gchar* _tmp933_;
	gchar* _tmp934_;
	IconCollectionIcon _tmp935_ = {0};
	gchar* _tmp936_;
	gchar* _tmp937_;
	IconCollectionIcon _tmp938_ = {0};
	gchar* _tmp939_;
	gchar* _tmp940_;
	IconCollectionIcon _tmp941_ = {0};
	gchar* _tmp942_;
	gchar* _tmp943_;
	IconCollectionIcon _tmp944_ = {0};
	gchar* _tmp945_;
	gchar* _tmp946_;
	IconCollectionIcon _tmp947_ = {0};
	gchar* _tmp948_;
	gchar* _tmp949_;
	IconCollectionIcon _tmp950_ = {0};
	gchar* _tmp951_;
	gchar* _tmp952_;
	IconCollectionIcon _tmp953_ = {0};
	gchar* _tmp954_;
	gchar* _tmp955_;
	IconCollectionIcon _tmp956_ = {0};
	gchar* _tmp957_;
	gchar* _tmp958_;
	IconCollectionIcon _tmp959_ = {0};
	gchar* _tmp960_;
	gchar* _tmp961_;
	IconCollectionIcon _tmp962_ = {0};
	gchar* _tmp963_;
	gchar* _tmp964_;
	IconCollectionIcon _tmp965_ = {0};
	gchar* _tmp966_;
	gchar* _tmp967_;
	IconCollectionIcon _tmp968_ = {0};
	gchar* _tmp969_;
	gchar* _tmp970_;
	IconCollectionIcon _tmp971_ = {0};
	gchar* _tmp972_;
	gchar* _tmp973_;
	IconCollectionIcon _tmp974_ = {0};
	gchar* _tmp975_;
	gchar* _tmp976_;
	IconCollectionIcon _tmp977_ = {0};
	gchar* _tmp978_;
	gchar* _tmp979_;
	IconCollectionIcon _tmp980_ = {0};
	gchar* _tmp981_;
	gchar* _tmp982_;
	IconCollectionIcon _tmp983_ = {0};
	gchar* _tmp984_;
	gchar* _tmp985_;
	IconCollectionIcon _tmp986_ = {0};
	gchar* _tmp987_;
	gchar* _tmp988_;
	IconCollectionIcon _tmp989_ = {0};
	gchar* _tmp990_;
	gchar* _tmp991_;
	IconCollectionIcon _tmp992_ = {0};
	gchar* _tmp993_;
	gchar* _tmp994_;
	IconCollectionIcon _tmp995_ = {0};
	gchar* _tmp996_;
	gchar* _tmp997_;
	IconCollectionIcon _tmp998_ = {0};
	gchar* _tmp999_;
	gchar* _tmp1000_;
	IconCollectionIcon _tmp1001_ = {0};
	gchar* _tmp1002_;
	gchar* _tmp1003_;
	IconCollectionIcon _tmp1004_ = {0};
	gchar* _tmp1005_;
	gchar* _tmp1006_;
	IconCollectionIcon _tmp1007_ = {0};
	gchar* _tmp1008_;
	gchar* _tmp1009_;
	IconCollectionIcon _tmp1010_ = {0};
	gchar* _tmp1011_;
	gchar* _tmp1012_;
	IconCollectionIcon _tmp1013_ = {0};
	gchar* _tmp1014_;
	gchar* _tmp1015_;
	IconCollectionIcon _tmp1016_ = {0};
	gchar* _tmp1017_;
	gchar* _tmp1018_;
	IconCollectionIcon _tmp1019_ = {0};
	gchar* _tmp1020_;
	gchar* _tmp1021_;
	IconCollectionIcon _tmp1022_ = {0};
	gchar* _tmp1023_;
	gchar* _tmp1024_;
	IconCollectionIcon _tmp1025_ = {0};
	gchar* _tmp1026_;
	gchar* _tmp1027_;
	IconCollectionIcon _tmp1028_ = {0};
	gchar* _tmp1029_;
	gchar* _tmp1030_;
	IconCollectionIcon _tmp1031_ = {0};
	gchar* _tmp1032_;
	gchar* _tmp1033_;
	IconCollectionIcon _tmp1034_ = {0};
	gchar* _tmp1035_;
	gchar* _tmp1036_;
	IconCollectionIcon _tmp1037_ = {0};
	gchar* _tmp1038_;
	gchar* _tmp1039_;
	IconCollectionIcon _tmp1040_ = {0};
	gchar* _tmp1041_;
	gchar* _tmp1042_;
	IconCollectionIcon _tmp1043_ = {0};
	gchar* _tmp1044_;
	gchar* _tmp1045_;
	IconCollectionIcon _tmp1046_ = {0};
	gchar* _tmp1047_;
	gchar* _tmp1048_;
	IconCollectionIcon _tmp1049_ = {0};
	gchar* _tmp1050_;
	gchar* _tmp1051_;
	IconCollectionIcon _tmp1052_ = {0};
	gchar* _tmp1053_;
	gchar* _tmp1054_;
	IconCollectionIcon _tmp1055_ = {0};
	gchar* _tmp1056_;
	gchar* _tmp1057_;
	IconCollectionIcon _tmp1058_ = {0};
	gchar* _tmp1059_;
	gchar* _tmp1060_;
	IconCollectionIcon _tmp1061_ = {0};
	gchar* _tmp1062_;
	gchar* _tmp1063_;
	IconCollectionIcon _tmp1064_ = {0};
	gchar* _tmp1065_;
	gchar* _tmp1066_;
	IconCollectionIcon _tmp1067_ = {0};
	gchar* _tmp1068_;
	gchar* _tmp1069_;
	IconCollectionIcon _tmp1070_ = {0};
	gchar* _tmp1071_;
	gchar* _tmp1072_;
	IconCollectionIcon _tmp1073_ = {0};
	gchar* _tmp1074_;
	gchar* _tmp1075_;
	IconCollectionIcon _tmp1076_ = {0};
	gchar* _tmp1077_;
	gchar* _tmp1078_;
	IconCollectionIcon _tmp1079_ = {0};
	gchar* _tmp1080_;
	gchar* _tmp1081_;
	IconCollectionIcon _tmp1082_ = {0};
	gchar* _tmp1083_;
	gchar* _tmp1084_;
	IconCollectionIcon _tmp1085_ = {0};
	gchar* _tmp1086_;
	gchar* _tmp1087_;
	IconCollectionIcon _tmp1088_ = {0};
	gchar* _tmp1089_;
	gchar* _tmp1090_;
	IconCollectionIcon _tmp1091_ = {0};
	gchar* _tmp1092_;
	gchar* _tmp1093_;
	IconCollectionIcon _tmp1094_ = {0};
	gchar* _tmp1095_;
	gchar* _tmp1096_;
	IconCollectionIcon _tmp1097_ = {0};
	gchar* _tmp1098_;
	gchar* _tmp1099_;
	IconCollectionIcon _tmp1100_ = {0};
	gchar* _tmp1101_;
	gchar* _tmp1102_;
	IconCollectionIcon _tmp1103_ = {0};
	gchar* _tmp1104_;
	gchar* _tmp1105_;
	IconCollectionIcon _tmp1106_ = {0};
	gchar* _tmp1107_;
	gchar* _tmp1108_;
	IconCollectionIcon _tmp1109_ = {0};
	gchar* _tmp1110_;
	gchar* _tmp1111_;
	IconCollectionIcon _tmp1112_ = {0};
	gchar* _tmp1113_;
	gchar* _tmp1114_;
	IconCollectionIcon _tmp1115_ = {0};
	gchar* _tmp1116_;
	gchar* _tmp1117_;
	IconCollectionIcon _tmp1118_ = {0};
	gchar* _tmp1119_;
	gchar* _tmp1120_;
	IconCollectionIcon _tmp1121_ = {0};
	gchar* _tmp1122_;
	gchar* _tmp1123_;
	IconCollectionIcon _tmp1124_ = {0};
	gchar* _tmp1125_;
	gchar* _tmp1126_;
	IconCollectionIcon _tmp1127_ = {0};
	gchar* _tmp1128_;
	gchar* _tmp1129_;
	IconCollectionIcon _tmp1130_ = {0};
	gchar* _tmp1131_;
	gchar* _tmp1132_;
	IconCollectionIcon _tmp1133_ = {0};
	gchar* _tmp1134_;
	gchar* _tmp1135_;
	IconCollectionIcon _tmp1136_ = {0};
	gchar* _tmp1137_;
	gchar* _tmp1138_;
	IconCollectionIcon _tmp1139_ = {0};
	gchar* _tmp1140_;
	gchar* _tmp1141_;
	IconCollectionIcon _tmp1142_ = {0};
	gchar* _tmp1143_;
	gchar* _tmp1144_;
	IconCollectionIcon _tmp1145_ = {0};
	gchar* _tmp1146_;
	gchar* _tmp1147_;
	IconCollectionIcon _tmp1148_ = {0};
	gchar* _tmp1149_;
	gchar* _tmp1150_;
	IconCollectionIcon _tmp1151_ = {0};
	gchar* _tmp1152_;
	gchar* _tmp1153_;
	IconCollectionIcon _tmp1154_ = {0};
	gchar* _tmp1155_;
	gchar* _tmp1156_;
	IconCollectionIcon _tmp1157_ = {0};
	gchar* _tmp1158_;
	gchar* _tmp1159_;
	IconCollectionIcon _tmp1160_ = {0};
	gchar* _tmp1161_;
	gchar* _tmp1162_;
	IconCollectionIcon _tmp1163_ = {0};
	gchar* _tmp1164_;
	gchar* _tmp1165_;
	IconCollectionIcon _tmp1166_ = {0};
	gchar* _tmp1167_;
	gchar* _tmp1168_;
	IconCollectionIcon _tmp1169_ = {0};
	gchar* _tmp1170_;
	gchar* _tmp1171_;
	IconCollectionIcon _tmp1172_ = {0};
	gchar* _tmp1173_;
	gchar* _tmp1174_;
	IconCollectionIcon _tmp1175_ = {0};
	gchar* _tmp1176_;
	gchar* _tmp1177_;
	IconCollectionIcon _tmp1178_ = {0};
	gchar* _tmp1179_;
	gchar* _tmp1180_;
	IconCollectionIcon _tmp1181_ = {0};
	gchar* _tmp1182_;
	gchar* _tmp1183_;
	IconCollectionIcon _tmp1184_ = {0};
	gchar* _tmp1185_;
	gchar* _tmp1186_;
	IconCollectionIcon _tmp1187_ = {0};
	gchar* _tmp1188_;
	gchar* _tmp1189_;
	IconCollectionIcon _tmp1190_ = {0};
	gchar* _tmp1191_;
	gchar* _tmp1192_;
	IconCollectionIcon _tmp1193_ = {0};
	gchar* _tmp1194_;
	gchar* _tmp1195_;
	IconCollectionIcon _tmp1196_ = {0};
	gchar* _tmp1197_;
	gchar* _tmp1198_;
	IconCollectionIcon _tmp1199_ = {0};
	gchar* _tmp1200_;
	gchar* _tmp1201_;
	IconCollectionIcon _tmp1202_ = {0};
	gchar* _tmp1203_;
	gchar* _tmp1204_;
	IconCollectionIcon _tmp1205_ = {0};
	gchar* _tmp1206_;
	gchar* _tmp1207_;
	IconCollectionIcon _tmp1208_ = {0};
	gchar* _tmp1209_;
	gchar* _tmp1210_;
	IconCollectionIcon _tmp1211_ = {0};
	gchar* _tmp1212_;
	gchar* _tmp1213_;
	IconCollectionIcon _tmp1214_ = {0};
	gchar* _tmp1215_;
	gchar* _tmp1216_;
	IconCollectionIcon _tmp1217_ = {0};
	gchar* _tmp1218_;
	gchar* _tmp1219_;
	IconCollectionIcon _tmp1220_ = {0};
	gchar* _tmp1221_;
	gchar* _tmp1222_;
	IconCollectionIcon _tmp1223_ = {0};
	gchar* _tmp1224_;
	gchar* _tmp1225_;
	IconCollectionIcon _tmp1226_ = {0};
	gchar* _tmp1227_;
	gchar* _tmp1228_;
	IconCollectionIcon _tmp1229_ = {0};
	gchar* _tmp1230_;
	gchar* _tmp1231_;
	IconCollectionIcon _tmp1232_ = {0};
	gchar* _tmp1233_;
	gchar* _tmp1234_;
	IconCollectionIcon _tmp1235_ = {0};
	gchar* _tmp1236_;
	gchar* _tmp1237_;
	IconCollectionIcon _tmp1238_ = {0};
	gchar* _tmp1239_;
	gchar* _tmp1240_;
	IconCollectionIcon _tmp1241_ = {0};
	gchar* _tmp1242_;
	gchar* _tmp1243_;
	IconCollectionIcon _tmp1244_ = {0};
	gchar* _tmp1245_;
	gchar* _tmp1246_;
	IconCollectionIcon _tmp1247_ = {0};
	gchar* _tmp1248_;
	gchar* _tmp1249_;
	IconCollectionIcon _tmp1250_ = {0};
	gchar* _tmp1251_;
	gchar* _tmp1252_;
	IconCollectionIcon _tmp1253_ = {0};
	gchar* _tmp1254_;
	gchar* _tmp1255_;
	IconCollectionIcon _tmp1256_ = {0};
	gchar* _tmp1257_;
	gchar* _tmp1258_;
	IconCollectionIcon _tmp1259_ = {0};
	gchar* _tmp1260_;
	gchar* _tmp1261_;
	IconCollectionIcon _tmp1262_ = {0};
	gchar* _tmp1263_;
	gchar* _tmp1264_;
	IconCollectionIcon _tmp1265_ = {0};
	gchar* _tmp1266_;
	gchar* _tmp1267_;
	IconCollectionIcon _tmp1268_ = {0};
	gchar* _tmp1269_;
	gchar* _tmp1270_;
	IconCollectionIcon _tmp1271_ = {0};
	gchar* _tmp1272_;
	gchar* _tmp1273_;
	IconCollectionIcon _tmp1274_ = {0};
	gchar* _tmp1275_;
	gchar* _tmp1276_;
	IconCollectionIcon _tmp1277_ = {0};
	gchar* _tmp1278_;
	gchar* _tmp1279_;
	IconCollectionIcon _tmp1280_ = {0};
	gchar* _tmp1281_;
	gchar* _tmp1282_;
	IconCollectionIcon _tmp1283_ = {0};
	gchar* _tmp1284_;
	gchar* _tmp1285_;
	IconCollectionIcon _tmp1286_ = {0};
	gchar* _tmp1287_;
	gchar* _tmp1288_;
	IconCollectionIcon _tmp1289_ = {0};
	gchar* _tmp1290_;
	gchar* _tmp1291_;
	IconCollectionIcon _tmp1292_ = {0};
	gchar* _tmp1293_;
	gchar* _tmp1294_;
	IconCollectionIcon _tmp1295_ = {0};
	gchar* _tmp1296_;
	gchar* _tmp1297_;
	IconCollectionIcon _tmp1298_ = {0};
	gchar* _tmp1299_;
	gchar* _tmp1300_;
	IconCollectionIcon _tmp1301_ = {0};
	gchar* _tmp1302_;
	gchar* _tmp1303_;
	IconCollectionIcon _tmp1304_ = {0};
	gchar* _tmp1305_;
	gchar* _tmp1306_;
	IconCollectionIcon _tmp1307_ = {0};
	gchar* _tmp1308_;
	gchar* _tmp1309_;
	IconCollectionIcon _tmp1310_ = {0};
	gchar* _tmp1311_;
	gchar* _tmp1312_;
	IconCollectionIcon _tmp1313_ = {0};
	gchar* _tmp1314_;
	gchar* _tmp1315_;
	IconCollectionIcon _tmp1316_ = {0};
	gchar* _tmp1317_;
	gchar* _tmp1318_;
	IconCollectionIcon _tmp1319_ = {0};
	gchar* _tmp1320_;
	gchar* _tmp1321_;
	IconCollectionIcon _tmp1322_ = {0};
	gchar* _tmp1323_;
	gchar* _tmp1324_;
	IconCollectionIcon _tmp1325_ = {0};
	gchar* _tmp1326_;
	gchar* _tmp1327_;
	IconCollectionIcon _tmp1328_ = {0};
	gchar* _tmp1329_;
	gchar* _tmp1330_;
	IconCollectionIcon _tmp1331_ = {0};
	gchar* _tmp1332_;
	gchar* _tmp1333_;
	IconCollectionIcon _tmp1334_ = {0};
	gchar* _tmp1335_;
	gchar* _tmp1336_;
	IconCollectionIcon _tmp1337_ = {0};
	gchar* _tmp1338_;
	gchar* _tmp1339_;
	IconCollectionIcon _tmp1340_ = {0};
	gchar* _tmp1341_;
	gchar* _tmp1342_;
	IconCollectionIcon _tmp1343_ = {0};
	gchar* _tmp1344_;
	gchar* _tmp1345_;
	IconCollectionIcon _tmp1346_ = {0};
	gchar* _tmp1347_;
	gchar* _tmp1348_;
	IconCollectionIcon _tmp1349_ = {0};
	gchar* _tmp1350_;
	gchar* _tmp1351_;
	IconCollectionIcon _tmp1352_ = {0};
	gchar* _tmp1353_;
	gchar* _tmp1354_;
	IconCollectionIcon _tmp1355_ = {0};
	gchar* _tmp1356_;
	gchar* _tmp1357_;
	IconCollectionIcon _tmp1358_ = {0};
	gchar* _tmp1359_;
	gchar* _tmp1360_;
	IconCollectionIcon _tmp1361_ = {0};
	gchar* _tmp1362_;
	gchar* _tmp1363_;
	IconCollectionIcon _tmp1364_ = {0};
	gchar* _tmp1365_;
	gchar* _tmp1366_;
	IconCollectionIcon _tmp1367_ = {0};
	gchar* _tmp1368_;
	gchar* _tmp1369_;
	IconCollectionIcon _tmp1370_ = {0};
	gchar* _tmp1371_;
	gchar* _tmp1372_;
	IconCollectionIcon _tmp1373_ = {0};
	gchar* _tmp1374_;
	gchar* _tmp1375_;
	IconCollectionIcon _tmp1376_ = {0};
	gchar* _tmp1377_;
	gchar* _tmp1378_;
	IconCollectionIcon _tmp1379_ = {0};
	gchar* _tmp1380_;
	gchar* _tmp1381_;
	IconCollectionIcon _tmp1382_ = {0};
	gchar* _tmp1383_;
	gchar* _tmp1384_;
	IconCollectionIcon _tmp1385_ = {0};
	gchar* _tmp1386_;
	gchar* _tmp1387_;
	IconCollectionIcon _tmp1388_ = {0};
	IconCollectionIcon* _tmp1389_;
	IconCollectionIcon* _tmp1390_;
	gint _tmp1390__length1;
	IconCollectionIcon* result;
	_tmp0_ = g_strdup ("address-book-new");
	_tmp1_ = g_strdup (_ ("Create a new address book"));
	memset (&_tmp2_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp2_.name);
	_tmp2_.name = _tmp0_;
	_g_free0 (_tmp2_.description);
	_tmp2_.description = _tmp1_;
	_tmp2_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp3_ = g_strdup ("align-horizontal-center");
	_tmp4_ = g_strdup (_ ("Align objects to center along the X axis"));
	memset (&_tmp5_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp5_.name);
	_tmp5_.name = _tmp3_;
	_g_free0 (_tmp5_.description);
	_tmp5_.description = _tmp4_;
	_tmp5_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp6_ = g_strdup ("align-horizontal-left");
	_tmp7_ = g_strdup (_ ("Align objects left along the X axis"));
	memset (&_tmp8_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp8_.name);
	_tmp8_.name = _tmp6_;
	_g_free0 (_tmp8_.description);
	_tmp8_.description = _tmp7_;
	_tmp8_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp9_ = g_strdup ("align-horizontal-right");
	_tmp10_ = g_strdup (_ ("Align objects right along the X axis"));
	memset (&_tmp11_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp11_.name);
	_tmp11_.name = _tmp9_;
	_g_free0 (_tmp11_.description);
	_tmp11_.description = _tmp10_;
	_tmp11_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp12_ = g_strdup ("align-vertical-bottom");
	_tmp13_ = g_strdup (_ ("Align objects to bottom along the Y axis"));
	memset (&_tmp14_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp14_.name);
	_tmp14_.name = _tmp12_;
	_g_free0 (_tmp14_.description);
	_tmp14_.description = _tmp13_;
	_tmp14_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp15_ = g_strdup ("align-vertical-center");
	_tmp16_ = g_strdup (_ ("Align objects to center along the Y axis"));
	memset (&_tmp17_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp17_.name);
	_tmp17_.name = _tmp15_;
	_g_free0 (_tmp17_.description);
	_tmp17_.description = _tmp16_;
	_tmp17_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp18_ = g_strdup ("align-vertical-top");
	_tmp19_ = g_strdup (_ ("Align objects to top along the Y axis"));
	memset (&_tmp20_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp20_.name);
	_tmp20_.name = _tmp18_;
	_g_free0 (_tmp20_.description);
	_tmp20_.description = _tmp19_;
	_tmp20_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp21_ = g_strdup ("application-exit");
	_tmp22_ = g_strdup (_ ("Used for exiting an application"));
	memset (&_tmp23_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp23_.name);
	_tmp23_.name = _tmp21_;
	_g_free0 (_tmp23_.description);
	_tmp23_.description = _tmp22_;
	_tmp23_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp24_ = g_strdup ("appointment-new");
	_tmp25_ = g_strdup (_ ("Create a new appointment in a calendaring application"));
	memset (&_tmp26_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp26_.name);
	_tmp26_.name = _tmp24_;
	_g_free0 (_tmp26_.description);
	_tmp26_.description = _tmp25_;
	_tmp26_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp27_ = g_strdup ("bookmark-new");
	_tmp28_ = g_strdup (_ ("Create a new bookmark"));
	memset (&_tmp29_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp29_.name);
	_tmp29_.name = _tmp27_;
	_g_free0 (_tmp29_.description);
	_tmp29_.description = _tmp28_;
	_tmp29_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp30_ = g_strdup ("browser-download");
	_tmp31_ = g_strdup (_ ("Download a file from the Internet"));
	memset (&_tmp32_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp32_.name);
	_tmp32_.name = _tmp30_;
	_g_free0 (_tmp32_.description);
	_tmp32_.description = _tmp31_;
	_tmp32_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp33_ = g_strdup ("call-start");
	_tmp34_ = g_strdup (_ ("Initiate or accept a call"));
	memset (&_tmp35_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp35_.name);
	_tmp35_.name = _tmp33_;
	_g_free0 (_tmp35_.description);
	_tmp35_.description = _tmp34_;
	_tmp35_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp36_ = g_strdup ("call-stop");
	_tmp37_ = g_strdup (_ ("Stop the current call"));
	memset (&_tmp38_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp38_.name);
	_tmp38_.name = _tmp36_;
	_g_free0 (_tmp38_.description);
	_tmp38_.description = _tmp37_;
	_tmp38_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp39_ = g_strdup ("color-picker");
	_tmp40_ = g_strdup (_ ("Pick a color from elsewhere on screen"));
	memset (&_tmp41_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp41_.name);
	_tmp41_.name = _tmp39_;
	_g_free0 (_tmp41_.description);
	_tmp41_.description = _tmp40_;
	_tmp41_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp42_ = g_strdup ("contact-new");
	_tmp43_ = g_strdup (_ ("Create a new contact in an address book application"));
	memset (&_tmp44_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp44_.name);
	_tmp44_.name = _tmp42_;
	_g_free0 (_tmp44_.description);
	_tmp44_.description = _tmp43_;
	_tmp44_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp45_ = g_strdup ("distribute-horizontal-center");
	_tmp46_ = g_strdup (_ ("Distribute the center lines of objects horizontally"));
	memset (&_tmp47_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp47_.name);
	_tmp47_.name = _tmp45_;
	_g_free0 (_tmp47_.description);
	_tmp47_.description = _tmp46_;
	_tmp47_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp48_ = g_strdup ("distribute-horizontal-gaps");
	_tmp49_ = g_strdup (_ ("Make horizontal gaps between objects equal"));
	memset (&_tmp50_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp50_.name);
	_tmp50_.name = _tmp48_;
	_g_free0 (_tmp50_.description);
	_tmp50_.description = _tmp49_;
	_tmp50_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp51_ = g_strdup ("distribute-horizontal-left");
	_tmp52_ = g_strdup (_ ("Distribute left edges of objects horizontally"));
	memset (&_tmp53_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp53_.name);
	_tmp53_.name = _tmp51_;
	_g_free0 (_tmp53_.description);
	_tmp53_.description = _tmp52_;
	_tmp53_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp54_ = g_strdup ("distribute-horizontal-right");
	_tmp55_ = g_strdup (_ ("Distribute right edges of objects horizontally"));
	memset (&_tmp56_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp56_.name);
	_tmp56_.name = _tmp54_;
	_g_free0 (_tmp56_.description);
	_tmp56_.description = _tmp55_;
	_tmp56_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp57_ = g_strdup ("distribute-vertical-bottom");
	_tmp58_ = g_strdup (_ ("Distribute bottom edges of objects vertically"));
	memset (&_tmp59_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp59_.name);
	_tmp59_.name = _tmp57_;
	_g_free0 (_tmp59_.description);
	_tmp59_.description = _tmp58_;
	_tmp59_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp60_ = g_strdup ("distribute-vertical-center");
	_tmp61_ = g_strdup (_ ("Distribute center lines of objects vertically"));
	memset (&_tmp62_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp62_.name);
	_tmp62_.name = _tmp60_;
	_g_free0 (_tmp62_.description);
	_tmp62_.description = _tmp61_;
	_tmp62_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp63_ = g_strdup ("distribute-vertical-gaps");
	_tmp64_ = g_strdup (_ ("Make vertical gaps between objects equal"));
	memset (&_tmp65_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp65_.name);
	_tmp65_.name = _tmp63_;
	_g_free0 (_tmp65_.description);
	_tmp65_.description = _tmp64_;
	_tmp65_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp66_ = g_strdup ("distribute-vertical-top");
	_tmp67_ = g_strdup (_ ("Distribute top edges of objects vertically"));
	memset (&_tmp68_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp68_.name);
	_tmp68_.name = _tmp66_;
	_g_free0 (_tmp68_.description);
	_tmp68_.description = _tmp67_;
	_tmp68_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp69_ = g_strdup ("document-export");
	_tmp70_ = g_strdup (_ ("Export a document"));
	memset (&_tmp71_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp71_.name);
	_tmp71_.name = _tmp69_;
	_g_free0 (_tmp71_.description);
	_tmp71_.description = _tmp70_;
	_tmp71_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp72_ = g_strdup ("document-import");
	_tmp73_ = g_strdup (_ ("Import a document"));
	memset (&_tmp74_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp74_.name);
	_tmp74_.name = _tmp72_;
	_g_free0 (_tmp74_.description);
	_tmp74_.description = _tmp73_;
	_tmp74_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp75_ = g_strdup ("document-new");
	_tmp76_ = g_strdup (_ ("Create a new document"));
	memset (&_tmp77_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp77_.name);
	_tmp77_.name = _tmp75_;
	_g_free0 (_tmp77_.description);
	_tmp77_.description = _tmp76_;
	_tmp77_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp78_ = g_strdup ("document-open");
	_tmp79_ = g_strdup (_ ("Open a document"));
	memset (&_tmp80_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp80_.name);
	_tmp80_.name = _tmp78_;
	_g_free0 (_tmp80_.description);
	_tmp80_.description = _tmp79_;
	_tmp80_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp81_ = g_strdup ("document-open-recent");
	_tmp82_ = g_strdup (_ ("Open a document that was recently opened"));
	memset (&_tmp83_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp83_.name);
	_tmp83_.name = _tmp81_;
	_g_free0 (_tmp83_.description);
	_tmp83_.description = _tmp82_;
	_tmp83_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp84_ = g_strdup ("document-page-setup");
	_tmp85_ = g_strdup (_ ("The page setup action of a document editor"));
	memset (&_tmp86_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp86_.name);
	_tmp86_.name = _tmp84_;
	_g_free0 (_tmp86_.description);
	_tmp86_.description = _tmp85_;
	_tmp86_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp87_ = g_strdup ("document-print");
	_tmp88_ = g_strdup (_ ("Print"));
	memset (&_tmp89_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp89_.name);
	_tmp89_.name = _tmp87_;
	_g_free0 (_tmp89_.description);
	_tmp89_.description = _tmp88_;
	_tmp89_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp90_ = g_strdup ("document-print-preview");
	_tmp91_ = g_strdup (_ ("The print preview action of an application"));
	memset (&_tmp92_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp92_.name);
	_tmp92_.name = _tmp90_;
	_g_free0 (_tmp92_.description);
	_tmp92_.description = _tmp91_;
	_tmp92_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp93_ = g_strdup ("document-properties");
	_tmp94_ = g_strdup (_ ("View the properties of a document"));
	memset (&_tmp95_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp95_.name);
	_tmp95_.name = _tmp93_;
	_g_free0 (_tmp95_.description);
	_tmp95_.description = _tmp94_;
	_tmp95_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp96_ = g_strdup ("document-revert");
	_tmp97_ = g_strdup (_ ("Revert to a previous version of a document"));
	memset (&_tmp98_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp98_.name);
	_tmp98_.name = _tmp96_;
	_g_free0 (_tmp98_.description);
	_tmp98_.description = _tmp97_;
	_tmp98_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp99_ = g_strdup ("document-save");
	_tmp100_ = g_strdup (_ ("Save"));
	memset (&_tmp101_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp101_.name);
	_tmp101_.name = _tmp99_;
	_g_free0 (_tmp101_.description);
	_tmp101_.description = _tmp100_;
	_tmp101_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp102_ = g_strdup ("document-save-as");
	_tmp103_ = g_strdup (_ ("Save as"));
	memset (&_tmp104_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp104_.name);
	_tmp104_.name = _tmp102_;
	_g_free0 (_tmp104_.description);
	_tmp104_.description = _tmp103_;
	_tmp104_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp105_ = g_strdup ("document-send");
	_tmp106_ = g_strdup (_ ("Send"));
	memset (&_tmp107_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp107_.name);
	_tmp107_.name = _tmp105_;
	_g_free0 (_tmp107_.description);
	_tmp107_.description = _tmp106_;
	_tmp107_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp108_ = g_strdup ("edit");
	_tmp109_ = g_strdup (_ ("Edit"));
	memset (&_tmp110_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp110_.name);
	_tmp110_.name = _tmp108_;
	_g_free0 (_tmp110_.description);
	_tmp110_.description = _tmp109_;
	_tmp110_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp111_ = g_strdup ("edit-clear");
	_tmp112_ = g_strdup (_ ("Clear"));
	memset (&_tmp113_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp113_.name);
	_tmp113_.name = _tmp111_;
	_g_free0 (_tmp113_.description);
	_tmp113_.description = _tmp112_;
	_tmp113_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp114_ = g_strdup ("edit-copy");
	_tmp115_ = g_strdup (_ ("Copy"));
	memset (&_tmp116_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp116_.name);
	_tmp116_.name = _tmp114_;
	_g_free0 (_tmp116_.description);
	_tmp116_.description = _tmp115_;
	_tmp116_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp117_ = g_strdup ("edit-cut");
	_tmp118_ = g_strdup (_ ("Cut"));
	memset (&_tmp119_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp119_.name);
	_tmp119_.name = _tmp117_;
	_g_free0 (_tmp119_.description);
	_tmp119_.description = _tmp118_;
	_tmp119_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp120_ = g_strdup ("edit-delete");
	_tmp121_ = g_strdup (_ ("Delete"));
	memset (&_tmp122_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp122_.name);
	_tmp122_.name = _tmp120_;
	_g_free0 (_tmp122_.description);
	_tmp122_.description = _tmp121_;
	_tmp122_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp123_ = g_strdup ("edit-find");
	_tmp124_ = g_strdup (_ ("Find"));
	memset (&_tmp125_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp125_.name);
	_tmp125_.name = _tmp123_;
	_g_free0 (_tmp125_.description);
	_tmp125_.description = _tmp124_;
	_tmp125_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp126_ = g_strdup ("edit-find-replace");
	_tmp127_ = g_strdup (_ ("Find & Replace"));
	memset (&_tmp128_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp128_.name);
	_tmp128_.name = _tmp126_;
	_g_free0 (_tmp128_.description);
	_tmp128_.description = _tmp127_;
	_tmp128_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp129_ = g_strdup ("edit-flag");
	_tmp130_ = g_strdup (_ ("Flag an item, such as a spam email"));
	memset (&_tmp131_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp131_.name);
	_tmp131_.name = _tmp129_;
	_g_free0 (_tmp131_.description);
	_tmp131_.description = _tmp130_;
	_tmp131_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp132_ = g_strdup ("edit-paste");
	_tmp133_ = g_strdup (_ ("Paste"));
	memset (&_tmp134_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp134_.name);
	_tmp134_.name = _tmp132_;
	_g_free0 (_tmp134_.description);
	_tmp134_.description = _tmp133_;
	_tmp134_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp135_ = g_strdup ("edit-redo");
	_tmp136_ = g_strdup (_ ("Redo"));
	memset (&_tmp137_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp137_.name);
	_tmp137_.name = _tmp135_;
	_g_free0 (_tmp137_.description);
	_tmp137_.description = _tmp136_;
	_tmp137_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp138_ = g_strdup ("edit-select-all");
	_tmp139_ = g_strdup (_ ("Select all"));
	memset (&_tmp140_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp140_.name);
	_tmp140_.name = _tmp138_;
	_g_free0 (_tmp140_.description);
	_tmp140_.description = _tmp139_;
	_tmp140_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp141_ = g_strdup ("edit-undo");
	_tmp142_ = g_strdup (_ ("Undo"));
	memset (&_tmp143_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp143_.name);
	_tmp143_.name = _tmp141_;
	_g_free0 (_tmp143_.description);
	_tmp143_.description = _tmp142_;
	_tmp143_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp144_ = g_strdup ("event-new");
	_tmp145_ = g_strdup (_ ("Create a new calendar event"));
	memset (&_tmp146_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp146_.name);
	_tmp146_.name = _tmp144_;
	_g_free0 (_tmp146_.description);
	_tmp146_.description = _tmp145_;
	_tmp146_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp147_ = g_strdup ("folder-copy");
	_tmp148_ = g_strdup (_ ("Copy a folder"));
	memset (&_tmp149_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp149_.name);
	_tmp149_.name = _tmp147_;
	_g_free0 (_tmp149_.description);
	_tmp149_.description = _tmp148_;
	_tmp149_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp150_ = g_strdup ("folder-move");
	_tmp151_ = g_strdup (_ ("Move a folder"));
	memset (&_tmp152_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp152_.name);
	_tmp152_.name = _tmp150_;
	_g_free0 (_tmp152_.description);
	_tmp152_.description = _tmp151_;
	_tmp152_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp153_ = g_strdup ("folder-new");
	_tmp154_ = g_strdup (_ ("Create a new folder"));
	memset (&_tmp155_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp155_.name);
	_tmp155_.name = _tmp153_;
	_g_free0 (_tmp155_.description);
	_tmp155_.description = _tmp154_;
	_tmp155_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp156_ = g_strdup ("format-indent-less");
	_tmp157_ = g_strdup (_ ("Decrease indent"));
	memset (&_tmp158_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp158_.name);
	_tmp158_.name = _tmp156_;
	_g_free0 (_tmp158_.description);
	_tmp158_.description = _tmp157_;
	_tmp158_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp159_ = g_strdup ("format-indent-more");
	_tmp160_ = g_strdup (_ ("Increase indent"));
	memset (&_tmp161_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp161_.name);
	_tmp161_.name = _tmp159_;
	_g_free0 (_tmp161_.description);
	_tmp161_.description = _tmp160_;
	_tmp161_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp162_ = g_strdup ("format-justify-center");
	_tmp163_ = g_strdup (_ ("Center justify text"));
	memset (&_tmp164_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp164_.name);
	_tmp164_.name = _tmp162_;
	_g_free0 (_tmp164_.description);
	_tmp164_.description = _tmp163_;
	_tmp164_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp165_ = g_strdup ("format-justify-fill");
	_tmp166_ = g_strdup (_ ("Fill justify text"));
	memset (&_tmp167_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp167_.name);
	_tmp167_.name = _tmp165_;
	_g_free0 (_tmp167_.description);
	_tmp167_.description = _tmp166_;
	_tmp167_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp168_ = g_strdup ("format-justify-left");
	_tmp169_ = g_strdup (_ ("Left justify text"));
	memset (&_tmp170_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp170_.name);
	_tmp170_.name = _tmp168_;
	_g_free0 (_tmp170_.description);
	_tmp170_.description = _tmp169_;
	_tmp170_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp171_ = g_strdup ("format-justify-right");
	_tmp172_ = g_strdup (_ ("Right justify text"));
	memset (&_tmp173_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp173_.name);
	_tmp173_.name = _tmp171_;
	_g_free0 (_tmp173_.description);
	_tmp173_.description = _tmp172_;
	_tmp173_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp174_ = g_strdup ("format-text-direction-ltr");
	_tmp175_ = g_strdup (_ ("Format text as left-to-right"));
	memset (&_tmp176_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp176_.name);
	_tmp176_.name = _tmp174_;
	_g_free0 (_tmp176_.description);
	_tmp176_.description = _tmp175_;
	_tmp176_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp177_ = g_strdup ("format-text-direction-rtl");
	_tmp178_ = g_strdup (_ ("Format text as right-to-left"));
	memset (&_tmp179_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp179_.name);
	_tmp179_.name = _tmp177_;
	_g_free0 (_tmp179_.description);
	_tmp179_.description = _tmp178_;
	_tmp179_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp180_ = g_strdup ("format-text-bold");
	_tmp181_ = g_strdup (_ ("Format text as bold"));
	memset (&_tmp182_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp182_.name);
	_tmp182_.name = _tmp180_;
	_g_free0 (_tmp182_.description);
	_tmp182_.description = _tmp181_;
	_tmp182_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp183_ = g_strdup ("format-text-highlight");
	_tmp184_ = g_strdup (_ ("Format text as highlighted"));
	memset (&_tmp185_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp185_.name);
	_tmp185_.name = _tmp183_;
	_g_free0 (_tmp185_.description);
	_tmp185_.description = _tmp184_;
	_tmp185_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp186_ = g_strdup ("format-text-italic");
	_tmp187_ = g_strdup (_ ("Format text as italic"));
	memset (&_tmp188_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp188_.name);
	_tmp188_.name = _tmp186_;
	_g_free0 (_tmp188_.description);
	_tmp188_.description = _tmp187_;
	_tmp188_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp189_ = g_strdup ("format-text-underline");
	_tmp190_ = g_strdup (_ ("Format text as underlined"));
	memset (&_tmp191_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp191_.name);
	_tmp191_.name = _tmp189_;
	_g_free0 (_tmp191_.description);
	_tmp191_.description = _tmp190_;
	_tmp191_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp192_ = g_strdup ("format-text-strikethrough");
	_tmp193_ = g_strdup (_ ("Format text as being struck through"));
	memset (&_tmp194_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp194_.name);
	_tmp194_.name = _tmp192_;
	_g_free0 (_tmp194_.description);
	_tmp194_.description = _tmp193_;
	_tmp194_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp195_ = g_strdup ("go-bottom");
	_tmp196_ = g_strdup (_ ("Go to the bottom, such as in a list"));
	memset (&_tmp197_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp197_.name);
	_tmp197_.name = _tmp195_;
	_g_free0 (_tmp197_.description);
	_tmp197_.description = _tmp196_;
	_tmp197_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp198_ = g_strdup ("go-down");
	_tmp199_ = g_strdup (_ ("Go down, such as in a list"));
	memset (&_tmp200_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp200_.name);
	_tmp200_.name = _tmp198_;
	_g_free0 (_tmp200_.description);
	_tmp200_.description = _tmp199_;
	_tmp200_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp201_ = g_strdup ("go-first");
	_tmp202_ = g_strdup (_ ("Go to the first item, such as in a list"));
	memset (&_tmp203_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp203_.name);
	_tmp203_.name = _tmp201_;
	_g_free0 (_tmp203_.description);
	_tmp203_.description = _tmp202_;
	_tmp203_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp204_ = g_strdup ("go-home");
	_tmp205_ = g_strdup (_ ("Go to the home location"));
	memset (&_tmp206_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp206_.name);
	_tmp206_.name = _tmp204_;
	_g_free0 (_tmp206_.description);
	_tmp206_.description = _tmp205_;
	_tmp206_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp207_ = g_strdup ("go-jump");
	_tmp208_ = g_strdup (_ ("Jump to a location"));
	memset (&_tmp209_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp209_.name);
	_tmp209_.name = _tmp207_;
	_g_free0 (_tmp209_.description);
	_tmp209_.description = _tmp208_;
	_tmp209_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp210_ = g_strdup ("go-last");
	_tmp211_ = g_strdup (_ ("Go to the last item, such as in a list"));
	memset (&_tmp212_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp212_.name);
	_tmp212_.name = _tmp210_;
	_g_free0 (_tmp212_.description);
	_tmp212_.description = _tmp211_;
	_tmp212_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp213_ = g_strdup ("go-next");
	_tmp214_ = g_strdup (_ ("Go forward to the next item, such as in a list or navigation"));
	memset (&_tmp215_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp215_.name);
	_tmp215_.name = _tmp213_;
	_g_free0 (_tmp215_.description);
	_tmp215_.description = _tmp214_;
	_tmp215_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp216_ = g_strdup ("go-previous");
	_tmp217_ = g_strdup (_ ("Go back to the previous item, such as in a list or navigation"));
	memset (&_tmp218_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp218_.name);
	_tmp218_.name = _tmp216_;
	_g_free0 (_tmp218_.description);
	_tmp218_.description = _tmp217_;
	_tmp218_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp219_ = g_strdup ("go-top");
	_tmp220_ = g_strdup (_ ("Go to the top, such as in a list"));
	memset (&_tmp221_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp221_.name);
	_tmp221_.name = _tmp219_;
	_g_free0 (_tmp221_.description);
	_tmp221_.description = _tmp220_;
	_tmp221_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp222_ = g_strdup ("go-up");
	_tmp223_ = g_strdup (_ ("Go up, such as in a list"));
	memset (&_tmp224_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp224_.name);
	_tmp224_.name = _tmp222_;
	_g_free0 (_tmp224_.description);
	_tmp224_.description = _tmp223_;
	_tmp224_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp225_ = g_strdup ("help-about");
	_tmp226_ = g_strdup (_ ("Information about an app"));
	memset (&_tmp227_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp227_.name);
	_tmp227_.name = _tmp225_;
	_g_free0 (_tmp227_.description);
	_tmp227_.description = _tmp226_;
	_tmp227_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp228_ = g_strdup ("help-contents");
	_tmp229_ = g_strdup (_ ("Get help"));
	memset (&_tmp230_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp230_.name);
	_tmp230_.name = _tmp228_;
	_g_free0 (_tmp230_.description);
	_tmp230_.description = _tmp229_;
	_tmp230_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp231_ = g_strdup ("help-faq");
	_tmp232_ = g_strdup (_ ("Frequently asked questions"));
	memset (&_tmp233_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp233_.name);
	_tmp233_.name = _tmp231_;
	_g_free0 (_tmp233_.description);
	_tmp233_.description = _tmp232_;
	_tmp233_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp234_ = g_strdup ("image-adjust");
	_tmp235_ = g_strdup (_ ("Make adjustments to an image"));
	memset (&_tmp236_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp236_.name);
	_tmp236_.name = _tmp234_;
	_g_free0 (_tmp236_.description);
	_tmp236_.description = _tmp235_;
	_tmp236_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp237_ = g_strdup ("image-auto-adjust");
	_tmp238_ = g_strdup (_ ("Automatically adjust an image"));
	memset (&_tmp239_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp239_.name);
	_tmp239_.name = _tmp237_;
	_g_free0 (_tmp239_.description);
	_tmp239_.description = _tmp238_;
	_tmp239_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp240_ = g_strdup ("image-crop");
	_tmp241_ = g_strdup (_ ("Crop an image"));
	memset (&_tmp242_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp242_.name);
	_tmp242_.name = _tmp240_;
	_g_free0 (_tmp242_.description);
	_tmp242_.description = _tmp241_;
	_tmp242_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp243_ = g_strdup ("image-red-eye");
	_tmp244_ = g_strdup (_ ("Remove red eye from an image"));
	memset (&_tmp245_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp245_.name);
	_tmp245_.name = _tmp243_;
	_g_free0 (_tmp245_.description);
	_tmp245_.description = _tmp244_;
	_tmp245_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp246_ = g_strdup ("insert-image");
	_tmp247_ = g_strdup (_ ("Insert an image"));
	memset (&_tmp248_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp248_.name);
	_tmp248_.name = _tmp246_;
	_g_free0 (_tmp248_.description);
	_tmp248_.description = _tmp247_;
	_tmp248_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp249_ = g_strdup ("insert-link");
	_tmp250_ = g_strdup (_ ("Insert a link"));
	memset (&_tmp251_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp251_.name);
	_tmp251_.name = _tmp249_;
	_g_free0 (_tmp251_.description);
	_tmp251_.description = _tmp250_;
	_tmp251_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp252_ = g_strdup ("insert-object");
	_tmp253_ = g_strdup (_ ("Insert an object"));
	memset (&_tmp254_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp254_.name);
	_tmp254_.name = _tmp252_;
	_g_free0 (_tmp254_.description);
	_tmp254_.description = _tmp253_;
	_tmp254_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp255_ = g_strdup ("insert-text");
	_tmp256_ = g_strdup (_ ("Insert text"));
	memset (&_tmp257_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp257_.name);
	_tmp257_.name = _tmp255_;
	_g_free0 (_tmp257_.description);
	_tmp257_.description = _tmp256_;
	_tmp257_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp258_ = g_strdup ("list-add");
	_tmp259_ = g_strdup (_ ("Add to a list"));
	memset (&_tmp260_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp260_.name);
	_tmp260_.name = _tmp258_;
	_g_free0 (_tmp260_.description);
	_tmp260_.description = _tmp259_;
	_tmp260_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp261_ = g_strdup ("list-remove");
	_tmp262_ = g_strdup (_ ("Remove from a list"));
	memset (&_tmp263_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp263_.name);
	_tmp263_.name = _tmp261_;
	_g_free0 (_tmp263_.description);
	_tmp263_.description = _tmp262_;
	_tmp263_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp264_ = g_strdup ("mail-forward");
	_tmp265_ = g_strdup (_ ("Forward an email"));
	memset (&_tmp266_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp266_.name);
	_tmp266_.name = _tmp264_;
	_g_free0 (_tmp266_.description);
	_tmp266_.description = _tmp265_;
	_tmp266_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp267_ = g_strdup ("mail-mark-important");
	_tmp268_ = g_strdup (_ ("Mark an email as important"));
	memset (&_tmp269_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp269_.name);
	_tmp269_.name = _tmp267_;
	_g_free0 (_tmp269_.description);
	_tmp269_.description = _tmp268_;
	_tmp269_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp270_ = g_strdup ("mail-mark-junk");
	_tmp271_ = g_strdup (_ ("Mark an email as junk or spam"));
	memset (&_tmp272_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp272_.name);
	_tmp272_.name = _tmp270_;
	_g_free0 (_tmp272_.description);
	_tmp272_.description = _tmp271_;
	_tmp272_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp273_ = g_strdup ("mail-mark-notjunk");
	_tmp274_ = g_strdup (_ ("Mark an email as not junk or spam"));
	memset (&_tmp275_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp275_.name);
	_tmp275_.name = _tmp273_;
	_g_free0 (_tmp275_.description);
	_tmp275_.description = _tmp274_;
	_tmp275_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp276_ = g_strdup ("mail-mark-read");
	_tmp277_ = g_strdup (_ ("Mark an email as read"));
	memset (&_tmp278_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp278_.name);
	_tmp278_.name = _tmp276_;
	_g_free0 (_tmp278_.description);
	_tmp278_.description = _tmp277_;
	_tmp278_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp279_ = g_strdup ("mail-mark-unread");
	_tmp280_ = g_strdup (_ ("Mark an email as unread"));
	memset (&_tmp281_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp281_.name);
	_tmp281_.name = _tmp279_;
	_g_free0 (_tmp281_.description);
	_tmp281_.description = _tmp280_;
	_tmp281_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp282_ = g_strdup ("mail-message-new");
	_tmp283_ = g_strdup (_ ("Compose a new email"));
	memset (&_tmp284_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp284_.name);
	_tmp284_.name = _tmp282_;
	_g_free0 (_tmp284_.description);
	_tmp284_.description = _tmp283_;
	_tmp284_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp285_ = g_strdup ("mail-reply-all");
	_tmp286_ = g_strdup (_ ("Reply to all participants of an email"));
	memset (&_tmp287_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp287_.name);
	_tmp287_.name = _tmp285_;
	_g_free0 (_tmp287_.description);
	_tmp287_.description = _tmp286_;
	_tmp287_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp288_ = g_strdup ("mail-reply-sender");
	_tmp289_ = g_strdup (_ ("Reply to the sender of an email"));
	memset (&_tmp290_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp290_.name);
	_tmp290_.name = _tmp288_;
	_g_free0 (_tmp290_.description);
	_tmp290_.description = _tmp289_;
	_tmp290_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp291_ = g_strdup ("mail-send");
	_tmp292_ = g_strdup (_ ("Send an email"));
	memset (&_tmp293_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp293_.name);
	_tmp293_.name = _tmp291_;
	_g_free0 (_tmp293_.description);
	_tmp293_.description = _tmp292_;
	_tmp293_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp294_ = g_strdup ("mail-send-receive");
	_tmp295_ = g_strdup (_ ("Send and receive all email"));
	memset (&_tmp296_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp296_.name);
	_tmp296_.name = _tmp294_;
	_g_free0 (_tmp296_.description);
	_tmp296_.description = _tmp295_;
	_tmp296_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp297_ = g_strdup ("media-eject");
	_tmp298_ = g_strdup (_ ("Eject removable media"));
	memset (&_tmp299_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp299_.name);
	_tmp299_.name = _tmp297_;
	_g_free0 (_tmp299_.description);
	_tmp299_.description = _tmp298_;
	_tmp299_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp300_ = g_strdup ("media-playback-pause");
	_tmp301_ = g_strdup (_ ("Pause media playback"));
	memset (&_tmp302_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp302_.name);
	_tmp302_.name = _tmp300_;
	_g_free0 (_tmp302_.description);
	_tmp302_.description = _tmp301_;
	_tmp302_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp303_ = g_strdup ("media-playback-start");
	_tmp304_ = g_strdup (_ ("Start playing media"));
	memset (&_tmp305_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp305_.name);
	_tmp305_.name = _tmp303_;
	_g_free0 (_tmp305_.description);
	_tmp305_.description = _tmp304_;
	_tmp305_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp306_ = g_strdup ("media-playback-stop");
	_tmp307_ = g_strdup (_ ("Stop playing media"));
	memset (&_tmp308_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp308_.name);
	_tmp308_.name = _tmp306_;
	_g_free0 (_tmp308_.description);
	_tmp308_.description = _tmp307_;
	_tmp308_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp309_ = g_strdup ("media-record");
	_tmp310_ = g_strdup (_ ("Start recording"));
	memset (&_tmp311_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp311_.name);
	_tmp311_.name = _tmp309_;
	_g_free0 (_tmp311_.description);
	_tmp311_.description = _tmp310_;
	_tmp311_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp312_ = g_strdup ("media-seek-backward");
	_tmp313_ = g_strdup (_ ("Seek backwards or rewind"));
	memset (&_tmp314_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp314_.name);
	_tmp314_.name = _tmp312_;
	_g_free0 (_tmp314_.description);
	_tmp314_.description = _tmp313_;
	_tmp314_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp315_ = g_strdup ("media-seek-forward");
	_tmp316_ = g_strdup (_ ("Seek forwards, or fastforward"));
	memset (&_tmp317_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp317_.name);
	_tmp317_.name = _tmp315_;
	_g_free0 (_tmp317_.description);
	_tmp317_.description = _tmp316_;
	_tmp317_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp318_ = g_strdup ("media-skip-backward");
	_tmp319_ = g_strdup (_ ("Skip backwards, such as to the previous track"));
	memset (&_tmp320_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp320_.name);
	_tmp320_.name = _tmp318_;
	_g_free0 (_tmp320_.description);
	_tmp320_.description = _tmp319_;
	_tmp320_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp321_ = g_strdup ("media-skip-forward");
	_tmp322_ = g_strdup (_ ("Skip forwards, such as to the next track"));
	memset (&_tmp323_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp323_.name);
	_tmp323_.name = _tmp321_;
	_g_free0 (_tmp323_.description);
	_tmp323_.description = _tmp322_;
	_tmp323_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp324_ = g_strdup ("object-flip-horizontal");
	_tmp325_ = g_strdup (_ ("Flip an object horizontally"));
	memset (&_tmp326_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp326_.name);
	_tmp326_.name = _tmp324_;
	_g_free0 (_tmp326_.description);
	_tmp326_.description = _tmp325_;
	_tmp326_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp327_ = g_strdup ("object-flip-vertical");
	_tmp328_ = g_strdup (_ ("Flip an object vertically"));
	memset (&_tmp329_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp329_.name);
	_tmp329_.name = _tmp327_;
	_g_free0 (_tmp329_.description);
	_tmp329_.description = _tmp328_;
	_tmp329_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp330_ = g_strdup ("object-rotate-left");
	_tmp331_ = g_strdup (_ ("Rotate an object to the left or counter-clockwise"));
	memset (&_tmp332_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp332_.name);
	_tmp332_.name = _tmp330_;
	_g_free0 (_tmp332_.description);
	_tmp332_.description = _tmp331_;
	_tmp332_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp333_ = g_strdup ("object-rotate-right");
	_tmp334_ = g_strdup (_ ("Rotate an object to the right or clockwise"));
	memset (&_tmp335_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp335_.name);
	_tmp335_.name = _tmp333_;
	_g_free0 (_tmp335_.description);
	_tmp335_.description = _tmp334_;
	_tmp335_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp336_ = g_strdup ("office-database-new");
	_tmp337_ = g_strdup (_ ("Create a new database"));
	memset (&_tmp338_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp338_.name);
	_tmp338_.name = _tmp336_;
	_g_free0 (_tmp338_.description);
	_tmp338_.description = _tmp337_;
	_tmp338_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp339_ = g_strdup ("process-stop");
	_tmp340_ = g_strdup (_ ("Stop an action that may take a while to process, such as web page load" \
"ing in a browser"));
	memset (&_tmp341_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp341_.name);
	_tmp341_.name = _tmp339_;
	_g_free0 (_tmp341_.description);
	_tmp341_.description = _tmp340_;
	_tmp341_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp342_ = g_strdup ("system-lock-screen");
	_tmp343_ = g_strdup (_ ("Lock the screen or the user's session"));
	memset (&_tmp344_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp344_.name);
	_tmp344_.name = _tmp342_;
	_g_free0 (_tmp344_.description);
	_tmp344_.description = _tmp343_;
	_tmp344_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp345_ = g_strdup ("system-log-out");
	_tmp346_ = g_strdup (_ ("Log out of the user's session"));
	memset (&_tmp347_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp347_.name);
	_tmp347_.name = _tmp345_;
	_g_free0 (_tmp347_.description);
	_tmp347_.description = _tmp346_;
	_tmp347_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp348_ = g_strdup ("system-run");
	_tmp349_ = g_strdup (_ ("Run a system app or command"));
	memset (&_tmp350_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp350_.name);
	_tmp350_.name = _tmp348_;
	_g_free0 (_tmp350_.description);
	_tmp350_.description = _tmp349_;
	_tmp350_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp351_ = g_strdup ("system-search");
	_tmp352_ = g_strdup (_ ("Search the system"));
	memset (&_tmp353_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp353_.name);
	_tmp353_.name = _tmp351_;
	_g_free0 (_tmp353_.description);
	_tmp353_.description = _tmp352_;
	_tmp353_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp354_ = g_strdup ("system-reboot");
	_tmp355_ = g_strdup (_ ("Restart the device"));
	memset (&_tmp356_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp356_.name);
	_tmp356_.name = _tmp354_;
	_g_free0 (_tmp356_.description);
	_tmp356_.description = _tmp355_;
	_tmp356_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp357_ = g_strdup ("system-shutdown");
	_tmp358_ = g_strdup (_ ("Shut the device down"));
	memset (&_tmp359_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp359_.name);
	_tmp359_.name = _tmp357_;
	_g_free0 (_tmp359_.description);
	_tmp359_.description = _tmp358_;
	_tmp359_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp360_ = g_strdup ("tag-new");
	_tmp361_ = g_strdup (_ ("Create a new tag"));
	memset (&_tmp362_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp362_.name);
	_tmp362_.name = _tmp360_;
	_g_free0 (_tmp362_.description);
	_tmp362_.description = _tmp361_;
	_tmp362_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp363_ = g_strdup ("tools-check-spelling");
	_tmp364_ = g_strdup (_ ("Check spelling"));
	memset (&_tmp365_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp365_.name);
	_tmp365_.name = _tmp363_;
	_g_free0 (_tmp365_.description);
	_tmp365_.description = _tmp364_;
	_tmp365_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp366_ = g_strdup ("tools-timer");
	_tmp367_ = g_strdup (_ ("Set or adjust a timer"));
	memset (&_tmp368_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp368_.name);
	_tmp368_.name = _tmp366_;
	_g_free0 (_tmp368_.description);
	_tmp368_.description = _tmp367_;
	_tmp368_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp369_ = g_strdup ("view-column");
	_tmp370_ = g_strdup (_ ("Display the current view as columns"));
	memset (&_tmp371_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp371_.name);
	_tmp371_.name = _tmp369_;
	_g_free0 (_tmp371_.description);
	_tmp371_.description = _tmp370_;
	_tmp371_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp372_ = g_strdup ("view-continuous");
	_tmp373_ = g_strdup (_ ("display the current view in a continously scrolling list"));
	memset (&_tmp374_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp374_.name);
	_tmp374_.name = _tmp372_;
	_g_free0 (_tmp374_.description);
	_tmp374_.description = _tmp373_;
	_tmp374_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp375_ = g_strdup ("view-dual");
	_tmp376_ = g_strdup (_ ("display the current view as a split, dual view"));
	memset (&_tmp377_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp377_.name);
	_tmp377_.name = _tmp375_;
	_g_free0 (_tmp377_.description);
	_tmp377_.description = _tmp376_;
	_tmp377_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp378_ = g_strdup ("view-fullscreen");
	_tmp379_ = g_strdup (_ ("View fullscreen"));
	memset (&_tmp380_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp380_.name);
	_tmp380_.name = _tmp378_;
	_g_free0 (_tmp380_.description);
	_tmp380_.description = _tmp379_;
	_tmp380_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp381_ = g_strdup ("view-grid");
	_tmp382_ = g_strdup (_ ("Display the current view as a grid of images or icons"));
	memset (&_tmp383_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp383_.name);
	_tmp383_.name = _tmp381_;
	_g_free0 (_tmp383_.description);
	_tmp383_.description = _tmp382_;
	_tmp383_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp384_ = g_strdup ("view-refresh");
	_tmp385_ = g_strdup (_ ("Refresh or reload the current view"));
	memset (&_tmp386_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp386_.name);
	_tmp386_.name = _tmp384_;
	_g_free0 (_tmp386_.description);
	_tmp386_.description = _tmp385_;
	_tmp386_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp387_ = g_strdup ("view-restore");
	_tmp388_ = g_strdup (_ ("Leave fullscreen and return to a normal window"));
	memset (&_tmp389_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp389_.name);
	_tmp389_.name = _tmp387_;
	_g_free0 (_tmp389_.description);
	_tmp389_.description = _tmp388_;
	_tmp389_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp390_ = g_strdup ("view-more");
	_tmp391_ = g_strdup (_ ("View more information about the given context in a popover or menu"));
	memset (&_tmp392_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp392_.name);
	_tmp392_.name = _tmp390_;
	_g_free0 (_tmp392_.description);
	_tmp392_.description = _tmp391_;
	_tmp392_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp393_ = g_strdup ("view-more-horizontal");
	_tmp394_ = g_strdup (_ ("View more information about the given context in a new view or window"));
	memset (&_tmp395_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp395_.name);
	_tmp395_.name = _tmp393_;
	_g_free0 (_tmp395_.description);
	_tmp395_.description = _tmp394_;
	_tmp395_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp396_ = g_strdup ("view-paged");
	_tmp397_ = g_strdup (_ ("Display the current view as a collection of pages"));
	memset (&_tmp398_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp398_.name);
	_tmp398_.name = _tmp396_;
	_g_free0 (_tmp398_.description);
	_tmp398_.description = _tmp397_;
	_tmp398_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp399_ = g_strdup ("view-pin");
	_tmp400_ = g_strdup (_ ("Pin the current view so that it does not automatically hide"));
	memset (&_tmp401_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp401_.name);
	_tmp401_.name = _tmp399_;
	_g_free0 (_tmp401_.description);
	_tmp401_.description = _tmp400_;
	_tmp401_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp402_ = g_strdup ("view-sort-ascending");
	_tmp403_ = g_strdup (_ ("Sort items in an ascending order, such as in a list"));
	memset (&_tmp404_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp404_.name);
	_tmp404_.name = _tmp402_;
	_g_free0 (_tmp404_.description);
	_tmp404_.description = _tmp403_;
	_tmp404_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp405_ = g_strdup ("view-sort-descending");
	_tmp406_ = g_strdup (_ ("Sort items in a descending order, such as in a list"));
	memset (&_tmp407_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp407_.name);
	_tmp407_.name = _tmp405_;
	_g_free0 (_tmp407_.description);
	_tmp407_.description = _tmp406_;
	_tmp407_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp408_ = g_strdup ("window-close");
	_tmp409_ = g_strdup (_ ("Close the window"));
	memset (&_tmp410_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp410_.name);
	_tmp410_.name = _tmp408_;
	_g_free0 (_tmp410_.description);
	_tmp410_.description = _tmp409_;
	_tmp410_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp411_ = g_strdup ("window-new");
	_tmp412_ = g_strdup (_ ("Create a new window"));
	memset (&_tmp413_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp413_.name);
	_tmp413_.name = _tmp411_;
	_g_free0 (_tmp413_.description);
	_tmp413_.description = _tmp412_;
	_tmp413_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp414_ = g_strdup ("zoom-fit-best");
	_tmp415_ = g_strdup (_ ("Zoom to the best fit"));
	memset (&_tmp416_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp416_.name);
	_tmp416_.name = _tmp414_;
	_g_free0 (_tmp416_.description);
	_tmp416_.description = _tmp415_;
	_tmp416_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp417_ = g_strdup ("zoom-in");
	_tmp418_ = g_strdup (_ ("Zoom in"));
	memset (&_tmp419_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp419_.name);
	_tmp419_.name = _tmp417_;
	_g_free0 (_tmp419_.description);
	_tmp419_.description = _tmp418_;
	_tmp419_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp420_ = g_strdup ("zoom-original");
	_tmp421_ = g_strdup (_ ("Zoom to the original size"));
	memset (&_tmp422_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp422_.name);
	_tmp422_.name = _tmp420_;
	_g_free0 (_tmp422_.description);
	_tmp422_.description = _tmp421_;
	_tmp422_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp423_ = g_strdup ("zoom-out");
	_tmp424_ = g_strdup (_ ("Zoom out"));
	memset (&_tmp425_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp425_.name);
	_tmp425_.name = _tmp423_;
	_g_free0 (_tmp425_.description);
	_tmp425_.description = _tmp424_;
	_tmp425_.category = ICON_COLLECTION_CATEGORY_ACTIONS;
	_tmp426_ = g_strdup ("accessories-calculator");
	_tmp427_ = g_strdup (_ ("Calculator"));
	memset (&_tmp428_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp428_.name);
	_tmp428_.name = _tmp426_;
	_g_free0 (_tmp428_.description);
	_tmp428_.description = _tmp427_;
	_tmp428_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp429_ = g_strdup ("accessories-character-map");
	_tmp430_ = g_strdup (_ ("International and extended text character map"));
	memset (&_tmp431_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp431_.name);
	_tmp431_.name = _tmp429_;
	_g_free0 (_tmp431_.description);
	_tmp431_.description = _tmp430_;
	_tmp431_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp432_ = g_strdup ("accessories-dictionary");
	_tmp433_ = g_strdup (_ ("Dictionary"));
	memset (&_tmp434_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp434_.name);
	_tmp434_.name = _tmp432_;
	_g_free0 (_tmp434_.description);
	_tmp434_.description = _tmp433_;
	_tmp434_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp435_ = g_strdup ("accessories-screenshot-tool");
	_tmp436_ = g_strdup (_ ("Screenshot application"));
	memset (&_tmp437_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp437_.name);
	_tmp437_.name = _tmp435_;
	_g_free0 (_tmp437_.description);
	_tmp437_.description = _tmp436_;
	_tmp437_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp438_ = g_strdup ("accessories-text-editor");
	_tmp439_ = g_strdup (_ ("Text editor"));
	memset (&_tmp440_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp440_.name);
	_tmp440_.name = _tmp438_;
	_g_free0 (_tmp440_.description);
	_tmp440_.description = _tmp439_;
	_tmp440_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp441_ = g_strdup ("application-default-icon");
	_tmp442_ = g_strdup (_ ("Default or unprovided app icon"));
	memset (&_tmp443_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp443_.name);
	_tmp443_.name = _tmp441_;
	_g_free0 (_tmp443_.description);
	_tmp443_.description = _tmp442_;
	_tmp443_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp444_ = g_strdup ("system-file-manager");
	_tmp445_ = g_strdup (_ ("Files"));
	memset (&_tmp446_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp446_.name);
	_tmp446_.name = _tmp444_;
	_g_free0 (_tmp446_.description);
	_tmp446_.description = _tmp445_;
	_tmp446_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp447_ = g_strdup ("system-software-install");
	_tmp448_ = g_strdup (_ ("AppCenter or software installer"));
	memset (&_tmp449_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp449_.name);
	_tmp449_.name = _tmp447_;
	_g_free0 (_tmp449_.description);
	_tmp449_.description = _tmp448_;
	_tmp449_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp450_ = g_strdup ("system-software-update");
	_tmp451_ = g_strdup (_ ("Software updater"));
	memset (&_tmp452_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp452_.name);
	_tmp452_.name = _tmp450_;
	_g_free0 (_tmp452_.description);
	_tmp452_.description = _tmp451_;
	_tmp452_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp453_ = g_strdup ("utilities-system-monitor");
	_tmp454_ = g_strdup (_ ("System resource monitor"));
	memset (&_tmp455_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp455_.name);
	_tmp455_.name = _tmp453_;
	_g_free0 (_tmp455_.description);
	_tmp455_.description = _tmp454_;
	_tmp455_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp456_ = g_strdup ("utilities-terminal");
	_tmp457_ = g_strdup (_ ("Terminal"));
	memset (&_tmp458_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp458_.name);
	_tmp458_.name = _tmp456_;
	_g_free0 (_tmp458_.description);
	_tmp458_.description = _tmp457_;
	_tmp458_.category = ICON_COLLECTION_CATEGORY_APPS;
	_tmp459_ = g_strdup ("applications-accessories");
	_tmp460_ = g_strdup (_ ("Accessory or utility app category"));
	memset (&_tmp461_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp461_.name);
	_tmp461_.name = _tmp459_;
	_g_free0 (_tmp461_.description);
	_tmp461_.description = _tmp460_;
	_tmp461_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp462_ = g_strdup ("applications-development");
	_tmp463_ = g_strdup (_ ("Programming, software development, code, or IDE app category"));
	memset (&_tmp464_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp464_.name);
	_tmp464_.name = _tmp462_;
	_g_free0 (_tmp464_.description);
	_tmp464_.description = _tmp463_;
	_tmp464_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp465_ = g_strdup ("applications-education");
	_tmp466_ = g_strdup (_ ("Education, learning, or school app category"));
	memset (&_tmp467_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp467_.name);
	_tmp467_.name = _tmp465_;
	_g_free0 (_tmp467_.description);
	_tmp467_.description = _tmp466_;
	_tmp467_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp468_ = g_strdup ("applications-engineering");
	_tmp469_ = g_strdup (_ ("Engineering app category"));
	memset (&_tmp470_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp470_.name);
	_tmp470_.name = _tmp468_;
	_g_free0 (_tmp470_.description);
	_tmp470_.description = _tmp469_;
	_tmp470_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp471_ = g_strdup ("applications-games");
	_tmp472_ = g_strdup (_ ("Games app category"));
	memset (&_tmp473_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp473_.name);
	_tmp473_.name = _tmp471_;
	_g_free0 (_tmp473_.description);
	_tmp473_.description = _tmp472_;
	_tmp473_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp474_ = g_strdup ("applications-graphics");
	_tmp475_ = g_strdup (_ ("Graphics, drawing, art, or photo manipulation app category"));
	memset (&_tmp476_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp476_.name);
	_tmp476_.name = _tmp474_;
	_g_free0 (_tmp476_.description);
	_tmp476_.description = _tmp475_;
	_tmp476_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp477_ = g_strdup ("applications-internet");
	_tmp478_ = g_strdup (_ ("Internet or web related app category"));
	memset (&_tmp479_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp479_.name);
	_tmp479_.name = _tmp477_;
	_g_free0 (_tmp479_.description);
	_tmp479_.description = _tmp478_;
	_tmp479_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp480_ = g_strdup ("applications-multimedia");
	_tmp481_ = g_strdup (_ ("Multimedia, audio, or video app category"));
	memset (&_tmp482_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp482_.name);
	_tmp482_.name = _tmp480_;
	_g_free0 (_tmp482_.description);
	_tmp482_.description = _tmp481_;
	_tmp482_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp483_ = g_strdup ("applications-office");
	_tmp484_ = g_strdup (_ ("Office app category"));
	memset (&_tmp485_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp485_.name);
	_tmp485_.name = _tmp483_;
	_g_free0 (_tmp485_.description);
	_tmp485_.description = _tmp484_;
	_tmp485_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp486_ = g_strdup ("applications-other");
	_tmp487_ = g_strdup (_ ("Other or uncategorized app category"));
	memset (&_tmp488_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp488_.name);
	_tmp488_.name = _tmp486_;
	_g_free0 (_tmp488_.description);
	_tmp488_.description = _tmp487_;
	_tmp488_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp489_ = g_strdup ("applications-science");
	_tmp490_ = g_strdup (_ ("Science app category"));
	memset (&_tmp491_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp491_.name);
	_tmp491_.name = _tmp489_;
	_g_free0 (_tmp491_.description);
	_tmp491_.description = _tmp490_;
	_tmp491_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp492_ = g_strdup ("applications-system");
	_tmp493_ = g_strdup (_ ("System tools or OS app category"));
	memset (&_tmp494_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp494_.name);
	_tmp494_.name = _tmp492_;
	_g_free0 (_tmp494_.description);
	_tmp494_.description = _tmp493_;
	_tmp494_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp495_ = g_strdup ("applications-utilities");
	_tmp496_ = g_strdup (_ ("Utility app category"));
	memset (&_tmp497_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp497_.name);
	_tmp497_.name = _tmp495_;
	_g_free0 (_tmp497_.description);
	_tmp497_.description = _tmp496_;
	_tmp497_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp498_ = g_strdup ("preferences-bluetooth");
	_tmp499_ = g_strdup (_ ("Bluetooth settings"));
	memset (&_tmp500_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp500_.name);
	_tmp500_.name = _tmp498_;
	_g_free0 (_tmp500_.description);
	_tmp500_.description = _tmp499_;
	_tmp500_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp501_ = g_strdup ("preferences-color");
	_tmp502_ = g_strdup (_ ("Color settings such as printer, display, or camera calibration"));
	memset (&_tmp503_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp503_.name);
	_tmp503_.name = _tmp501_;
	_g_free0 (_tmp503_.description);
	_tmp503_.description = _tmp502_;
	_tmp503_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp504_ = g_strdup ("preferences-desktop");
	_tmp505_ = g_strdup (_ ("Desktop interface settings"));
	memset (&_tmp506_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp506_.name);
	_tmp506_.name = _tmp504_;
	_g_free0 (_tmp506_.description);
	_tmp506_.description = _tmp505_;
	_tmp506_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp507_ = g_strdup ("preferences-desktop-accessibility");
	_tmp508_ = g_strdup (_ ("Universal access settings"));
	memset (&_tmp509_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp509_.name);
	_tmp509_.name = _tmp507_;
	_g_free0 (_tmp509_.description);
	_tmp509_.description = _tmp508_;
	_tmp509_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp510_ = g_strdup ("preferences-desktop-accessibility-pointing");
	_tmp511_ = g_strdup (_ ("Universal access settings for pointing, such as controlling the cursor"));
	memset (&_tmp512_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp512_.name);
	_tmp512_.name = _tmp510_;
	_g_free0 (_tmp512_.description);
	_tmp512_.description = _tmp511_;
	_tmp512_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp513_ = g_strdup ("preferences-desktop-accessibility-zoom");
	_tmp514_ = g_strdup (_ ("Universal access settings for zooming or magnifying"));
	memset (&_tmp515_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp515_.name);
	_tmp515_.name = _tmp513_;
	_g_free0 (_tmp515_.description);
	_tmp515_.description = _tmp514_;
	_tmp515_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp516_ = g_strdup ("preferences-desktop-applications");
	_tmp517_ = g_strdup (_ ("App-related settings, such as default or startup apps"));
	memset (&_tmp518_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp518_.name);
	_tmp518_.name = _tmp516_;
	_g_free0 (_tmp518_.description);
	_tmp518_.description = _tmp517_;
	_tmp518_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp519_ = g_strdup ("preferences-desktop-display");
	_tmp520_ = g_strdup (_ ("Display settings, such as resolution or scaling"));
	memset (&_tmp521_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp521_.name);
	_tmp521_.name = _tmp519_;
	_g_free0 (_tmp521_.description);
	_tmp521_.description = _tmp520_;
	_tmp521_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp522_ = g_strdup ("preferences-desktop-font");
	_tmp523_ = g_strdup (_ ("Font settings"));
	memset (&_tmp524_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp524_.name);
	_tmp524_.name = _tmp522_;
	_g_free0 (_tmp524_.description);
	_tmp524_.description = _tmp523_;
	_tmp524_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp525_ = g_strdup ("preferences-desktop-keyboard");
	_tmp526_ = g_strdup (_ ("Keyboard settings, such as layout or shortcuts"));
	memset (&_tmp527_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp527_.name);
	_tmp527_.name = _tmp525_;
	_g_free0 (_tmp527_.description);
	_tmp527_.description = _tmp526_;
	_tmp527_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp528_ = g_strdup ("preferences-desktop-locale");
	_tmp529_ = g_strdup (_ ("International localization, language, or region settings"));
	memset (&_tmp530_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp530_.name);
	_tmp530_.name = _tmp528_;
	_g_free0 (_tmp530_.description);
	_tmp530_.description = _tmp529_;
	_tmp530_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp531_ = g_strdup ("preferences-desktop-online-accounts");
	_tmp532_ = g_strdup (_ ("Online account and cloud sync or sign in settings"));
	memset (&_tmp533_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp533_.name);
	_tmp533_.name = _tmp531_;
	_g_free0 (_tmp533_.description);
	_tmp533_.description = _tmp532_;
	_tmp533_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp534_ = g_strdup ("preferences-desktop-peripherals");
	_tmp535_ = g_strdup (_ ("Settings for peripherals, such as a mouse or keyboard"));
	memset (&_tmp536_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp536_.name);
	_tmp536_.name = _tmp534_;
	_g_free0 (_tmp536_.description);
	_tmp536_.description = _tmp535_;
	_tmp536_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp537_ = g_strdup ("preferences-desktop-sound");
	_tmp538_ = g_strdup (_ ("Sound or audio input and output settings"));
	memset (&_tmp539_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp539_.name);
	_tmp539_.name = _tmp537_;
	_g_free0 (_tmp539_.description);
	_tmp539_.description = _tmp538_;
	_tmp539_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp540_ = g_strdup ("preferences-desktop-theme");
	_tmp541_ = g_strdup (_ ("Look and feel, appearance, style, or theme settings"));
	memset (&_tmp542_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp542_.name);
	_tmp542_.name = _tmp540_;
	_g_free0 (_tmp542_.description);
	_tmp542_.description = _tmp541_;
	_tmp542_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp543_ = g_strdup ("preferences-desktop-wallpaper");
	_tmp544_ = g_strdup (_ ("Desktop wallpaper or background settings"));
	memset (&_tmp545_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp545_.name);
	_tmp545_.name = _tmp543_;
	_g_free0 (_tmp545_.description);
	_tmp545_.description = _tmp544_;
	_tmp545_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp546_ = g_strdup ("preferences-other");
	_tmp547_ = g_strdup (_ ("Other, miscellaneous, or uncategorized settings"));
	memset (&_tmp548_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp548_.name);
	_tmp548_.name = _tmp546_;
	_g_free0 (_tmp548_.description);
	_tmp548_.description = _tmp547_;
	_tmp548_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp549_ = g_strdup ("preferences-system");
	_tmp550_ = g_strdup (_ ("System settings or preferences"));
	memset (&_tmp551_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp551_.name);
	_tmp551_.name = _tmp549_;
	_g_free0 (_tmp551_.description);
	_tmp551_.description = _tmp550_;
	_tmp551_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp552_ = g_strdup ("preferences-system-network");
	_tmp553_ = g_strdup (_ ("Network settings, such as wireless, Ethernet, or VPN"));
	memset (&_tmp554_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp554_.name);
	_tmp554_.name = _tmp552_;
	_g_free0 (_tmp554_.description);
	_tmp554_.description = _tmp553_;
	_tmp554_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp555_ = g_strdup ("preferences-system-notifications");
	_tmp556_ = g_strdup (_ ("Notification alert settings"));
	memset (&_tmp557_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp557_.name);
	_tmp557_.name = _tmp555_;
	_g_free0 (_tmp557_.description);
	_tmp557_.description = _tmp556_;
	_tmp557_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp558_ = g_strdup ("preferences-system-power");
	_tmp559_ = g_strdup (_ ("Power management or energy usage settings, such as battery"));
	memset (&_tmp560_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp560_.name);
	_tmp560_.name = _tmp558_;
	_g_free0 (_tmp560_.description);
	_tmp560_.description = _tmp559_;
	_tmp560_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp561_ = g_strdup ("preferences-system-privacy");
	_tmp562_ = g_strdup (_ ("Privacy and security settings"));
	memset (&_tmp563_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp563_.name);
	_tmp563_.name = _tmp561_;
	_g_free0 (_tmp563_.description);
	_tmp563_.description = _tmp562_;
	_tmp563_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp564_ = g_strdup ("preferences-system-sharing");
	_tmp565_ = g_strdup (_ ("Sharing settings, such as library sharing or media streaming over a ne" \
"twork"));
	memset (&_tmp566_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp566_.name);
	_tmp566_.name = _tmp564_;
	_g_free0 (_tmp566_.description);
	_tmp566_.description = _tmp565_;
	_tmp566_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp567_ = g_strdup ("preferences-system-time");
	_tmp568_ = g_strdup (_ ("Time and date settings"));
	memset (&_tmp569_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp569_.name);
	_tmp569_.name = _tmp567_;
	_g_free0 (_tmp569_.description);
	_tmp569_.description = _tmp568_;
	_tmp569_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp570_ = g_strdup ("preferences-system-windows");
	_tmp571_ = g_strdup (_ ("Window management settings"));
	memset (&_tmp572_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp572_.name);
	_tmp572_.name = _tmp570_;
	_g_free0 (_tmp572_.description);
	_tmp572_.description = _tmp571_;
	_tmp572_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp573_ = g_strdup ("system-help");
	_tmp574_ = g_strdup (_ ("Help"));
	memset (&_tmp575_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp575_.name);
	_tmp575_.name = _tmp573_;
	_g_free0 (_tmp575_.description);
	_tmp575_.description = _tmp574_;
	_tmp575_.category = ICON_COLLECTION_CATEGORY_CATEGORIES;
	_tmp576_ = g_strdup ("audio-card");
	_tmp577_ = g_strdup (_ ("Audio output device, such as a sound card or speaker"));
	memset (&_tmp578_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp578_.name);
	_tmp578_.name = _tmp576_;
	_g_free0 (_tmp578_.description);
	_tmp578_.description = _tmp577_;
	_tmp578_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp579_ = g_strdup ("audio-headphones");
	_tmp580_ = g_strdup (_ ("Audio output device representing headphones"));
	memset (&_tmp581_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp581_.name);
	_tmp581_.name = _tmp579_;
	_g_free0 (_tmp581_.description);
	_tmp581_.description = _tmp580_;
	_tmp581_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp582_ = g_strdup ("audio-headset");
	_tmp583_ = g_strdup (_ ("Audio output device representing a headset"));
	memset (&_tmp584_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp584_.name);
	_tmp584_.name = _tmp582_;
	_g_free0 (_tmp584_.description);
	_tmp584_.description = _tmp583_;
	_tmp584_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp585_ = g_strdup ("audio-input-microphone");
	_tmp586_ = g_strdup (_ ("Microphone"));
	memset (&_tmp587_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp587_.name);
	_tmp587_.name = _tmp585_;
	_g_free0 (_tmp587_.description);
	_tmp587_.description = _tmp586_;
	_tmp587_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp588_ = g_strdup ("audio-subwoofer");
	_tmp589_ = g_strdup (_ ("Subwoofer or bass speaker"));
	memset (&_tmp590_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp590_.name);
	_tmp590_.name = _tmp588_;
	_g_free0 (_tmp590_.description);
	_tmp590_.description = _tmp589_;
	_tmp590_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp591_ = g_strdup ("battery");
	_tmp592_ = g_strdup (_ ("Battery"));
	memset (&_tmp593_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp593_.name);
	_tmp593_.name = _tmp591_;
	_g_free0 (_tmp593_.description);
	_tmp593_.description = _tmp592_;
	_tmp593_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp594_ = g_strdup ("bluetooth");
	_tmp595_ = g_strdup (_ ("Bluetooth"));
	memset (&_tmp596_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp596_.name);
	_tmp596_.name = _tmp594_;
	_g_free0 (_tmp596_.description);
	_tmp596_.description = _tmp595_;
	_tmp596_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp597_ = g_strdup ("camera-photo");
	_tmp598_ = g_strdup (_ ("Digital photo or still camera"));
	memset (&_tmp599_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp599_.name);
	_tmp599_.name = _tmp597_;
	_g_free0 (_tmp599_.description);
	_tmp599_.description = _tmp598_;
	_tmp599_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp600_ = g_strdup ("camera-video");
	_tmp601_ = g_strdup (_ ("Video or movie camera"));
	memset (&_tmp602_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp602_.name);
	_tmp602_.name = _tmp600_;
	_g_free0 (_tmp602_.description);
	_tmp602_.description = _tmp601_;
	_tmp602_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp603_ = g_strdup ("camera-web");
	_tmp604_ = g_strdup (_ ("Webcam or built-in camera"));
	memset (&_tmp605_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp605_.name);
	_tmp605_.name = _tmp603_;
	_g_free0 (_tmp605_.description);
	_tmp605_.description = _tmp604_;
	_tmp605_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp606_ = g_strdup ("computer");
	_tmp607_ = g_strdup (_ ("Generic or desktop computer"));
	memset (&_tmp608_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp608_.name);
	_tmp608_.name = _tmp606_;
	_g_free0 (_tmp608_.description);
	_tmp608_.description = _tmp607_;
	_tmp608_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp609_ = g_strdup ("computer-laptop");
	_tmp610_ = g_strdup (_ ("Laptop or notebook computer"));
	memset (&_tmp611_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp611_.name);
	_tmp611_.name = _tmp609_;
	_g_free0 (_tmp611_.description);
	_tmp611_.description = _tmp610_;
	_tmp611_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp612_ = g_strdup ("drive-harddisk");
	_tmp613_ = g_strdup (_ ("Hard disk or storage drive"));
	memset (&_tmp614_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp614_.name);
	_tmp614_.name = _tmp612_;
	_g_free0 (_tmp614_.description);
	_tmp614_.description = _tmp613_;
	_tmp614_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp615_ = g_strdup ("drive-optical");
	_tmp616_ = g_strdup (_ ("Optical drive, such as for CD, DVD, or Blu-ray discs"));
	memset (&_tmp617_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp617_.name);
	_tmp617_.name = _tmp615_;
	_g_free0 (_tmp617_.description);
	_tmp617_.description = _tmp616_;
	_tmp617_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp618_ = g_strdup ("drive-removable-media");
	_tmp619_ = g_strdup (_ ("Removable storage device, such as a portable hard drive"));
	memset (&_tmp620_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp620_.name);
	_tmp620_.name = _tmp618_;
	_g_free0 (_tmp620_.description);
	_tmp620_.description = _tmp619_;
	_tmp620_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp621_ = g_strdup ("drive-removable-media-usb");
	_tmp622_ = g_strdup (_ ("USB drive or stick, such as a flash, jump, or thumb drive"));
	memset (&_tmp623_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp623_.name);
	_tmp623_.name = _tmp621_;
	_g_free0 (_tmp623_.description);
	_tmp623_.description = _tmp622_;
	_tmp623_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp624_ = g_strdup ("input-gaming");
	_tmp625_ = g_strdup (_ ("Video game controller, such as a paddle, remote, or joystick"));
	memset (&_tmp626_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp626_.name);
	_tmp626_.name = _tmp624_;
	_g_free0 (_tmp626_.description);
	_tmp626_.description = _tmp625_;
	_tmp626_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp627_ = g_strdup ("input-keyboard");
	_tmp628_ = g_strdup (_ ("Keyboard"));
	memset (&_tmp629_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp629_.name);
	_tmp629_.name = _tmp627_;
	_g_free0 (_tmp629_.description);
	_tmp629_.description = _tmp628_;
	_tmp629_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp630_ = g_strdup ("input-mouse");
	_tmp631_ = g_strdup (_ ("Mouse"));
	memset (&_tmp632_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp632_.name);
	_tmp632_.name = _tmp630_;
	_g_free0 (_tmp632_.description);
	_tmp632_.description = _tmp631_;
	_tmp632_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp633_ = g_strdup ("input-tablet");
	_tmp634_ = g_strdup (_ ("Graphics tablet or pen input, such as a Wacom digitizer, Intuos, Cinti" \
"q, or Bamboo"));
	memset (&_tmp635_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp635_.name);
	_tmp635_.name = _tmp633_;
	_g_free0 (_tmp635_.description);
	_tmp635_.description = _tmp634_;
	_tmp635_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp636_ = g_strdup ("input-touchpad");
	_tmp637_ = g_strdup (_ ("Touchpad input, such as a multitouch trackpad or clickpad"));
	memset (&_tmp638_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp638_.name);
	_tmp638_.name = _tmp636_;
	_g_free0 (_tmp638_.description);
	_tmp638_.description = _tmp637_;
	_tmp638_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp639_ = g_strdup ("media-flash");
	_tmp640_ = g_strdup (_ ("Flash media such as a memory stick or SD card"));
	memset (&_tmp641_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp641_.name);
	_tmp641_.name = _tmp639_;
	_g_free0 (_tmp641_.description);
	_tmp641_.description = _tmp640_;
	_tmp641_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp642_ = g_strdup ("media-optical");
	_tmp643_ = g_strdup (_ ("Optical media, such as a CD, DVD, or Blu-ray disc"));
	memset (&_tmp644_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp644_.name);
	_tmp644_.name = _tmp642_;
	_g_free0 (_tmp644_.description);
	_tmp644_.description = _tmp643_;
	_tmp644_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp645_ = g_strdup ("modem");
	_tmp646_ = g_strdup (_ ("Network modem or router"));
	memset (&_tmp647_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp647_.name);
	_tmp647_.name = _tmp645_;
	_g_free0 (_tmp647_.description);
	_tmp647_.description = _tmp646_;
	_tmp647_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp648_ = g_strdup ("multimedia-player");
	_tmp649_ = g_strdup (_ ("Media player device, such as a portable mp3 music player or iPod"));
	memset (&_tmp650_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp650_.name);
	_tmp650_.name = _tmp648_;
	_g_free0 (_tmp650_.description);
	_tmp650_.description = _tmp649_;
	_tmp650_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp651_ = g_strdup ("network-cellular");
	_tmp652_ = g_strdup (_ ("Cellular type wireless network or device, such as a 2G, 3G, or 4G LTE " \
"connection, modem, or SIM card"));
	memset (&_tmp653_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp653_.name);
	_tmp653_.name = _tmp651_;
	_g_free0 (_tmp653_.description);
	_tmp653_.description = _tmp652_;
	_tmp653_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp654_ = g_strdup ("network-firewall");
	_tmp655_ = g_strdup (_ ("Networking firewall"));
	memset (&_tmp656_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp656_.name);
	_tmp656_.name = _tmp654_;
	_g_free0 (_tmp656_.description);
	_tmp656_.description = _tmp655_;
	_tmp656_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp657_ = g_strdup ("network-vpn");
	_tmp658_ = g_strdup (_ ("Virtual private network or VPN connection"));
	memset (&_tmp659_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp659_.name);
	_tmp659_.name = _tmp657_;
	_g_free0 (_tmp659_.description);
	_tmp659_.description = _tmp658_;
	_tmp659_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp660_ = g_strdup ("network-wired");
	_tmp661_ = g_strdup (_ ("Wired network connection, such as Ethernet"));
	memset (&_tmp662_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp662_.name);
	_tmp662_.name = _tmp660_;
	_g_free0 (_tmp662_.description);
	_tmp662_.description = _tmp661_;
	_tmp662_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp663_ = g_strdup ("network-wireless");
	_tmp664_ = g_strdup (_ ("Wireless network connection, such as Wi-Fi"));
	memset (&_tmp665_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp665_.name);
	_tmp665_.name = _tmp663_;
	_g_free0 (_tmp665_.description);
	_tmp665_.description = _tmp664_;
	_tmp665_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp666_ = g_strdup ("network-wireless-hotspot");
	_tmp667_ = g_strdup (_ ("Wireless hotspot connection, such as through a mobile cellular phone o" \
"r smartphone"));
	memset (&_tmp668_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp668_.name);
	_tmp668_.name = _tmp666_;
	_g_free0 (_tmp668_.description);
	_tmp668_.description = _tmp667_;
	_tmp668_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp669_ = g_strdup ("phone");
	_tmp670_ = g_strdup (_ ("Generic phone, such as a mobile Android smartphone or iPhone"));
	memset (&_tmp671_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp671_.name);
	_tmp671_.name = _tmp669_;
	_g_free0 (_tmp671_.description);
	_tmp671_.description = _tmp670_;
	_tmp671_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp672_ = g_strdup ("printer");
	_tmp673_ = g_strdup (_ ("Printer"));
	memset (&_tmp674_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp674_.name);
	_tmp674_.name = _tmp672_;
	_g_free0 (_tmp674_.description);
	_tmp674_.description = _tmp673_;
	_tmp674_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp675_ = g_strdup ("printer-network");
	_tmp676_ = g_strdup (_ ("Network-connected or shared printer"));
	memset (&_tmp677_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp677_.name);
	_tmp677_.name = _tmp675_;
	_g_free0 (_tmp677_.description);
	_tmp677_.description = _tmp676_;
	_tmp677_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp678_ = g_strdup ("scanner");
	_tmp679_ = g_strdup (_ ("Scanner"));
	memset (&_tmp680_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp680_.name);
	_tmp680_.name = _tmp678_;
	_g_free0 (_tmp680_.description);
	_tmp680_.description = _tmp679_;
	_tmp680_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp681_ = g_strdup ("video-display");
	_tmp682_ = g_strdup (_ ("Display, screen, or monitor"));
	memset (&_tmp683_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp683_.name);
	_tmp683_.name = _tmp681_;
	_g_free0 (_tmp683_.description);
	_tmp683_.description = _tmp682_;
	_tmp683_.category = ICON_COLLECTION_CATEGORY_DEVICES;
	_tmp684_ = g_strdup ("emblem-default");
	_tmp685_ = g_strdup (_ ("Default selection emblem, such as for a printer or other device"));
	memset (&_tmp686_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp686_.name);
	_tmp686_.name = _tmp684_;
	_g_free0 (_tmp686_.description);
	_tmp686_.description = _tmp685_;
	_tmp686_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp687_ = g_strdup ("emblem-disabled");
	_tmp688_ = g_strdup (_ ("Disabled feature or service emblem"));
	memset (&_tmp689_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp689_.name);
	_tmp689_.name = _tmp687_;
	_g_free0 (_tmp689_.description);
	_tmp689_.description = _tmp688_;
	_tmp689_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp690_ = g_strdup ("emblem-documents");
	_tmp691_ = g_strdup (_ ("Documents emblem"));
	memset (&_tmp692_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp692_.name);
	_tmp692_.name = _tmp690_;
	_g_free0 (_tmp692_.description);
	_tmp692_.description = _tmp691_;
	_tmp692_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp693_ = g_strdup ("emblem-downloads");
	_tmp694_ = g_strdup (_ ("Downloads emblem"));
	memset (&_tmp695_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp695_.name);
	_tmp695_.name = _tmp693_;
	_g_free0 (_tmp695_.description);
	_tmp695_.description = _tmp694_;
	_tmp695_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp696_ = g_strdup ("emblem-enabled");
	_tmp697_ = g_strdup (_ ("Enabled feature or service emblem"));
	memset (&_tmp698_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp698_.name);
	_tmp698_.name = _tmp696_;
	_g_free0 (_tmp698_.description);
	_tmp698_.description = _tmp697_;
	_tmp698_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp699_ = g_strdup ("emblem-error");
	_tmp700_ = g_strdup (_ ("Emblem for the error status of a feature or service"));
	memset (&_tmp701_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp701_.name);
	_tmp701_.name = _tmp699_;
	_g_free0 (_tmp701_.description);
	_tmp701_.description = _tmp700_;
	_tmp701_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp702_ = g_strdup ("emblem-favorite");
	_tmp703_ = g_strdup (_ ("Item the user has marked as a favorite"));
	memset (&_tmp704_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp704_.name);
	_tmp704_.name = _tmp702_;
	_g_free0 (_tmp704_.description);
	_tmp704_.description = _tmp703_;
	_tmp704_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp705_ = g_strdup ("emblem-important");
	_tmp706_ = g_strdup (_ ("Item marked as important"));
	memset (&_tmp707_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp707_.name);
	_tmp707_.name = _tmp705_;
	_g_free0 (_tmp707_.description);
	_tmp707_.description = _tmp706_;
	_tmp707_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp708_ = g_strdup ("emblem-mail");
	_tmp709_ = g_strdup (_ ("Item related to email"));
	memset (&_tmp710_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp710_.name);
	_tmp710_.name = _tmp708_;
	_g_free0 (_tmp710_.description);
	_tmp710_.description = _tmp709_;
	_tmp710_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp711_ = g_strdup ("emblem-mixed");
	_tmp712_ = g_strdup (_ ("Emblem for the partially enabled status of a feature or service"));
	memset (&_tmp713_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp713_.name);
	_tmp713_.name = _tmp711_;
	_g_free0 (_tmp713_.description);
	_tmp713_.description = _tmp712_;
	_tmp713_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp714_ = g_strdup ("emblem-photos");
	_tmp715_ = g_strdup (_ ("Photos emblem"));
	memset (&_tmp716_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp716_.name);
	_tmp716_.name = _tmp714_;
	_g_free0 (_tmp716_.description);
	_tmp716_.description = _tmp715_;
	_tmp716_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp717_ = g_strdup ("emblem-readonly");
	_tmp718_ = g_strdup (_ ("Item is read-only, or the user cannot write to or make changes to it"));
	memset (&_tmp719_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp719_.name);
	_tmp719_.name = _tmp717_;
	_g_free0 (_tmp719_.description);
	_tmp719_.description = _tmp718_;
	_tmp719_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp720_ = g_strdup ("emblem-shared");
	_tmp721_ = g_strdup (_ ("Item shared with other people or users"));
	memset (&_tmp722_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp722_.name);
	_tmp722_.name = _tmp720_;
	_g_free0 (_tmp722_.description);
	_tmp722_.description = _tmp721_;
	_tmp722_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp723_ = g_strdup ("emblem-symbolic-link");
	_tmp724_ = g_strdup (_ ("Item is a symbolic link to a file somewhere else"));
	memset (&_tmp725_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp725_.name);
	_tmp725_.name = _tmp723_;
	_g_free0 (_tmp725_.description);
	_tmp725_.description = _tmp724_;
	_tmp725_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp726_ = g_strdup ("emblem-synchronized");
	_tmp727_ = g_strdup (_ ("Item is configured to be synchronized to another device or location"));
	memset (&_tmp728_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp728_.name);
	_tmp728_.name = _tmp726_;
	_g_free0 (_tmp728_.description);
	_tmp728_.description = _tmp727_;
	_tmp728_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp729_ = g_strdup ("emblem-system");
	_tmp730_ = g_strdup (_ ("Item is a system file, library, setting, or data"));
	memset (&_tmp731_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp731_.name);
	_tmp731_.name = _tmp729_;
	_g_free0 (_tmp731_.description);
	_tmp731_.description = _tmp730_;
	_tmp731_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp732_ = g_strdup ("emblem-unreadable");
	_tmp733_ = g_strdup (_ ("Item is unreadable or inaccessible"));
	memset (&_tmp734_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp734_.name);
	_tmp734_.name = _tmp732_;
	_g_free0 (_tmp734_.description);
	_tmp734_.description = _tmp733_;
	_tmp734_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp735_ = g_strdup ("emblem-warning");
	_tmp736_ = g_strdup (_ ("Emblem for the warning status of a feature or service"));
	memset (&_tmp737_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp737_.name);
	_tmp737_.name = _tmp735_;
	_g_free0 (_tmp737_.description);
	_tmp737_.description = _tmp736_;
	_tmp737_.category = ICON_COLLECTION_CATEGORY_EMBLEMS;
	_tmp738_ = g_strdup ("face-angel");
	_tmp739_ = g_strdup (_ ("0:-) emoticon"));
	memset (&_tmp740_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp740_.name);
	_tmp740_.name = _tmp738_;
	_g_free0 (_tmp740_.description);
	_tmp740_.description = _tmp739_;
	_tmp740_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp741_ = g_strdup ("face-angry");
	_tmp742_ = g_strdup (_ ("X-( emoticon"));
	memset (&_tmp743_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp743_.name);
	_tmp743_.name = _tmp741_;
	_g_free0 (_tmp743_.description);
	_tmp743_.description = _tmp742_;
	_tmp743_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp744_ = g_strdup ("face-cool");
	_tmp745_ = g_strdup (_ ("B-) emoticon"));
	memset (&_tmp746_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp746_.name);
	_tmp746_.name = _tmp744_;
	_g_free0 (_tmp746_.description);
	_tmp746_.description = _tmp745_;
	_tmp746_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp747_ = g_strdup ("face-crying");
	_tmp748_ = g_strdup (_ (":'( emoticon"));
	memset (&_tmp749_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp749_.name);
	_tmp749_.name = _tmp747_;
	_g_free0 (_tmp749_.description);
	_tmp749_.description = _tmp748_;
	_tmp749_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp750_ = g_strdup ("face-devilish");
	_tmp751_ = g_strdup (_ (">:-) emoticon"));
	memset (&_tmp752_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp752_.name);
	_tmp752_.name = _tmp750_;
	_g_free0 (_tmp752_.description);
	_tmp752_.description = _tmp751_;
	_tmp752_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp753_ = g_strdup ("face-embarrassed");
	_tmp754_ = g_strdup (_ (":-[ emoticon"));
	memset (&_tmp755_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp755_.name);
	_tmp755_.name = _tmp753_;
	_g_free0 (_tmp755_.description);
	_tmp755_.description = _tmp754_;
	_tmp755_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp756_ = g_strdup ("face-heart");
	_tmp757_ = g_strdup (_ ("<3 emoticon"));
	memset (&_tmp758_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp758_.name);
	_tmp758_.name = _tmp756_;
	_g_free0 (_tmp758_.description);
	_tmp758_.description = _tmp757_;
	_tmp758_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp759_ = g_strdup ("face-heart-broken");
	_tmp760_ = g_strdup (_ ("</3 emoticon"));
	memset (&_tmp761_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp761_.name);
	_tmp761_.name = _tmp759_;
	_g_free0 (_tmp761_.description);
	_tmp761_.description = _tmp760_;
	_tmp761_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp762_ = g_strdup ("face-kiss");
	_tmp763_ = g_strdup (_ (":-* emoticon"));
	memset (&_tmp764_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp764_.name);
	_tmp764_.name = _tmp762_;
	_g_free0 (_tmp764_.description);
	_tmp764_.description = _tmp763_;
	_tmp764_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp765_ = g_strdup ("face-laugh");
	_tmp766_ = g_strdup (_ (":-)) emoticon"));
	memset (&_tmp767_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp767_.name);
	_tmp767_.name = _tmp765_;
	_g_free0 (_tmp767_.description);
	_tmp767_.description = _tmp766_;
	_tmp767_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp768_ = g_strdup ("face-monkey");
	_tmp769_ = g_strdup (_ (":-(|) emoticon"));
	memset (&_tmp770_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp770_.name);
	_tmp770_.name = _tmp768_;
	_g_free0 (_tmp770_.description);
	_tmp770_.description = _tmp769_;
	_tmp770_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp771_ = g_strdup ("face-plain");
	_tmp772_ = g_strdup (_ (":-| emoticon"));
	memset (&_tmp773_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp773_.name);
	_tmp773_.name = _tmp771_;
	_g_free0 (_tmp773_.description);
	_tmp773_.description = _tmp772_;
	_tmp773_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp774_ = g_strdup ("face-raspberry");
	_tmp775_ = g_strdup (_ (":-P emoticon"));
	memset (&_tmp776_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp776_.name);
	_tmp776_.name = _tmp774_;
	_g_free0 (_tmp776_.description);
	_tmp776_.description = _tmp775_;
	_tmp776_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp777_ = g_strdup ("face-sad");
	_tmp778_ = g_strdup (_ (":-( emoticon"));
	memset (&_tmp779_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp779_.name);
	_tmp779_.name = _tmp777_;
	_g_free0 (_tmp779_.description);
	_tmp779_.description = _tmp778_;
	_tmp779_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp780_ = g_strdup ("face-sick");
	_tmp781_ = g_strdup (_ (":-& emoticon"));
	memset (&_tmp782_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp782_.name);
	_tmp782_.name = _tmp780_;
	_g_free0 (_tmp782_.description);
	_tmp782_.description = _tmp781_;
	_tmp782_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp783_ = g_strdup ("face-smile");
	_tmp784_ = g_strdup (_ (":-) emoticon"));
	memset (&_tmp785_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp785_.name);
	_tmp785_.name = _tmp783_;
	_g_free0 (_tmp785_.description);
	_tmp785_.description = _tmp784_;
	_tmp785_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp786_ = g_strdup ("face-smile-big");
	_tmp787_ = g_strdup (_ (":-D emoticon"));
	memset (&_tmp788_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp788_.name);
	_tmp788_.name = _tmp786_;
	_g_free0 (_tmp788_.description);
	_tmp788_.description = _tmp787_;
	_tmp788_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp789_ = g_strdup ("face-smirk");
	_tmp790_ = g_strdup (_ (":-! emoticon"));
	memset (&_tmp791_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp791_.name);
	_tmp791_.name = _tmp789_;
	_g_free0 (_tmp791_.description);
	_tmp791_.description = _tmp790_;
	_tmp791_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp792_ = g_strdup ("face-surprise");
	_tmp793_ = g_strdup (_ (":-0 emoticon"));
	memset (&_tmp794_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp794_.name);
	_tmp794_.name = _tmp792_;
	_g_free0 (_tmp794_.description);
	_tmp794_.description = _tmp793_;
	_tmp794_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp795_ = g_strdup ("face-tired");
	_tmp796_ = g_strdup (_ ("|-) emoticon"));
	memset (&_tmp797_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp797_.name);
	_tmp797_.name = _tmp795_;
	_g_free0 (_tmp797_.description);
	_tmp797_.description = _tmp796_;
	_tmp797_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp798_ = g_strdup ("face-uncertain");
	_tmp799_ = g_strdup (_ (":-/ emoticon"));
	memset (&_tmp800_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp800_.name);
	_tmp800_.name = _tmp798_;
	_g_free0 (_tmp800_.description);
	_tmp800_.description = _tmp799_;
	_tmp800_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp801_ = g_strdup ("face-wink");
	_tmp802_ = g_strdup (_ (";-) emoticon"));
	memset (&_tmp803_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp803_.name);
	_tmp803_.name = _tmp801_;
	_g_free0 (_tmp803_.description);
	_tmp803_.description = _tmp802_;
	_tmp803_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp804_ = g_strdup ("face-worried");
	_tmp805_ = g_strdup (_ (":-S emoticon"));
	memset (&_tmp806_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp806_.name);
	_tmp806_.name = _tmp804_;
	_g_free0 (_tmp806_.description);
	_tmp806_.description = _tmp805_;
	_tmp806_.category = ICON_COLLECTION_CATEGORY_EMOTES;
	_tmp807_ = g_strdup ("application-epub+zip");
	_tmp808_ = g_strdup (_ ("EPUB Ebook file types"));
	memset (&_tmp809_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp809_.name);
	_tmp809_.name = _tmp807_;
	_g_free0 (_tmp809_.description);
	_tmp809_.description = _tmp808_;
	_tmp809_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp810_ = g_strdup ("application-illustrator");
	_tmp811_ = g_strdup (_ ("Adobe Illustrator image file types"));
	memset (&_tmp812_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp812_.name);
	_tmp812_.name = _tmp810_;
	_g_free0 (_tmp812_.description);
	_tmp812_.description = _tmp811_;
	_tmp812_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp813_ = g_strdup ("application-javascript");
	_tmp814_ = g_strdup (_ ("Javascript programming language file types"));
	memset (&_tmp815_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp815_.name);
	_tmp815_.name = _tmp813_;
	_g_free0 (_tmp815_.description);
	_tmp815_.description = _tmp814_;
	_tmp815_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp816_ = g_strdup ("application-msword");
	_tmp817_ = g_strdup (_ ("Microsoft Word file types"));
	memset (&_tmp818_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp818_.name);
	_tmp818_.name = _tmp816_;
	_g_free0 (_tmp818_.description);
	_tmp818_.description = _tmp817_;
	_tmp818_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp819_ = g_strdup ("application-octet-stream");
	_tmp820_ = g_strdup (_ ("Binary file types"));
	memset (&_tmp821_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp821_.name);
	_tmp821_.name = _tmp819_;
	_g_free0 (_tmp821_.description);
	_tmp821_.description = _tmp820_;
	_tmp821_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp822_ = g_strdup ("application-pdf");
	_tmp823_ = g_strdup (_ ("PDF file types"));
	memset (&_tmp824_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp824_.name);
	_tmp824_.name = _tmp822_;
	_g_free0 (_tmp824_.description);
	_tmp824_.description = _tmp823_;
	_tmp824_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp825_ = g_strdup ("application-pgp");
	_tmp826_ = g_strdup (_ ("PGP file types"));
	memset (&_tmp827_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp827_.name);
	_tmp827_.name = _tmp825_;
	_g_free0 (_tmp827_.description);
	_tmp827_.description = _tmp826_;
	_tmp827_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp828_ = g_strdup ("application-vnd.debian.binary-package");
	_tmp829_ = g_strdup (_ ("Debian package file types"));
	memset (&_tmp830_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp830_.name);
	_tmp830_.name = _tmp828_;
	_g_free0 (_tmp830_.description);
	_tmp830_.description = _tmp829_;
	_tmp830_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp831_ = g_strdup ("application-vnd.flatpak.ref");
	_tmp832_ = g_strdup (_ ("Flatpak reference file types"));
	memset (&_tmp833_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp833_.name);
	_tmp833_.name = _tmp831_;
	_g_free0 (_tmp833_.description);
	_tmp833_.description = _tmp832_;
	_tmp833_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp834_ = g_strdup ("application-vnd.ms-access");
	_tmp835_ = g_strdup (_ ("Microsoft Access file types"));
	memset (&_tmp836_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp836_.name);
	_tmp836_.name = _tmp834_;
	_g_free0 (_tmp836_.description);
	_tmp836_.description = _tmp835_;
	_tmp836_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp837_ = g_strdup ("application-vnd.ms-excel");
	_tmp838_ = g_strdup (_ ("Microsoft Excel file types"));
	memset (&_tmp839_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp839_.name);
	_tmp839_.name = _tmp837_;
	_g_free0 (_tmp839_.description);
	_tmp839_.description = _tmp838_;
	_tmp839_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp840_ = g_strdup ("application-vnd.ms-powerpoint");
	_tmp841_ = g_strdup (_ ("Microsoft PowerPoint file types"));
	memset (&_tmp842_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp842_.name);
	_tmp842_.name = _tmp840_;
	_g_free0 (_tmp842_.description);
	_tmp842_.description = _tmp841_;
	_tmp842_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp843_ = g_strdup ("application-vnd.oasis.opendocument.chart");
	_tmp844_ = g_strdup (_ ("Oasis OpenDocument file types"));
	memset (&_tmp845_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp845_.name);
	_tmp845_.name = _tmp843_;
	_g_free0 (_tmp845_.description);
	_tmp845_.description = _tmp844_;
	_tmp845_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp846_ = g_strdup ("application-x-bittorrent");
	_tmp847_ = g_strdup (_ ("Torrent file types"));
	memset (&_tmp848_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp848_.name);
	_tmp848_.name = _tmp846_;
	_g_free0 (_tmp848_.description);
	_tmp848_.description = _tmp847_;
	_tmp848_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp849_ = g_strdup ("application-x-cd-image");
	_tmp850_ = g_strdup (_ ("CD Image file types"));
	memset (&_tmp851_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp851_.name);
	_tmp851_.name = _tmp849_;
	_g_free0 (_tmp851_.description);
	_tmp851_.description = _tmp850_;
	_tmp851_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp852_ = g_strdup ("application-x-desktop");
	_tmp853_ = g_strdup (_ ("Desktop file types"));
	memset (&_tmp854_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp854_.name);
	_tmp854_.name = _tmp852_;
	_g_free0 (_tmp854_.description);
	_tmp854_.description = _tmp853_;
	_tmp854_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp855_ = g_strdup ("application-x-executable");
	_tmp856_ = g_strdup (_ ("Executable file types"));
	memset (&_tmp857_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp857_.name);
	_tmp857_.name = _tmp855_;
	_g_free0 (_tmp857_.description);
	_tmp857_.description = _tmp856_;
	_tmp857_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp858_ = g_strdup ("application-x-fictionbook+xml");
	_tmp859_ = g_strdup (_ ("FictionBook file types"));
	memset (&_tmp860_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp860_.name);
	_tmp860_.name = _tmp858_;
	_g_free0 (_tmp860_.description);
	_tmp860_.description = _tmp859_;
	_tmp860_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp861_ = g_strdup ("application-x-firmware");
	_tmp862_ = g_strdup (_ ("Firmware file types"));
	memset (&_tmp863_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp863_.name);
	_tmp863_.name = _tmp861_;
	_g_free0 (_tmp863_.description);
	_tmp863_.description = _tmp862_;
	_tmp863_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp864_ = g_strdup ("application-x-php");
	_tmp865_ = g_strdup (_ ("PHP programming language file types"));
	memset (&_tmp866_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp866_.name);
	_tmp866_.name = _tmp864_;
	_g_free0 (_tmp866_.description);
	_tmp866_.description = _tmp865_;
	_tmp866_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp867_ = g_strdup ("application-x-ruby");
	_tmp868_ = g_strdup (_ ("Ruby programming language file types"));
	memset (&_tmp869_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp869_.name);
	_tmp869_.name = _tmp867_;
	_g_free0 (_tmp869_.description);
	_tmp869_.description = _tmp868_;
	_tmp869_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp870_ = g_strdup ("application-x-sharedlib");
	_tmp871_ = g_strdup (_ ("Shared library file types"));
	memset (&_tmp872_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp872_.name);
	_tmp872_.name = _tmp870_;
	_g_free0 (_tmp872_.description);
	_tmp872_.description = _tmp871_;
	_tmp872_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp873_ = g_strdup ("audio-x-generic");
	_tmp874_ = g_strdup (_ ("Generic audio file types"));
	memset (&_tmp875_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp875_.name);
	_tmp875_.name = _tmp873_;
	_g_free0 (_tmp875_.description);
	_tmp875_.description = _tmp874_;
	_tmp875_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp876_ = g_strdup ("audio-x-playlist");
	_tmp877_ = g_strdup (_ ("Audio playlist file types"));
	memset (&_tmp878_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp878_.name);
	_tmp878_.name = _tmp876_;
	_g_free0 (_tmp878_.description);
	_tmp878_.description = _tmp877_;
	_tmp878_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp879_ = g_strdup ("extension");
	_tmp880_ = g_strdup (_ ("Extension"));
	memset (&_tmp881_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp881_.name);
	_tmp881_.name = _tmp879_;
	_g_free0 (_tmp881_.description);
	_tmp881_.description = _tmp880_;
	_tmp881_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp882_ = g_strdup ("font-x-generic");
	_tmp883_ = g_strdup (_ ("Generic font file types"));
	memset (&_tmp884_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp884_.name);
	_tmp884_.name = _tmp882_;
	_g_free0 (_tmp884_.description);
	_tmp884_.description = _tmp883_;
	_tmp884_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp885_ = g_strdup ("image-vnd.adobe.photoshop");
	_tmp886_ = g_strdup (_ ("Adobe Photoshop image file types"));
	memset (&_tmp887_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp887_.name);
	_tmp887_.name = _tmp885_;
	_g_free0 (_tmp887_.description);
	_tmp887_.description = _tmp886_;
	_tmp887_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp888_ = g_strdup ("image-x-generic");
	_tmp889_ = g_strdup (_ ("Generic image file types"));
	memset (&_tmp890_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp890_.name);
	_tmp890_.name = _tmp888_;
	_g_free0 (_tmp890_.description);
	_tmp890_.description = _tmp889_;
	_tmp890_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp891_ = g_strdup ("image-x-xcf");
	_tmp892_ = g_strdup (_ ("XCF image file types"));
	memset (&_tmp893_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp893_.name);
	_tmp893_.name = _tmp891_;
	_g_free0 (_tmp893_.description);
	_tmp893_.description = _tmp892_;
	_tmp893_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp894_ = g_strdup ("internet-feed");
	_tmp895_ = g_strdup (_ ("Internet Feed"));
	memset (&_tmp896_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp896_.name);
	_tmp896_.name = _tmp894_;
	_g_free0 (_tmp896_.description);
	_tmp896_.description = _tmp895_;
	_tmp896_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp897_ = g_strdup ("model");
	_tmp898_ = g_strdup (_ ("Model"));
	memset (&_tmp899_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp899_.name);
	_tmp899_.name = _tmp897_;
	_g_free0 (_tmp899_.description);
	_tmp899_.description = _tmp898_;
	_tmp899_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp900_ = g_strdup ("office-contact");
	_tmp901_ = g_strdup (_ ("Contact file types"));
	memset (&_tmp902_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp902_.name);
	_tmp902_.name = _tmp900_;
	_g_free0 (_tmp902_.description);
	_tmp902_.description = _tmp901_;
	_tmp902_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp903_ = g_strdup ("office-database");
	_tmp904_ = g_strdup (_ ("Database file types"));
	memset (&_tmp905_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp905_.name);
	_tmp905_.name = _tmp903_;
	_g_free0 (_tmp905_.description);
	_tmp905_.description = _tmp904_;
	_tmp905_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp906_ = g_strdup ("package-x-generic");
	_tmp907_ = g_strdup (_ ("Generic package file types"));
	memset (&_tmp908_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp908_.name);
	_tmp908_.name = _tmp906_;
	_g_free0 (_tmp908_.description);
	_tmp908_.description = _tmp907_;
	_tmp908_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp909_ = g_strdup ("payment-card");
	_tmp910_ = g_strdup (_ ("Credit or debit card payments"));
	memset (&_tmp911_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp911_.name);
	_tmp911_.name = _tmp909_;
	_g_free0 (_tmp911_.description);
	_tmp911_.description = _tmp910_;
	_tmp911_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp912_ = g_strdup ("payment-card-amex");
	_tmp913_ = g_strdup (_ ("American Express branded credit or debit card payments"));
	memset (&_tmp914_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp914_.name);
	_tmp914_.name = _tmp912_;
	_g_free0 (_tmp914_.description);
	_tmp914_.description = _tmp913_;
	_tmp914_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp915_ = g_strdup ("payment-card-diners-club");
	_tmp916_ = g_strdup (_ ("Diner's Club branded credit or debit card payments"));
	memset (&_tmp917_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp917_.name);
	_tmp917_.name = _tmp915_;
	_g_free0 (_tmp917_.description);
	_tmp917_.description = _tmp916_;
	_tmp917_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp918_ = g_strdup ("payment-card-discover");
	_tmp919_ = g_strdup (_ ("Discover branded credit or debit card payments"));
	memset (&_tmp920_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp920_.name);
	_tmp920_.name = _tmp918_;
	_g_free0 (_tmp920_.description);
	_tmp920_.description = _tmp919_;
	_tmp920_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp921_ = g_strdup ("payment-card-jcb");
	_tmp922_ = g_strdup (_ ("Japan Credit Bureau branded credit or debit card payments"));
	memset (&_tmp923_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp923_.name);
	_tmp923_.name = _tmp921_;
	_g_free0 (_tmp923_.description);
	_tmp923_.description = _tmp922_;
	_tmp923_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp924_ = g_strdup ("payment-card-mastercard");
	_tmp925_ = g_strdup (_ ("Mastercard branded credit or debit card payments"));
	memset (&_tmp926_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp926_.name);
	_tmp926_.name = _tmp924_;
	_g_free0 (_tmp926_.description);
	_tmp926_.description = _tmp925_;
	_tmp926_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp927_ = g_strdup ("payment-card-unionpay");
	_tmp928_ = g_strdup (_ ("China UnionPay branded credit or debit card payments"));
	memset (&_tmp929_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp929_.name);
	_tmp929_.name = _tmp927_;
	_g_free0 (_tmp929_.description);
	_tmp929_.description = _tmp928_;
	_tmp929_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp930_ = g_strdup ("payment-card-visa");
	_tmp931_ = g_strdup (_ ("Visa branded credit or debit card payments"));
	memset (&_tmp932_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp932_.name);
	_tmp932_.name = _tmp930_;
	_g_free0 (_tmp932_.description);
	_tmp932_.description = _tmp931_;
	_tmp932_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp933_ = g_strdup ("text-css");
	_tmp934_ = g_strdup (_ ("CSS text file types"));
	memset (&_tmp935_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp935_.name);
	_tmp935_.name = _tmp933_;
	_g_free0 (_tmp935_.description);
	_tmp935_.description = _tmp934_;
	_tmp935_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp936_ = g_strdup ("text-html");
	_tmp937_ = g_strdup (_ ("HTML text file types"));
	memset (&_tmp938_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp938_.name);
	_tmp938_.name = _tmp936_;
	_g_free0 (_tmp938_.description);
	_tmp938_.description = _tmp937_;
	_tmp938_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp939_ = g_strdup ("text-markdown");
	_tmp940_ = g_strdup (_ ("Markdown text file types"));
	memset (&_tmp941_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp941_.name);
	_tmp941_.name = _tmp939_;
	_g_free0 (_tmp941_.description);
	_tmp941_.description = _tmp940_;
	_tmp941_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp942_ = g_strdup ("text-x-bibtex");
	_tmp943_ = g_strdup (_ ("Bibtext file types"));
	memset (&_tmp944_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp944_.name);
	_tmp944_.name = _tmp942_;
	_g_free0 (_tmp944_.description);
	_tmp944_.description = _tmp943_;
	_tmp944_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp945_ = g_strdup ("text-x-changelog");
	_tmp946_ = g_strdup (_ ("Changelog file types"));
	memset (&_tmp947_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp947_.name);
	_tmp947_.name = _tmp945_;
	_g_free0 (_tmp947_.description);
	_tmp947_.description = _tmp946_;
	_tmp947_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp948_ = g_strdup ("text-x-chdr");
	_tmp949_ = g_strdup (_ ("C programming language header file types"));
	memset (&_tmp950_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp950_.name);
	_tmp950_.name = _tmp948_;
	_g_free0 (_tmp950_.description);
	_tmp950_.description = _tmp949_;
	_tmp950_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp951_ = g_strdup ("text-x-copying");
	_tmp952_ = g_strdup (_ ("License file types"));
	memset (&_tmp953_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp953_.name);
	_tmp953_.name = _tmp951_;
	_g_free0 (_tmp953_.description);
	_tmp953_.description = _tmp952_;
	_tmp953_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp954_ = g_strdup ("text-x-csrc");
	_tmp955_ = g_strdup (_ ("C programming language file types"));
	memset (&_tmp956_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp956_.name);
	_tmp956_.name = _tmp954_;
	_g_free0 (_tmp956_.description);
	_tmp956_.description = _tmp955_;
	_tmp956_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp957_ = g_strdup ("text-x-generic");
	_tmp958_ = g_strdup (_ ("Generic text file types"));
	memset (&_tmp959_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp959_.name);
	_tmp959_.name = _tmp957_;
	_g_free0 (_tmp959_.description);
	_tmp959_.description = _tmp958_;
	_tmp959_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp960_ = g_strdup ("text-x-generic-template");
	_tmp961_ = g_strdup (_ ("Generic text templates"));
	memset (&_tmp962_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp962_.name);
	_tmp962_.name = _tmp960_;
	_g_free0 (_tmp962_.description);
	_tmp962_.description = _tmp961_;
	_tmp962_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp963_ = g_strdup ("text-x-gettext-translation");
	_tmp964_ = g_strdup (_ ("Gettext translation file types"));
	memset (&_tmp965_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp965_.name);
	_tmp965_.name = _tmp963_;
	_g_free0 (_tmp965_.description);
	_tmp965_.description = _tmp964_;
	_tmp965_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp966_ = g_strdup ("text-x-gettext-translation-template");
	_tmp967_ = g_strdup (_ ("Gettext translation model file types"));
	memset (&_tmp968_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp968_.name);
	_tmp968_.name = _tmp966_;
	_g_free0 (_tmp968_.description);
	_tmp968_.description = _tmp967_;
	_tmp968_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp969_ = g_strdup ("text-x-go");
	_tmp970_ = g_strdup (_ ("Go programming language file types"));
	memset (&_tmp971_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp971_.name);
	_tmp971_.name = _tmp969_;
	_g_free0 (_tmp971_.description);
	_tmp971_.description = _tmp970_;
	_tmp971_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp972_ = g_strdup ("text-x-install");
	_tmp973_ = g_strdup (_ ("Install file types"));
	memset (&_tmp974_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp974_.name);
	_tmp974_.name = _tmp972_;
	_g_free0 (_tmp974_.description);
	_tmp974_.description = _tmp973_;
	_tmp974_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp975_ = g_strdup ("text-x-makefile");
	_tmp976_ = g_strdup (_ ("Makefile file types"));
	memset (&_tmp977_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp977_.name);
	_tmp977_.name = _tmp975_;
	_g_free0 (_tmp977_.description);
	_tmp977_.description = _tmp976_;
	_tmp977_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp978_ = g_strdup ("text-x-preview");
	_tmp979_ = g_strdup (_ ("Preview file types"));
	memset (&_tmp980_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp980_.name);
	_tmp980_.name = _tmp978_;
	_g_free0 (_tmp980_.description);
	_tmp980_.description = _tmp979_;
	_tmp980_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp981_ = g_strdup ("text-x-python");
	_tmp982_ = g_strdup (_ ("Python programming language file types"));
	memset (&_tmp983_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp983_.name);
	_tmp983_.name = _tmp981_;
	_g_free0 (_tmp983_.description);
	_tmp983_.description = _tmp982_;
	_tmp983_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp984_ = g_strdup ("text-x-readme");
	_tmp985_ = g_strdup (_ ("Readme file types"));
	memset (&_tmp986_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp986_.name);
	_tmp986_.name = _tmp984_;
	_g_free0 (_tmp986_.description);
	_tmp986_.description = _tmp985_;
	_tmp986_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp987_ = g_strdup ("text-x-sass");
	_tmp988_ = g_strdup (_ ("Sass programming language file types"));
	memset (&_tmp989_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp989_.name);
	_tmp989_.name = _tmp987_;
	_g_free0 (_tmp989_.description);
	_tmp989_.description = _tmp988_;
	_tmp989_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp990_ = g_strdup ("text-x-script");
	_tmp991_ = g_strdup (_ ("Script file types, such as shell scripts"));
	memset (&_tmp992_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp992_.name);
	_tmp992_.name = _tmp990_;
	_g_free0 (_tmp992_.description);
	_tmp992_.description = _tmp991_;
	_tmp992_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp993_ = g_strdup ("text-x-ssa");
	_tmp994_ = g_strdup (_ ("SSA file types"));
	memset (&_tmp995_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp995_.name);
	_tmp995_.name = _tmp993_;
	_g_free0 (_tmp995_.description);
	_tmp995_.description = _tmp994_;
	_tmp995_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp996_ = g_strdup ("text-x-tex");
	_tmp997_ = g_strdup (_ ("TEX file types"));
	memset (&_tmp998_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp998_.name);
	_tmp998_.name = _tmp996_;
	_g_free0 (_tmp998_.description);
	_tmp998_.description = _tmp997_;
	_tmp998_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp999_ = g_strdup ("text-x-vala");
	_tmp1000_ = g_strdup (_ ("Vala programming language file types"));
	memset (&_tmp1001_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1001_.name);
	_tmp1001_.name = _tmp999_;
	_g_free0 (_tmp1001_.description);
	_tmp1001_.description = _tmp1000_;
	_tmp1001_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1002_ = g_strdup ("unknown");
	_tmp1003_ = g_strdup (_ ("Unknown file types"));
	memset (&_tmp1004_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1004_.name);
	_tmp1004_.name = _tmp1002_;
	_g_free0 (_tmp1004_.description);
	_tmp1004_.description = _tmp1003_;
	_tmp1004_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1005_ = g_strdup ("video-x-generic");
	_tmp1006_ = g_strdup (_ ("Generic video file types"));
	memset (&_tmp1007_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1007_.name);
	_tmp1007_.name = _tmp1005_;
	_g_free0 (_tmp1007_.description);
	_tmp1007_.description = _tmp1006_;
	_tmp1007_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1008_ = g_strdup ("x-office-address-book");
	_tmp1009_ = g_strdup (_ ("Generic address book file types"));
	memset (&_tmp1010_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1010_.name);
	_tmp1010_.name = _tmp1008_;
	_g_free0 (_tmp1010_.description);
	_tmp1010_.description = _tmp1009_;
	_tmp1010_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1011_ = g_strdup ("x-office-calendar");
	_tmp1012_ = g_strdup (_ ("Generic calendar file types"));
	memset (&_tmp1013_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1013_.name);
	_tmp1013_.name = _tmp1011_;
	_g_free0 (_tmp1013_.description);
	_tmp1013_.description = _tmp1012_;
	_tmp1013_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1014_ = g_strdup ("x-office-document");
	_tmp1015_ = g_strdup (_ ("Generic document and letter file types"));
	memset (&_tmp1016_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1016_.name);
	_tmp1016_.name = _tmp1014_;
	_g_free0 (_tmp1016_.description);
	_tmp1016_.description = _tmp1015_;
	_tmp1016_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1017_ = g_strdup ("x-office-document-template");
	_tmp1018_ = g_strdup (_ ("Generic document and letter template file types"));
	memset (&_tmp1019_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1019_.name);
	_tmp1019_.name = _tmp1017_;
	_g_free0 (_tmp1019_.description);
	_tmp1019_.description = _tmp1018_;
	_tmp1019_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1020_ = g_strdup ("x-office-drawing");
	_tmp1021_ = g_strdup (_ ("Generic drawing file types"));
	memset (&_tmp1022_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1022_.name);
	_tmp1022_.name = _tmp1020_;
	_g_free0 (_tmp1022_.description);
	_tmp1022_.description = _tmp1021_;
	_tmp1022_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1023_ = g_strdup ("x-office-drawing-template");
	_tmp1024_ = g_strdup (_ ("Generic drawing template file types"));
	memset (&_tmp1025_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1025_.name);
	_tmp1025_.name = _tmp1023_;
	_g_free0 (_tmp1025_.description);
	_tmp1025_.description = _tmp1024_;
	_tmp1025_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1026_ = g_strdup ("x-office-presentation");
	_tmp1027_ = g_strdup (_ ("Generic presentation file types"));
	memset (&_tmp1028_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1028_.name);
	_tmp1028_.name = _tmp1026_;
	_g_free0 (_tmp1028_.description);
	_tmp1028_.description = _tmp1027_;
	_tmp1028_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1029_ = g_strdup ("x-office-presentation-template");
	_tmp1030_ = g_strdup (_ ("Generic presentation template file types"));
	memset (&_tmp1031_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1031_.name);
	_tmp1031_.name = _tmp1029_;
	_g_free0 (_tmp1031_.description);
	_tmp1031_.description = _tmp1030_;
	_tmp1031_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1032_ = g_strdup ("x-office-spreadsheet");
	_tmp1033_ = g_strdup (_ ("Generic spreadsheet file types"));
	memset (&_tmp1034_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1034_.name);
	_tmp1034_.name = _tmp1032_;
	_g_free0 (_tmp1034_.description);
	_tmp1034_.description = _tmp1033_;
	_tmp1034_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1035_ = g_strdup ("x-office-spreadsheet-template");
	_tmp1036_ = g_strdup (_ ("Generic spreadsheet template file types"));
	memset (&_tmp1037_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1037_.name);
	_tmp1037_.name = _tmp1035_;
	_g_free0 (_tmp1037_.description);
	_tmp1037_.description = _tmp1036_;
	_tmp1037_.category = ICON_COLLECTION_CATEGORY_MIMES;
	_tmp1038_ = g_strdup ("bookmark-missing");
	_tmp1039_ = g_strdup (_ ("Bookmark missing"));
	memset (&_tmp1040_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1040_.name);
	_tmp1040_.name = _tmp1038_;
	_g_free0 (_tmp1040_.description);
	_tmp1040_.description = _tmp1039_;
	_tmp1040_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1041_ = g_strdup ("distributor-logo");
	_tmp1042_ = g_strdup (_ ("Distributor logo"));
	memset (&_tmp1043_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1043_.name);
	_tmp1043_.name = _tmp1041_;
	_g_free0 (_tmp1043_.description);
	_tmp1043_.description = _tmp1042_;
	_tmp1043_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1044_ = g_strdup ("folder");
	_tmp1045_ = g_strdup (_ ("Folder"));
	memset (&_tmp1046_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1046_.name);
	_tmp1046_.name = _tmp1044_;
	_g_free0 (_tmp1046_.description);
	_tmp1046_.description = _tmp1045_;
	_tmp1046_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1047_ = g_strdup ("folder-documents");
	_tmp1048_ = g_strdup (_ ("Documents folder"));
	memset (&_tmp1049_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1049_.name);
	_tmp1049_.name = _tmp1047_;
	_g_free0 (_tmp1049_.description);
	_tmp1049_.description = _tmp1048_;
	_tmp1049_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1050_ = g_strdup ("folder-download");
	_tmp1051_ = g_strdup (_ ("Downloads folder"));
	memset (&_tmp1052_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1052_.name);
	_tmp1052_.name = _tmp1050_;
	_g_free0 (_tmp1052_.description);
	_tmp1052_.description = _tmp1051_;
	_tmp1052_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1053_ = g_strdup ("folder-drag-accept");
	_tmp1054_ = g_strdup (_ ("Folder drag accept"));
	memset (&_tmp1055_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1055_.name);
	_tmp1055_.name = _tmp1053_;
	_g_free0 (_tmp1055_.description);
	_tmp1055_.description = _tmp1054_;
	_tmp1055_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1056_ = g_strdup ("folder-music");
	_tmp1057_ = g_strdup (_ ("Music folder"));
	memset (&_tmp1058_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1058_.name);
	_tmp1058_.name = _tmp1056_;
	_g_free0 (_tmp1058_.description);
	_tmp1058_.description = _tmp1057_;
	_tmp1058_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1059_ = g_strdup ("folder-open");
	_tmp1060_ = g_strdup (_ ("Open folder"));
	memset (&_tmp1061_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1061_.name);
	_tmp1061_.name = _tmp1059_;
	_g_free0 (_tmp1061_.description);
	_tmp1061_.description = _tmp1060_;
	_tmp1061_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1062_ = g_strdup ("folder-pictures");
	_tmp1063_ = g_strdup (_ ("Pictures folder"));
	memset (&_tmp1064_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1064_.name);
	_tmp1064_.name = _tmp1062_;
	_g_free0 (_tmp1064_.description);
	_tmp1064_.description = _tmp1063_;
	_tmp1064_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1065_ = g_strdup ("folder-publicshare");
	_tmp1066_ = g_strdup (_ ("Publicshare folder"));
	memset (&_tmp1067_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1067_.name);
	_tmp1067_.name = _tmp1065_;
	_g_free0 (_tmp1067_.description);
	_tmp1067_.description = _tmp1066_;
	_tmp1067_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1068_ = g_strdup ("folder-recent");
	_tmp1069_ = g_strdup (_ ("Recent folder"));
	memset (&_tmp1070_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1070_.name);
	_tmp1070_.name = _tmp1068_;
	_g_free0 (_tmp1070_.description);
	_tmp1070_.description = _tmp1069_;
	_tmp1070_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1071_ = g_strdup ("folder-remote");
	_tmp1072_ = g_strdup (_ ("Remote folder"));
	memset (&_tmp1073_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1073_.name);
	_tmp1073_.name = _tmp1071_;
	_g_free0 (_tmp1073_.description);
	_tmp1073_.description = _tmp1072_;
	_tmp1073_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1074_ = g_strdup ("folder-saved-search");
	_tmp1075_ = g_strdup (_ ("Saved search folder"));
	memset (&_tmp1076_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1076_.name);
	_tmp1076_.name = _tmp1074_;
	_g_free0 (_tmp1076_.description);
	_tmp1076_.description = _tmp1075_;
	_tmp1076_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1077_ = g_strdup ("folder-templates");
	_tmp1078_ = g_strdup (_ ("Templates folder"));
	memset (&_tmp1079_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1079_.name);
	_tmp1079_.name = _tmp1077_;
	_g_free0 (_tmp1079_.description);
	_tmp1079_.description = _tmp1078_;
	_tmp1079_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1080_ = g_strdup ("folder-videos");
	_tmp1081_ = g_strdup (_ ("Videos folder"));
	memset (&_tmp1082_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1082_.name);
	_tmp1082_.name = _tmp1080_;
	_g_free0 (_tmp1082_.description);
	_tmp1082_.description = _tmp1081_;
	_tmp1082_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1083_ = g_strdup ("internet-radio");
	_tmp1084_ = g_strdup (_ ("Internet radio"));
	memset (&_tmp1085_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1085_.name);
	_tmp1085_.name = _tmp1083_;
	_g_free0 (_tmp1085_.description);
	_tmp1085_.description = _tmp1084_;
	_tmp1085_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1086_ = g_strdup ("library-audiobook");
	_tmp1087_ = g_strdup (_ ("Audiobook library"));
	memset (&_tmp1088_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1088_.name);
	_tmp1088_.name = _tmp1086_;
	_g_free0 (_tmp1088_.description);
	_tmp1088_.description = _tmp1087_;
	_tmp1088_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1089_ = g_strdup ("library-places");
	_tmp1090_ = g_strdup (_ ("Library places"));
	memset (&_tmp1091_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1091_.name);
	_tmp1091_.name = _tmp1089_;
	_g_free0 (_tmp1091_.description);
	_tmp1091_.description = _tmp1090_;
	_tmp1091_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1092_ = g_strdup ("library-podcast");
	_tmp1093_ = g_strdup (_ ("Podcast library"));
	memset (&_tmp1094_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1094_.name);
	_tmp1094_.name = _tmp1092_;
	_g_free0 (_tmp1094_.description);
	_tmp1094_.description = _tmp1093_;
	_tmp1094_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1095_ = g_strdup ("mail-inbox");
	_tmp1096_ = g_strdup (_ ("Mail inbox"));
	memset (&_tmp1097_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1097_.name);
	_tmp1097_.name = _tmp1095_;
	_g_free0 (_tmp1097_.description);
	_tmp1097_.description = _tmp1096_;
	_tmp1097_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1098_ = g_strdup ("mail-mailbox");
	_tmp1099_ = g_strdup (_ ("Mail mailbox"));
	memset (&_tmp1100_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1100_.name);
	_tmp1100_.name = _tmp1098_;
	_g_free0 (_tmp1100_.description);
	_tmp1100_.description = _tmp1099_;
	_tmp1100_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1101_ = g_strdup ("mail-outbox");
	_tmp1102_ = g_strdup (_ ("Mail outbox"));
	memset (&_tmp1103_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1103_.name);
	_tmp1103_.name = _tmp1101_;
	_g_free0 (_tmp1103_.description);
	_tmp1103_.description = _tmp1102_;
	_tmp1103_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1104_ = g_strdup ("mail-sent");
	_tmp1105_ = g_strdup (_ ("Mail sent"));
	memset (&_tmp1106_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1106_.name);
	_tmp1106_.name = _tmp1104_;
	_g_free0 (_tmp1106_.description);
	_tmp1106_.description = _tmp1105_;
	_tmp1106_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1107_ = g_strdup ("network-server");
	_tmp1108_ = g_strdup (_ ("Network server"));
	memset (&_tmp1109_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1109_.name);
	_tmp1109_.name = _tmp1107_;
	_g_free0 (_tmp1109_.description);
	_tmp1109_.description = _tmp1108_;
	_tmp1109_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1110_ = g_strdup ("network-workgroup");
	_tmp1111_ = g_strdup (_ ("Network workgroup"));
	memset (&_tmp1112_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1112_.name);
	_tmp1112_.name = _tmp1110_;
	_g_free0 (_tmp1112_.description);
	_tmp1112_.description = _tmp1111_;
	_tmp1112_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1113_ = g_strdup ("playlist");
	_tmp1114_ = g_strdup (_ ("Playlist"));
	memset (&_tmp1115_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1115_.name);
	_tmp1115_.name = _tmp1113_;
	_g_free0 (_tmp1115_.description);
	_tmp1115_.description = _tmp1114_;
	_tmp1115_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1116_ = g_strdup ("playlist-automatic");
	_tmp1117_ = g_strdup (_ ("Automatic playlist"));
	memset (&_tmp1118_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1118_.name);
	_tmp1118_.name = _tmp1116_;
	_g_free0 (_tmp1118_.description);
	_tmp1118_.description = _tmp1117_;
	_tmp1118_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1119_ = g_strdup ("playlist-queue");
	_tmp1120_ = g_strdup (_ ("Playlist queue"));
	memset (&_tmp1121_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1121_.name);
	_tmp1121_.name = _tmp1119_;
	_g_free0 (_tmp1121_.description);
	_tmp1121_.description = _tmp1120_;
	_tmp1121_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1122_ = g_strdup ("playlist-similar");
	_tmp1123_ = g_strdup (_ ("Similar playlist"));
	memset (&_tmp1124_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1124_.name);
	_tmp1124_.name = _tmp1122_;
	_g_free0 (_tmp1124_.description);
	_tmp1124_.description = _tmp1123_;
	_tmp1124_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1125_ = g_strdup ("tag");
	_tmp1126_ = g_strdup (_ ("Tag"));
	memset (&_tmp1127_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1127_.name);
	_tmp1127_.name = _tmp1125_;
	_g_free0 (_tmp1127_.description);
	_tmp1127_.description = _tmp1126_;
	_tmp1127_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1128_ = g_strdup ("user-bookmarks");
	_tmp1129_ = g_strdup (_ ("Bookmarks"));
	memset (&_tmp1130_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1130_.name);
	_tmp1130_.name = _tmp1128_;
	_g_free0 (_tmp1130_.description);
	_tmp1130_.description = _tmp1129_;
	_tmp1130_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1131_ = g_strdup ("user-home");
	_tmp1132_ = g_strdup (_ ("Home"));
	memset (&_tmp1133_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1133_.name);
	_tmp1133_.name = _tmp1131_;
	_g_free0 (_tmp1133_.description);
	_tmp1133_.description = _tmp1132_;
	_tmp1133_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1134_ = g_strdup ("user-trash");
	_tmp1135_ = g_strdup (_ ("Trash"));
	memset (&_tmp1136_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1136_.name);
	_tmp1136_.name = _tmp1134_;
	_g_free0 (_tmp1136_.description);
	_tmp1136_.description = _tmp1135_;
	_tmp1136_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1137_ = g_strdup ("user-trash-full");
	_tmp1138_ = g_strdup (_ ("Trash full"));
	memset (&_tmp1139_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1139_.name);
	_tmp1139_.name = _tmp1137_;
	_g_free0 (_tmp1139_.description);
	_tmp1139_.description = _tmp1138_;
	_tmp1139_.category = ICON_COLLECTION_CATEGORY_PLACES;
	_tmp1140_ = g_strdup ("airplane-mode");
	_tmp1141_ = g_strdup (_ ("Airplane mode, where wireless radios are disabled or off"));
	memset (&_tmp1142_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1142_.name);
	_tmp1142_.name = _tmp1140_;
	_g_free0 (_tmp1142_.description);
	_tmp1142_.description = _tmp1141_;
	_tmp1142_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1143_ = g_strdup ("appointment-missed");
	_tmp1144_ = g_strdup (_ ("An appointment or calendar event was missed"));
	memset (&_tmp1145_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1145_.name);
	_tmp1145_.name = _tmp1143_;
	_g_free0 (_tmp1145_.description);
	_tmp1145_.description = _tmp1144_;
	_tmp1145_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1146_ = g_strdup ("appointment-soon");
	_tmp1147_ = g_strdup (_ ("An appointment or calendar event will be happening soon"));
	memset (&_tmp1148_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1148_.name);
	_tmp1148_.name = _tmp1146_;
	_g_free0 (_tmp1148_.description);
	_tmp1148_.description = _tmp1147_;
	_tmp1148_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1149_ = g_strdup ("audio-volume-high");
	_tmp1150_ = g_strdup (_ ("High or loud audio volume"));
	memset (&_tmp1151_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1151_.name);
	_tmp1151_.name = _tmp1149_;
	_g_free0 (_tmp1151_.description);
	_tmp1151_.description = _tmp1150_;
	_tmp1151_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1152_ = g_strdup ("audio-volume-low");
	_tmp1153_ = g_strdup (_ ("Low or quiet audio volume"));
	memset (&_tmp1154_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1154_.name);
	_tmp1154_.name = _tmp1152_;
	_g_free0 (_tmp1154_.description);
	_tmp1154_.description = _tmp1153_;
	_tmp1154_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1155_ = g_strdup ("audio-volume-medium");
	_tmp1156_ = g_strdup (_ ("Medium or normal audio volume"));
	memset (&_tmp1157_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1157_.name);
	_tmp1157_.name = _tmp1155_;
	_g_free0 (_tmp1157_.description);
	_tmp1157_.description = _tmp1156_;
	_tmp1157_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1158_ = g_strdup ("audio-volume-muted");
	_tmp1159_ = g_strdup (_ ("Audio volume is muted or off"));
	memset (&_tmp1160_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1160_.name);
	_tmp1160_.name = _tmp1158_;
	_g_free0 (_tmp1160_.description);
	_tmp1160_.description = _tmp1159_;
	_tmp1160_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1161_ = g_strdup ("audio-volume-muted-blocking");
	_tmp1162_ = g_strdup (_ ("Audio volume is muted or off and something is being blocked from makin" \
"g noise"));
	memset (&_tmp1163_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1163_.name);
	_tmp1163_.name = _tmp1161_;
	_g_free0 (_tmp1163_.description);
	_tmp1163_.description = _tmp1162_;
	_tmp1163_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1164_ = g_strdup ("avatar-default");
	_tmp1165_ = g_strdup (_ ("The default avatar to represent a user, such as someone who has not se" \
"t a profile picture"));
	memset (&_tmp1166_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1166_.name);
	_tmp1166_.name = _tmp1164_;
	_g_free0 (_tmp1166_.description);
	_tmp1166_.description = _tmp1165_;
	_tmp1166_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1167_ = g_strdup ("battery-ac-adapter");
	_tmp1168_ = g_strdup (_ ("A charger or AC adapter for a battery-powered device"));
	memset (&_tmp1169_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1169_.name);
	_tmp1169_.name = _tmp1167_;
	_g_free0 (_tmp1169_.description);
	_tmp1169_.description = _tmp1168_;
	_tmp1169_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1170_ = g_strdup ("battery-caution");
	_tmp1171_ = g_strdup (_ ("Low battery level"));
	memset (&_tmp1172_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1172_.name);
	_tmp1172_.name = _tmp1170_;
	_g_free0 (_tmp1172_.description);
	_tmp1172_.description = _tmp1171_;
	_tmp1172_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1173_ = g_strdup ("battery-caution-charging");
	_tmp1174_ = g_strdup (_ ("Low battery level, plugged into a charger or AC adapter"));
	memset (&_tmp1175_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1175_.name);
	_tmp1175_.name = _tmp1173_;
	_g_free0 (_tmp1175_.description);
	_tmp1175_.description = _tmp1174_;
	_tmp1175_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1176_ = g_strdup ("battery-empty");
	_tmp1177_ = g_strdup (_ ("Critically low battery level"));
	memset (&_tmp1178_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1178_.name);
	_tmp1178_.name = _tmp1176_;
	_g_free0 (_tmp1178_.description);
	_tmp1178_.description = _tmp1177_;
	_tmp1178_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1179_ = g_strdup ("battery-empty-charging");
	_tmp1180_ = g_strdup (_ ("Critically low battery, plugged into a charger or AC adapter"));
	memset (&_tmp1181_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1181_.name);
	_tmp1181_.name = _tmp1179_;
	_g_free0 (_tmp1181_.description);
	_tmp1181_.description = _tmp1180_;
	_tmp1181_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1182_ = g_strdup ("battery-full");
	_tmp1183_ = g_strdup (_ ("Mostly charged battery level"));
	memset (&_tmp1184_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1184_.name);
	_tmp1184_.name = _tmp1182_;
	_g_free0 (_tmp1184_.description);
	_tmp1184_.description = _tmp1183_;
	_tmp1184_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1185_ = g_strdup ("battery-full-charged");
	_tmp1186_ = g_strdup (_ ("Completely charged battery level"));
	memset (&_tmp1187_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1187_.name);
	_tmp1187_.name = _tmp1185_;
	_g_free0 (_tmp1187_.description);
	_tmp1187_.description = _tmp1186_;
	_tmp1187_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1188_ = g_strdup ("battery-full-charging");
	_tmp1189_ = g_strdup (_ ("Mostly charged battery level, plugged into a charger or AC adapter"));
	memset (&_tmp1190_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1190_.name);
	_tmp1190_.name = _tmp1188_;
	_g_free0 (_tmp1190_.description);
	_tmp1190_.description = _tmp1189_;
	_tmp1190_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1191_ = g_strdup ("battery-good");
	_tmp1192_ = g_strdup (_ ("Medium-high charged battery level"));
	memset (&_tmp1193_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1193_.name);
	_tmp1193_.name = _tmp1191_;
	_g_free0 (_tmp1193_.description);
	_tmp1193_.description = _tmp1192_;
	_tmp1193_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1194_ = g_strdup ("battery-good-charging");
	_tmp1195_ = g_strdup (_ ("Medium-high charged battery level, plugged into a charger or AC adapte" \
"r"));
	memset (&_tmp1196_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1196_.name);
	_tmp1196_.name = _tmp1194_;
	_g_free0 (_tmp1196_.description);
	_tmp1196_.description = _tmp1195_;
	_tmp1196_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1197_ = g_strdup ("battery-low");
	_tmp1198_ = g_strdup (_ ("Medium-low charged battery level"));
	memset (&_tmp1199_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1199_.name);
	_tmp1199_.name = _tmp1197_;
	_g_free0 (_tmp1199_.description);
	_tmp1199_.description = _tmp1198_;
	_tmp1199_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1200_ = g_strdup ("battery-low-charging");
	_tmp1201_ = g_strdup (_ ("Medium-low charged battery level, plugged into a charger or AC adapter"));
	memset (&_tmp1202_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1202_.name);
	_tmp1202_.name = _tmp1200_;
	_g_free0 (_tmp1202_.description);
	_tmp1202_.description = _tmp1201_;
	_tmp1202_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1203_ = g_strdup ("battery-missing");
	_tmp1204_ = g_strdup (_ ("Missing or malfunctioning battery"));
	memset (&_tmp1205_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1205_.name);
	_tmp1205_.name = _tmp1203_;
	_g_free0 (_tmp1205_.description);
	_tmp1205_.description = _tmp1204_;
	_tmp1205_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1206_ = g_strdup ("changes-allow");
	_tmp1207_ = g_strdup (_ ("Allow changes by unlocking such as with a password"));
	memset (&_tmp1208_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1208_.name);
	_tmp1208_.name = _tmp1206_;
	_g_free0 (_tmp1208_.description);
	_tmp1208_.description = _tmp1207_;
	_tmp1208_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1209_ = g_strdup ("changes-prevent");
	_tmp1210_ = g_strdup (_ ("Prevent changes by locking such as with a password"));
	memset (&_tmp1211_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1211_.name);
	_tmp1211_.name = _tmp1209_;
	_g_free0 (_tmp1211_.description);
	_tmp1211_.description = _tmp1210_;
	_tmp1211_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1212_ = g_strdup ("channel-insecure");
	_tmp1213_ = g_strdup (_ ("Insecure, unsecure, or unencrypted communication or connection, such a" \
"s HTTP"));
	memset (&_tmp1214_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1214_.name);
	_tmp1214_.name = _tmp1212_;
	_g_free0 (_tmp1214_.description);
	_tmp1214_.description = _tmp1213_;
	_tmp1214_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1215_ = g_strdup ("channel-secure");
	_tmp1216_ = g_strdup (_ ("Secure or encrypted communication or connection, such as HTTPS or encr" \
"ypted Wi-Fi"));
	memset (&_tmp1217_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1217_.name);
	_tmp1217_.name = _tmp1215_;
	_g_free0 (_tmp1217_.description);
	_tmp1217_.description = _tmp1216_;
	_tmp1217_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1218_ = g_strdup ("dialog-error");
	_tmp1219_ = g_strdup (_ ("Critical, unrecoverable, or other serious error"));
	memset (&_tmp1220_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1220_.name);
	_tmp1220_.name = _tmp1218_;
	_g_free0 (_tmp1220_.description);
	_tmp1220_.description = _tmp1219_;
	_tmp1220_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1221_ = g_strdup ("dialog-information");
	_tmp1222_ = g_strdup (_ ("Contextual information or explanation"));
	memset (&_tmp1223_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1223_.name);
	_tmp1223_.name = _tmp1221_;
	_g_free0 (_tmp1223_.description);
	_tmp1223_.description = _tmp1222_;
	_tmp1223_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1224_ = g_strdup ("dialog-password");
	_tmp1225_ = g_strdup (_ ("Requesting authentication details, such as a password or encryption ke" \
"y"));
	memset (&_tmp1226_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1226_.name);
	_tmp1226_.name = _tmp1224_;
	_g_free0 (_tmp1226_.description);
	_tmp1226_.description = _tmp1225_;
	_tmp1226_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1227_ = g_strdup ("dialog-question");
	_tmp1228_ = g_strdup (_ ("Question, decision, or choice for the user"));
	memset (&_tmp1229_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1229_.name);
	_tmp1229_.name = _tmp1227_;
	_g_free0 (_tmp1229_.description);
	_tmp1229_.description = _tmp1228_;
	_tmp1229_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1230_ = g_strdup ("dialog-warning");
	_tmp1231_ = g_strdup (_ ("Warning of potentially dangerous actions or consequences"));
	memset (&_tmp1232_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1232_.name);
	_tmp1232_.name = _tmp1230_;
	_g_free0 (_tmp1232_.description);
	_tmp1232_.description = _tmp1231_;
	_tmp1232_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1233_ = g_strdup ("image-loading");
	_tmp1234_ = g_strdup (_ ("Placeholder used when an image or thumbnail is loading"));
	memset (&_tmp1235_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1235_.name);
	_tmp1235_.name = _tmp1233_;
	_g_free0 (_tmp1235_.description);
	_tmp1235_.description = _tmp1234_;
	_tmp1235_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1236_ = g_strdup ("image-missing");
	_tmp1237_ = g_strdup (_ ("Placeholder used when an image or thumbnail is missing or cannot be lo" \
"aded"));
	memset (&_tmp1238_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1238_.name);
	_tmp1238_.name = _tmp1236_;
	_g_free0 (_tmp1238_.description);
	_tmp1238_.description = _tmp1237_;
	_tmp1238_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1239_ = g_strdup ("location-active");
	_tmp1240_ = g_strdup (_ ("Location services are in use"));
	memset (&_tmp1241_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1241_.name);
	_tmp1241_.name = _tmp1239_;
	_g_free0 (_tmp1241_.description);
	_tmp1241_.description = _tmp1240_;
	_tmp1241_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1242_ = g_strdup ("location-disabled");
	_tmp1243_ = g_strdup (_ ("Location services are disabled and unavailable"));
	memset (&_tmp1244_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1244_.name);
	_tmp1244_.name = _tmp1242_;
	_g_free0 (_tmp1244_.description);
	_tmp1244_.description = _tmp1243_;
	_tmp1244_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1245_ = g_strdup ("location-inactive");
	_tmp1246_ = g_strdup (_ ("Location services are available, but not in use"));
	memset (&_tmp1247_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1247_.name);
	_tmp1247_.name = _tmp1245_;
	_g_free0 (_tmp1247_.description);
	_tmp1247_.description = _tmp1246_;
	_tmp1247_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1248_ = g_strdup ("locked");
	_tmp1249_ = g_strdup (_ ("Locked or secured, typically requiring authentication or a password to" \
" unlock"));
	memset (&_tmp1250_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1250_.name);
	_tmp1250_.name = _tmp1248_;
	_g_free0 (_tmp1250_.description);
	_tmp1250_.description = _tmp1249_;
	_tmp1250_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1251_ = g_strdup ("mail-attachment");
	_tmp1252_ = g_strdup (_ ("Mail attachment or file in an email"));
	memset (&_tmp1253_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1253_.name);
	_tmp1253_.name = _tmp1251_;
	_g_free0 (_tmp1253_.description);
	_tmp1253_.description = _tmp1252_;
	_tmp1253_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1254_ = g_strdup ("mail-unread");
	_tmp1255_ = g_strdup (_ ("New, unread, or unviewed email"));
	memset (&_tmp1256_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1256_.name);
	_tmp1256_.name = _tmp1254_;
	_g_free0 (_tmp1256_.description);
	_tmp1256_.description = _tmp1255_;
	_tmp1256_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1257_ = g_strdup ("mail-read");
	_tmp1258_ = g_strdup (_ ("Read or already-viewed email"));
	memset (&_tmp1259_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1259_.name);
	_tmp1259_.name = _tmp1257_;
	_g_free0 (_tmp1259_.description);
	_tmp1259_.description = _tmp1258_;
	_tmp1259_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1260_ = g_strdup ("mail-replied");
	_tmp1261_ = g_strdup (_ ("Email that has been replied or responded to"));
	memset (&_tmp1262_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1262_.name);
	_tmp1262_.name = _tmp1260_;
	_g_free0 (_tmp1262_.description);
	_tmp1262_.description = _tmp1261_;
	_tmp1262_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1263_ = g_strdup ("mail-signed");
	_tmp1264_ = g_strdup (_ ("Email that contains a signature"));
	memset (&_tmp1265_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1265_.name);
	_tmp1265_.name = _tmp1263_;
	_g_free0 (_tmp1265_.description);
	_tmp1265_.description = _tmp1264_;
	_tmp1265_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1266_ = g_strdup ("mail-signed-verified");
	_tmp1267_ = g_strdup (_ ("Email that contains a signature that is verified by the security syste" \
"m"));
	memset (&_tmp1268_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1268_.name);
	_tmp1268_.name = _tmp1266_;
	_g_free0 (_tmp1268_.description);
	_tmp1268_.description = _tmp1267_;
	_tmp1268_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1269_ = g_strdup ("media-playlist-repeat");
	_tmp1270_ = g_strdup (_ ("Repeat a song, video, track, album, playlist, or other media"));
	memset (&_tmp1271_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1271_.name);
	_tmp1271_.name = _tmp1269_;
	_g_free0 (_tmp1271_.description);
	_tmp1271_.description = _tmp1270_;
	_tmp1271_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1272_ = g_strdup ("media-playlist-shuffle");
	_tmp1273_ = g_strdup (_ ("Shuffle or randomize an album, playlist, or other media"));
	memset (&_tmp1274_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1274_.name);
	_tmp1274_.name = _tmp1272_;
	_g_free0 (_tmp1274_.description);
	_tmp1274_.description = _tmp1273_;
	_tmp1274_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1275_ = g_strdup ("network-error");
	_tmp1276_ = g_strdup (_ ("Error or problem initializing or creating a network connection"));
	memset (&_tmp1277_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1277_.name);
	_tmp1277_.name = _tmp1275_;
	_g_free0 (_tmp1277_.description);
	_tmp1277_.description = _tmp1276_;
	_tmp1277_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1278_ = g_strdup ("network-idle");
	_tmp1279_ = g_strdup (_ ("No data being transmitted or received while connected to a network"));
	memset (&_tmp1280_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1280_.name);
	_tmp1280_.name = _tmp1278_;
	_g_free0 (_tmp1280_.description);
	_tmp1280_.description = _tmp1279_;
	_tmp1280_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1281_ = g_strdup ("network-offline");
	_tmp1282_ = g_strdup (_ ("Disconnected or offline from a network"));
	memset (&_tmp1283_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1283_.name);
	_tmp1283_.name = _tmp1281_;
	_g_free0 (_tmp1283_.description);
	_tmp1283_.description = _tmp1282_;
	_tmp1283_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1284_ = g_strdup ("network-receive");
	_tmp1285_ = g_strdup (_ ("Data is being received over a network"));
	memset (&_tmp1286_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1286_.name);
	_tmp1286_.name = _tmp1284_;
	_g_free0 (_tmp1286_.description);
	_tmp1286_.description = _tmp1285_;
	_tmp1286_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1287_ = g_strdup ("network-transmit");
	_tmp1288_ = g_strdup (_ ("Data is being transmitted over a network"));
	memset (&_tmp1289_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1289_.name);
	_tmp1289_.name = _tmp1287_;
	_g_free0 (_tmp1289_.description);
	_tmp1289_.description = _tmp1288_;
	_tmp1289_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1290_ = g_strdup ("network-transmit-receive");
	_tmp1291_ = g_strdup (_ ("Data is being both transmitted and received simultaneously over a netw" \
"ork"));
	memset (&_tmp1292_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1292_.name);
	_tmp1292_.name = _tmp1290_;
	_g_free0 (_tmp1292_.description);
	_tmp1292_.description = _tmp1291_;
	_tmp1292_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1293_ = g_strdup ("network-wired-disconnected");
	_tmp1294_ = g_strdup (_ ("Wired network, such as Ethernet, is disconnected"));
	memset (&_tmp1295_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1295_.name);
	_tmp1295_.name = _tmp1293_;
	_g_free0 (_tmp1295_.description);
	_tmp1295_.description = _tmp1294_;
	_tmp1295_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1296_ = g_strdup ("non-starred");
	_tmp1297_ = g_strdup (_ ("Item is not starred, favorited, or pinned by the user"));
	memset (&_tmp1298_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1298_.name);
	_tmp1298_.name = _tmp1296_;
	_g_free0 (_tmp1298_.description);
	_tmp1298_.description = _tmp1297_;
	_tmp1298_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1299_ = g_strdup ("notification-disabled");
	_tmp1300_ = g_strdup (_ ("Notifications are disabled or in Do-Not-Disturb mode"));
	memset (&_tmp1301_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1301_.name);
	_tmp1301_.name = _tmp1299_;
	_g_free0 (_tmp1301_.description);
	_tmp1301_.description = _tmp1300_;
	_tmp1301_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1302_ = g_strdup ("printer-error");
	_tmp1303_ = g_strdup (_ ("Error or problem occurred when attempting to print"));
	memset (&_tmp1304_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1304_.name);
	_tmp1304_.name = _tmp1302_;
	_g_free0 (_tmp1304_.description);
	_tmp1304_.description = _tmp1303_;
	_tmp1304_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1305_ = g_strdup ("printer-printing");
	_tmp1306_ = g_strdup (_ ("Job has been successfully spooled or sent to a printer"));
	memset (&_tmp1307_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1307_.name);
	_tmp1307_.name = _tmp1305_;
	_g_free0 (_tmp1307_.description);
	_tmp1307_.description = _tmp1306_;
	_tmp1307_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1308_ = g_strdup ("process-completed");
	_tmp1309_ = g_strdup (_ ("Process, job, or task has successfully completed or finished"));
	memset (&_tmp1310_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1310_.name);
	_tmp1310_.name = _tmp1308_;
	_g_free0 (_tmp1310_.description);
	_tmp1310_.description = _tmp1309_;
	_tmp1310_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1311_ = g_strdup ("process-error");
	_tmp1312_ = g_strdup (_ ("Process, job, or task has failed or been unsuccessful"));
	memset (&_tmp1313_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1313_.name);
	_tmp1313_.name = _tmp1311_;
	_g_free0 (_tmp1313_.description);
	_tmp1313_.description = _tmp1312_;
	_tmp1313_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1314_ = g_strdup ("process-paused");
	_tmp1315_ = g_strdup (_ ("Process, job, or task is currently paused or on hold"));
	memset (&_tmp1316_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1316_.name);
	_tmp1316_.name = _tmp1314_;
	_g_free0 (_tmp1316_.description);
	_tmp1316_.description = _tmp1315_;
	_tmp1316_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1317_ = g_strdup ("security-high");
	_tmp1318_ = g_strdup (_ ("Known to be secure, such as using strong encryption and a valid, verif" \
"ied, or trusted certificate"));
	memset (&_tmp1319_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1319_.name);
	_tmp1319_.name = _tmp1317_;
	_g_free0 (_tmp1319_.description);
	_tmp1319_.description = _tmp1318_;
	_tmp1319_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1320_ = g_strdup ("security-medium");
	_tmp1321_ = g_strdup (_ ("Presumed to be secure, such as using encryption"));
	memset (&_tmp1322_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1322_.name);
	_tmp1322_.name = _tmp1320_;
	_g_free0 (_tmp1322_.description);
	_tmp1322_.description = _tmp1321_;
	_tmp1322_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1323_ = g_strdup ("security-low");
	_tmp1324_ = g_strdup (_ ("Presumed to be insecure, such as unsecured, unencrypted, weak encrypti" \
"on, or an invalid, unverified, or untrusted certificate"));
	memset (&_tmp1325_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1325_.name);
	_tmp1325_.name = _tmp1323_;
	_g_free0 (_tmp1325_.description);
	_tmp1325_.description = _tmp1324_;
	_tmp1325_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1326_ = g_strdup ("software-update-available");
	_tmp1327_ = g_strdup (_ ("Updated apps, software, or drivers are available"));
	memset (&_tmp1328_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1328_.name);
	_tmp1328_.name = _tmp1326_;
	_g_free0 (_tmp1328_.description);
	_tmp1328_.description = _tmp1327_;
	_tmp1328_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1329_ = g_strdup ("software-update-urgent");
	_tmp1330_ = g_strdup (_ ("Urgent or critical updates are available"));
	memset (&_tmp1331_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1331_.name);
	_tmp1331_.name = _tmp1329_;
	_g_free0 (_tmp1331_.description);
	_tmp1331_.description = _tmp1330_;
	_tmp1331_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1332_ = g_strdup ("starred");
	_tmp1333_ = g_strdup (_ ("Item is starred, favorited, or pinned by the user"));
	memset (&_tmp1334_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1334_.name);
	_tmp1334_.name = _tmp1332_;
	_g_free0 (_tmp1334_.description);
	_tmp1334_.description = _tmp1333_;
	_tmp1334_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1335_ = g_strdup ("task-due");
	_tmp1336_ = g_strdup (_ ("Task is due soon"));
	memset (&_tmp1337_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1337_.name);
	_tmp1337_.name = _tmp1335_;
	_g_free0 (_tmp1337_.description);
	_tmp1337_.description = _tmp1336_;
	_tmp1337_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1338_ = g_strdup ("task-past-due");
	_tmp1339_ = g_strdup (_ ("Task is incomplete past the due date"));
	memset (&_tmp1340_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1340_.name);
	_tmp1340_.name = _tmp1338_;
	_g_free0 (_tmp1340_.description);
	_tmp1340_.description = _tmp1339_;
	_tmp1340_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1341_ = g_strdup ("user-available");
	_tmp1342_ = g_strdup (_ ("User, person, or contact is available or online"));
	memset (&_tmp1343_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1343_.name);
	_tmp1343_.name = _tmp1341_;
	_g_free0 (_tmp1343_.description);
	_tmp1343_.description = _tmp1342_;
	_tmp1343_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1344_ = g_strdup ("user-away");
	_tmp1345_ = g_strdup (_ ("User, person, or contact is away or unavailable"));
	memset (&_tmp1346_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1346_.name);
	_tmp1346_.name = _tmp1344_;
	_g_free0 (_tmp1346_.description);
	_tmp1346_.description = _tmp1345_;
	_tmp1346_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1347_ = g_strdup ("user-idle");
	_tmp1348_ = g_strdup (_ ("User, person, or contact is idle or unresponsive"));
	memset (&_tmp1349_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1349_.name);
	_tmp1349_.name = _tmp1347_;
	_g_free0 (_tmp1349_.description);
	_tmp1349_.description = _tmp1348_;
	_tmp1349_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1350_ = g_strdup ("user-offline");
	_tmp1351_ = g_strdup (_ ("User, person, or contact is offline or unreachable"));
	memset (&_tmp1352_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1352_.name);
	_tmp1352_.name = _tmp1350_;
	_g_free0 (_tmp1352_.description);
	_tmp1352_.description = _tmp1351_;
	_tmp1352_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1353_ = g_strdup ("view-private");
	_tmp1354_ = g_strdup (_ ("Private, anonymous, untracked, or incognito"));
	memset (&_tmp1355_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1355_.name);
	_tmp1355_.name = _tmp1353_;
	_g_free0 (_tmp1355_.description);
	_tmp1355_.description = _tmp1354_;
	_tmp1355_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1356_ = g_strdup ("weather-clear");
	_tmp1357_ = g_strdup (_ ("Clear skies or sunny weather"));
	memset (&_tmp1358_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1358_.name);
	_tmp1358_.name = _tmp1356_;
	_g_free0 (_tmp1358_.description);
	_tmp1358_.description = _tmp1357_;
	_tmp1358_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1359_ = g_strdup ("weather-clear-night");
	_tmp1360_ = g_strdup (_ ("Clear skies weather during the night"));
	memset (&_tmp1361_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1361_.name);
	_tmp1361_.name = _tmp1359_;
	_g_free0 (_tmp1361_.description);
	_tmp1361_.description = _tmp1360_;
	_tmp1361_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1362_ = g_strdup ("weather-few-clouds");
	_tmp1363_ = g_strdup (_ ("Partly cloudy, partly clear, or partly sunny weather"));
	memset (&_tmp1364_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1364_.name);
	_tmp1364_.name = _tmp1362_;
	_g_free0 (_tmp1364_.description);
	_tmp1364_.description = _tmp1363_;
	_tmp1364_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1365_ = g_strdup ("weather-few-clouds-night");
	_tmp1366_ = g_strdup (_ ("Partly cloudy or partly clear weather during the night"));
	memset (&_tmp1367_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1367_.name);
	_tmp1367_.name = _tmp1365_;
	_g_free0 (_tmp1367_.description);
	_tmp1367_.description = _tmp1366_;
	_tmp1367_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1368_ = g_strdup ("weather-fog");
	_tmp1369_ = g_strdup (_ ("Foggy weather"));
	memset (&_tmp1370_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1370_.name);
	_tmp1370_.name = _tmp1368_;
	_g_free0 (_tmp1370_.description);
	_tmp1370_.description = _tmp1369_;
	_tmp1370_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1371_ = g_strdup ("weather-overcast");
	_tmp1372_ = g_strdup (_ ("Overcast or cloudy weather"));
	memset (&_tmp1373_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1373_.name);
	_tmp1373_.name = _tmp1371_;
	_g_free0 (_tmp1373_.description);
	_tmp1373_.description = _tmp1372_;
	_tmp1373_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1374_ = g_strdup ("weather-severe-alert");
	_tmp1375_ = g_strdup (_ ("Severe or critical weather warning or alert"));
	memset (&_tmp1376_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1376_.name);
	_tmp1376_.name = _tmp1374_;
	_g_free0 (_tmp1376_.description);
	_tmp1376_.description = _tmp1375_;
	_tmp1376_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1377_ = g_strdup ("weather-showers");
	_tmp1378_ = g_strdup (_ ("Showers or rainy weather"));
	memset (&_tmp1379_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1379_.name);
	_tmp1379_.name = _tmp1377_;
	_g_free0 (_tmp1379_.description);
	_tmp1379_.description = _tmp1378_;
	_tmp1379_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1380_ = g_strdup ("weather-showers-scattered");
	_tmp1381_ = g_strdup (_ ("Scattered showers or partly rainy weather"));
	memset (&_tmp1382_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1382_.name);
	_tmp1382_.name = _tmp1380_;
	_g_free0 (_tmp1382_.description);
	_tmp1382_.description = _tmp1381_;
	_tmp1382_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1383_ = g_strdup ("weather-snow");
	_tmp1384_ = g_strdup (_ ("Snow showers or snowy weather"));
	memset (&_tmp1385_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1385_.name);
	_tmp1385_.name = _tmp1383_;
	_g_free0 (_tmp1385_.description);
	_tmp1385_.description = _tmp1384_;
	_tmp1385_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1386_ = g_strdup ("weather-storm");
	_tmp1387_ = g_strdup (_ ("Thunderstorms or stormy weather"));
	memset (&_tmp1388_, 0, sizeof (IconCollectionIcon));
	_g_free0 (_tmp1388_.name);
	_tmp1388_.name = _tmp1386_;
	_g_free0 (_tmp1388_.description);
	_tmp1388_.description = _tmp1387_;
	_tmp1388_.category = ICON_COLLECTION_CATEGORY_STATUS;
	_tmp1389_ = g_new0 (IconCollectionIcon, 463);
	_tmp1389_[0] = _tmp2_;
	_tmp1389_[1] = _tmp5_;
	_tmp1389_[2] = _tmp8_;
	_tmp1389_[3] = _tmp11_;
	_tmp1389_[4] = _tmp14_;
	_tmp1389_[5] = _tmp17_;
	_tmp1389_[6] = _tmp20_;
	_tmp1389_[7] = _tmp23_;
	_tmp1389_[8] = _tmp26_;
	_tmp1389_[9] = _tmp29_;
	_tmp1389_[10] = _tmp32_;
	_tmp1389_[11] = _tmp35_;
	_tmp1389_[12] = _tmp38_;
	_tmp1389_[13] = _tmp41_;
	_tmp1389_[14] = _tmp44_;
	_tmp1389_[15] = _tmp47_;
	_tmp1389_[16] = _tmp50_;
	_tmp1389_[17] = _tmp53_;
	_tmp1389_[18] = _tmp56_;
	_tmp1389_[19] = _tmp59_;
	_tmp1389_[20] = _tmp62_;
	_tmp1389_[21] = _tmp65_;
	_tmp1389_[22] = _tmp68_;
	_tmp1389_[23] = _tmp71_;
	_tmp1389_[24] = _tmp74_;
	_tmp1389_[25] = _tmp77_;
	_tmp1389_[26] = _tmp80_;
	_tmp1389_[27] = _tmp83_;
	_tmp1389_[28] = _tmp86_;
	_tmp1389_[29] = _tmp89_;
	_tmp1389_[30] = _tmp92_;
	_tmp1389_[31] = _tmp95_;
	_tmp1389_[32] = _tmp98_;
	_tmp1389_[33] = _tmp101_;
	_tmp1389_[34] = _tmp104_;
	_tmp1389_[35] = _tmp107_;
	_tmp1389_[36] = _tmp110_;
	_tmp1389_[37] = _tmp113_;
	_tmp1389_[38] = _tmp116_;
	_tmp1389_[39] = _tmp119_;
	_tmp1389_[40] = _tmp122_;
	_tmp1389_[41] = _tmp125_;
	_tmp1389_[42] = _tmp128_;
	_tmp1389_[43] = _tmp131_;
	_tmp1389_[44] = _tmp134_;
	_tmp1389_[45] = _tmp137_;
	_tmp1389_[46] = _tmp140_;
	_tmp1389_[47] = _tmp143_;
	_tmp1389_[48] = _tmp146_;
	_tmp1389_[49] = _tmp149_;
	_tmp1389_[50] = _tmp152_;
	_tmp1389_[51] = _tmp155_;
	_tmp1389_[52] = _tmp158_;
	_tmp1389_[53] = _tmp161_;
	_tmp1389_[54] = _tmp164_;
	_tmp1389_[55] = _tmp167_;
	_tmp1389_[56] = _tmp170_;
	_tmp1389_[57] = _tmp173_;
	_tmp1389_[58] = _tmp176_;
	_tmp1389_[59] = _tmp179_;
	_tmp1389_[60] = _tmp182_;
	_tmp1389_[61] = _tmp185_;
	_tmp1389_[62] = _tmp188_;
	_tmp1389_[63] = _tmp191_;
	_tmp1389_[64] = _tmp194_;
	_tmp1389_[65] = _tmp197_;
	_tmp1389_[66] = _tmp200_;
	_tmp1389_[67] = _tmp203_;
	_tmp1389_[68] = _tmp206_;
	_tmp1389_[69] = _tmp209_;
	_tmp1389_[70] = _tmp212_;
	_tmp1389_[71] = _tmp215_;
	_tmp1389_[72] = _tmp218_;
	_tmp1389_[73] = _tmp221_;
	_tmp1389_[74] = _tmp224_;
	_tmp1389_[75] = _tmp227_;
	_tmp1389_[76] = _tmp230_;
	_tmp1389_[77] = _tmp233_;
	_tmp1389_[78] = _tmp236_;
	_tmp1389_[79] = _tmp239_;
	_tmp1389_[80] = _tmp242_;
	_tmp1389_[81] = _tmp245_;
	_tmp1389_[82] = _tmp248_;
	_tmp1389_[83] = _tmp251_;
	_tmp1389_[84] = _tmp254_;
	_tmp1389_[85] = _tmp257_;
	_tmp1389_[86] = _tmp260_;
	_tmp1389_[87] = _tmp263_;
	_tmp1389_[88] = _tmp266_;
	_tmp1389_[89] = _tmp269_;
	_tmp1389_[90] = _tmp272_;
	_tmp1389_[91] = _tmp275_;
	_tmp1389_[92] = _tmp278_;
	_tmp1389_[93] = _tmp281_;
	_tmp1389_[94] = _tmp284_;
	_tmp1389_[95] = _tmp287_;
	_tmp1389_[96] = _tmp290_;
	_tmp1389_[97] = _tmp293_;
	_tmp1389_[98] = _tmp296_;
	_tmp1389_[99] = _tmp299_;
	_tmp1389_[100] = _tmp302_;
	_tmp1389_[101] = _tmp305_;
	_tmp1389_[102] = _tmp308_;
	_tmp1389_[103] = _tmp311_;
	_tmp1389_[104] = _tmp314_;
	_tmp1389_[105] = _tmp317_;
	_tmp1389_[106] = _tmp320_;
	_tmp1389_[107] = _tmp323_;
	_tmp1389_[108] = _tmp326_;
	_tmp1389_[109] = _tmp329_;
	_tmp1389_[110] = _tmp332_;
	_tmp1389_[111] = _tmp335_;
	_tmp1389_[112] = _tmp338_;
	_tmp1389_[113] = _tmp341_;
	_tmp1389_[114] = _tmp344_;
	_tmp1389_[115] = _tmp347_;
	_tmp1389_[116] = _tmp350_;
	_tmp1389_[117] = _tmp353_;
	_tmp1389_[118] = _tmp356_;
	_tmp1389_[119] = _tmp359_;
	_tmp1389_[120] = _tmp362_;
	_tmp1389_[121] = _tmp365_;
	_tmp1389_[122] = _tmp368_;
	_tmp1389_[123] = _tmp371_;
	_tmp1389_[124] = _tmp374_;
	_tmp1389_[125] = _tmp377_;
	_tmp1389_[126] = _tmp380_;
	_tmp1389_[127] = _tmp383_;
	_tmp1389_[128] = _tmp386_;
	_tmp1389_[129] = _tmp389_;
	_tmp1389_[130] = _tmp392_;
	_tmp1389_[131] = _tmp395_;
	_tmp1389_[132] = _tmp398_;
	_tmp1389_[133] = _tmp401_;
	_tmp1389_[134] = _tmp404_;
	_tmp1389_[135] = _tmp407_;
	_tmp1389_[136] = _tmp410_;
	_tmp1389_[137] = _tmp413_;
	_tmp1389_[138] = _tmp416_;
	_tmp1389_[139] = _tmp419_;
	_tmp1389_[140] = _tmp422_;
	_tmp1389_[141] = _tmp425_;
	_tmp1389_[142] = _tmp428_;
	_tmp1389_[143] = _tmp431_;
	_tmp1389_[144] = _tmp434_;
	_tmp1389_[145] = _tmp437_;
	_tmp1389_[146] = _tmp440_;
	_tmp1389_[147] = _tmp443_;
	_tmp1389_[148] = _tmp446_;
	_tmp1389_[149] = _tmp449_;
	_tmp1389_[150] = _tmp452_;
	_tmp1389_[151] = _tmp455_;
	_tmp1389_[152] = _tmp458_;
	_tmp1389_[153] = _tmp461_;
	_tmp1389_[154] = _tmp464_;
	_tmp1389_[155] = _tmp467_;
	_tmp1389_[156] = _tmp470_;
	_tmp1389_[157] = _tmp473_;
	_tmp1389_[158] = _tmp476_;
	_tmp1389_[159] = _tmp479_;
	_tmp1389_[160] = _tmp482_;
	_tmp1389_[161] = _tmp485_;
	_tmp1389_[162] = _tmp488_;
	_tmp1389_[163] = _tmp491_;
	_tmp1389_[164] = _tmp494_;
	_tmp1389_[165] = _tmp497_;
	_tmp1389_[166] = _tmp500_;
	_tmp1389_[167] = _tmp503_;
	_tmp1389_[168] = _tmp506_;
	_tmp1389_[169] = _tmp509_;
	_tmp1389_[170] = _tmp512_;
	_tmp1389_[171] = _tmp515_;
	_tmp1389_[172] = _tmp518_;
	_tmp1389_[173] = _tmp521_;
	_tmp1389_[174] = _tmp524_;
	_tmp1389_[175] = _tmp527_;
	_tmp1389_[176] = _tmp530_;
	_tmp1389_[177] = _tmp533_;
	_tmp1389_[178] = _tmp536_;
	_tmp1389_[179] = _tmp539_;
	_tmp1389_[180] = _tmp542_;
	_tmp1389_[181] = _tmp545_;
	_tmp1389_[182] = _tmp548_;
	_tmp1389_[183] = _tmp551_;
	_tmp1389_[184] = _tmp554_;
	_tmp1389_[185] = _tmp557_;
	_tmp1389_[186] = _tmp560_;
	_tmp1389_[187] = _tmp563_;
	_tmp1389_[188] = _tmp566_;
	_tmp1389_[189] = _tmp569_;
	_tmp1389_[190] = _tmp572_;
	_tmp1389_[191] = _tmp575_;
	_tmp1389_[192] = _tmp578_;
	_tmp1389_[193] = _tmp581_;
	_tmp1389_[194] = _tmp584_;
	_tmp1389_[195] = _tmp587_;
	_tmp1389_[196] = _tmp590_;
	_tmp1389_[197] = _tmp593_;
	_tmp1389_[198] = _tmp596_;
	_tmp1389_[199] = _tmp599_;
	_tmp1389_[200] = _tmp602_;
	_tmp1389_[201] = _tmp605_;
	_tmp1389_[202] = _tmp608_;
	_tmp1389_[203] = _tmp611_;
	_tmp1389_[204] = _tmp614_;
	_tmp1389_[205] = _tmp617_;
	_tmp1389_[206] = _tmp620_;
	_tmp1389_[207] = _tmp623_;
	_tmp1389_[208] = _tmp626_;
	_tmp1389_[209] = _tmp629_;
	_tmp1389_[210] = _tmp632_;
	_tmp1389_[211] = _tmp635_;
	_tmp1389_[212] = _tmp638_;
	_tmp1389_[213] = _tmp641_;
	_tmp1389_[214] = _tmp644_;
	_tmp1389_[215] = _tmp647_;
	_tmp1389_[216] = _tmp650_;
	_tmp1389_[217] = _tmp653_;
	_tmp1389_[218] = _tmp656_;
	_tmp1389_[219] = _tmp659_;
	_tmp1389_[220] = _tmp662_;
	_tmp1389_[221] = _tmp665_;
	_tmp1389_[222] = _tmp668_;
	_tmp1389_[223] = _tmp671_;
	_tmp1389_[224] = _tmp674_;
	_tmp1389_[225] = _tmp677_;
	_tmp1389_[226] = _tmp680_;
	_tmp1389_[227] = _tmp683_;
	_tmp1389_[228] = _tmp686_;
	_tmp1389_[229] = _tmp689_;
	_tmp1389_[230] = _tmp692_;
	_tmp1389_[231] = _tmp695_;
	_tmp1389_[232] = _tmp698_;
	_tmp1389_[233] = _tmp701_;
	_tmp1389_[234] = _tmp704_;
	_tmp1389_[235] = _tmp707_;
	_tmp1389_[236] = _tmp710_;
	_tmp1389_[237] = _tmp713_;
	_tmp1389_[238] = _tmp716_;
	_tmp1389_[239] = _tmp719_;
	_tmp1389_[240] = _tmp722_;
	_tmp1389_[241] = _tmp725_;
	_tmp1389_[242] = _tmp728_;
	_tmp1389_[243] = _tmp731_;
	_tmp1389_[244] = _tmp734_;
	_tmp1389_[245] = _tmp737_;
	_tmp1389_[246] = _tmp740_;
	_tmp1389_[247] = _tmp743_;
	_tmp1389_[248] = _tmp746_;
	_tmp1389_[249] = _tmp749_;
	_tmp1389_[250] = _tmp752_;
	_tmp1389_[251] = _tmp755_;
	_tmp1389_[252] = _tmp758_;
	_tmp1389_[253] = _tmp761_;
	_tmp1389_[254] = _tmp764_;
	_tmp1389_[255] = _tmp767_;
	_tmp1389_[256] = _tmp770_;
	_tmp1389_[257] = _tmp773_;
	_tmp1389_[258] = _tmp776_;
	_tmp1389_[259] = _tmp779_;
	_tmp1389_[260] = _tmp782_;
	_tmp1389_[261] = _tmp785_;
	_tmp1389_[262] = _tmp788_;
	_tmp1389_[263] = _tmp791_;
	_tmp1389_[264] = _tmp794_;
	_tmp1389_[265] = _tmp797_;
	_tmp1389_[266] = _tmp800_;
	_tmp1389_[267] = _tmp803_;
	_tmp1389_[268] = _tmp806_;
	_tmp1389_[269] = _tmp809_;
	_tmp1389_[270] = _tmp812_;
	_tmp1389_[271] = _tmp815_;
	_tmp1389_[272] = _tmp818_;
	_tmp1389_[273] = _tmp821_;
	_tmp1389_[274] = _tmp824_;
	_tmp1389_[275] = _tmp827_;
	_tmp1389_[276] = _tmp830_;
	_tmp1389_[277] = _tmp833_;
	_tmp1389_[278] = _tmp836_;
	_tmp1389_[279] = _tmp839_;
	_tmp1389_[280] = _tmp842_;
	_tmp1389_[281] = _tmp845_;
	_tmp1389_[282] = _tmp848_;
	_tmp1389_[283] = _tmp851_;
	_tmp1389_[284] = _tmp854_;
	_tmp1389_[285] = _tmp857_;
	_tmp1389_[286] = _tmp860_;
	_tmp1389_[287] = _tmp863_;
	_tmp1389_[288] = _tmp866_;
	_tmp1389_[289] = _tmp869_;
	_tmp1389_[290] = _tmp872_;
	_tmp1389_[291] = _tmp875_;
	_tmp1389_[292] = _tmp878_;
	_tmp1389_[293] = _tmp881_;
	_tmp1389_[294] = _tmp884_;
	_tmp1389_[295] = _tmp887_;
	_tmp1389_[296] = _tmp890_;
	_tmp1389_[297] = _tmp893_;
	_tmp1389_[298] = _tmp896_;
	_tmp1389_[299] = _tmp899_;
	_tmp1389_[300] = _tmp902_;
	_tmp1389_[301] = _tmp905_;
	_tmp1389_[302] = _tmp908_;
	_tmp1389_[303] = _tmp911_;
	_tmp1389_[304] = _tmp914_;
	_tmp1389_[305] = _tmp917_;
	_tmp1389_[306] = _tmp920_;
	_tmp1389_[307] = _tmp923_;
	_tmp1389_[308] = _tmp926_;
	_tmp1389_[309] = _tmp929_;
	_tmp1389_[310] = _tmp932_;
	_tmp1389_[311] = _tmp935_;
	_tmp1389_[312] = _tmp938_;
	_tmp1389_[313] = _tmp941_;
	_tmp1389_[314] = _tmp944_;
	_tmp1389_[315] = _tmp947_;
	_tmp1389_[316] = _tmp950_;
	_tmp1389_[317] = _tmp953_;
	_tmp1389_[318] = _tmp956_;
	_tmp1389_[319] = _tmp959_;
	_tmp1389_[320] = _tmp962_;
	_tmp1389_[321] = _tmp965_;
	_tmp1389_[322] = _tmp968_;
	_tmp1389_[323] = _tmp971_;
	_tmp1389_[324] = _tmp974_;
	_tmp1389_[325] = _tmp977_;
	_tmp1389_[326] = _tmp980_;
	_tmp1389_[327] = _tmp983_;
	_tmp1389_[328] = _tmp986_;
	_tmp1389_[329] = _tmp989_;
	_tmp1389_[330] = _tmp992_;
	_tmp1389_[331] = _tmp995_;
	_tmp1389_[332] = _tmp998_;
	_tmp1389_[333] = _tmp1001_;
	_tmp1389_[334] = _tmp1004_;
	_tmp1389_[335] = _tmp1007_;
	_tmp1389_[336] = _tmp1010_;
	_tmp1389_[337] = _tmp1013_;
	_tmp1389_[338] = _tmp1016_;
	_tmp1389_[339] = _tmp1019_;
	_tmp1389_[340] = _tmp1022_;
	_tmp1389_[341] = _tmp1025_;
	_tmp1389_[342] = _tmp1028_;
	_tmp1389_[343] = _tmp1031_;
	_tmp1389_[344] = _tmp1034_;
	_tmp1389_[345] = _tmp1037_;
	_tmp1389_[346] = _tmp1040_;
	_tmp1389_[347] = _tmp1043_;
	_tmp1389_[348] = _tmp1046_;
	_tmp1389_[349] = _tmp1049_;
	_tmp1389_[350] = _tmp1052_;
	_tmp1389_[351] = _tmp1055_;
	_tmp1389_[352] = _tmp1058_;
	_tmp1389_[353] = _tmp1061_;
	_tmp1389_[354] = _tmp1064_;
	_tmp1389_[355] = _tmp1067_;
	_tmp1389_[356] = _tmp1070_;
	_tmp1389_[357] = _tmp1073_;
	_tmp1389_[358] = _tmp1076_;
	_tmp1389_[359] = _tmp1079_;
	_tmp1389_[360] = _tmp1082_;
	_tmp1389_[361] = _tmp1085_;
	_tmp1389_[362] = _tmp1088_;
	_tmp1389_[363] = _tmp1091_;
	_tmp1389_[364] = _tmp1094_;
	_tmp1389_[365] = _tmp1097_;
	_tmp1389_[366] = _tmp1100_;
	_tmp1389_[367] = _tmp1103_;
	_tmp1389_[368] = _tmp1106_;
	_tmp1389_[369] = _tmp1109_;
	_tmp1389_[370] = _tmp1112_;
	_tmp1389_[371] = _tmp1115_;
	_tmp1389_[372] = _tmp1118_;
	_tmp1389_[373] = _tmp1121_;
	_tmp1389_[374] = _tmp1124_;
	_tmp1389_[375] = _tmp1127_;
	_tmp1389_[376] = _tmp1130_;
	_tmp1389_[377] = _tmp1133_;
	_tmp1389_[378] = _tmp1136_;
	_tmp1389_[379] = _tmp1139_;
	_tmp1389_[380] = _tmp1142_;
	_tmp1389_[381] = _tmp1145_;
	_tmp1389_[382] = _tmp1148_;
	_tmp1389_[383] = _tmp1151_;
	_tmp1389_[384] = _tmp1154_;
	_tmp1389_[385] = _tmp1157_;
	_tmp1389_[386] = _tmp1160_;
	_tmp1389_[387] = _tmp1163_;
	_tmp1389_[388] = _tmp1166_;
	_tmp1389_[389] = _tmp1169_;
	_tmp1389_[390] = _tmp1172_;
	_tmp1389_[391] = _tmp1175_;
	_tmp1389_[392] = _tmp1178_;
	_tmp1389_[393] = _tmp1181_;
	_tmp1389_[394] = _tmp1184_;
	_tmp1389_[395] = _tmp1187_;
	_tmp1389_[396] = _tmp1190_;
	_tmp1389_[397] = _tmp1193_;
	_tmp1389_[398] = _tmp1196_;
	_tmp1389_[399] = _tmp1199_;
	_tmp1389_[400] = _tmp1202_;
	_tmp1389_[401] = _tmp1205_;
	_tmp1389_[402] = _tmp1208_;
	_tmp1389_[403] = _tmp1211_;
	_tmp1389_[404] = _tmp1214_;
	_tmp1389_[405] = _tmp1217_;
	_tmp1389_[406] = _tmp1220_;
	_tmp1389_[407] = _tmp1223_;
	_tmp1389_[408] = _tmp1226_;
	_tmp1389_[409] = _tmp1229_;
	_tmp1389_[410] = _tmp1232_;
	_tmp1389_[411] = _tmp1235_;
	_tmp1389_[412] = _tmp1238_;
	_tmp1389_[413] = _tmp1241_;
	_tmp1389_[414] = _tmp1244_;
	_tmp1389_[415] = _tmp1247_;
	_tmp1389_[416] = _tmp1250_;
	_tmp1389_[417] = _tmp1253_;
	_tmp1389_[418] = _tmp1256_;
	_tmp1389_[419] = _tmp1259_;
	_tmp1389_[420] = _tmp1262_;
	_tmp1389_[421] = _tmp1265_;
	_tmp1389_[422] = _tmp1268_;
	_tmp1389_[423] = _tmp1271_;
	_tmp1389_[424] = _tmp1274_;
	_tmp1389_[425] = _tmp1277_;
	_tmp1389_[426] = _tmp1280_;
	_tmp1389_[427] = _tmp1283_;
	_tmp1389_[428] = _tmp1286_;
	_tmp1389_[429] = _tmp1289_;
	_tmp1389_[430] = _tmp1292_;
	_tmp1389_[431] = _tmp1295_;
	_tmp1389_[432] = _tmp1298_;
	_tmp1389_[433] = _tmp1301_;
	_tmp1389_[434] = _tmp1304_;
	_tmp1389_[435] = _tmp1307_;
	_tmp1389_[436] = _tmp1310_;
	_tmp1389_[437] = _tmp1313_;
	_tmp1389_[438] = _tmp1316_;
	_tmp1389_[439] = _tmp1319_;
	_tmp1389_[440] = _tmp1322_;
	_tmp1389_[441] = _tmp1325_;
	_tmp1389_[442] = _tmp1328_;
	_tmp1389_[443] = _tmp1331_;
	_tmp1389_[444] = _tmp1334_;
	_tmp1389_[445] = _tmp1337_;
	_tmp1389_[446] = _tmp1340_;
	_tmp1389_[447] = _tmp1343_;
	_tmp1389_[448] = _tmp1346_;
	_tmp1389_[449] = _tmp1349_;
	_tmp1389_[450] = _tmp1352_;
	_tmp1389_[451] = _tmp1355_;
	_tmp1389_[452] = _tmp1358_;
	_tmp1389_[453] = _tmp1361_;
	_tmp1389_[454] = _tmp1364_;
	_tmp1389_[455] = _tmp1367_;
	_tmp1389_[456] = _tmp1370_;
	_tmp1389_[457] = _tmp1373_;
	_tmp1389_[458] = _tmp1376_;
	_tmp1389_[459] = _tmp1379_;
	_tmp1389_[460] = _tmp1382_;
	_tmp1389_[461] = _tmp1385_;
	_tmp1389_[462] = _tmp1388_;
	_tmp1390_ = _tmp1389_;
	_tmp1390__length1 = 463;
	if (result_length1) {
		*result_length1 = _tmp1390__length1;
	}
	result = _tmp1390_;
	return result;
}

IconCollection*
icon_collection_construct (GType object_type)
{
	IconCollection* self = NULL;
	self = (IconCollection*) g_type_create_instance (object_type);
	return self;
}

IconCollection*
icon_collection_new (void)
{
	return icon_collection_construct (TYPE_ICON_COLLECTION);
}

void
icon_collection_icon_copy (const IconCollectionIcon* self,
                           IconCollectionIcon* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
	_tmp2_ = (*self).description;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).description);
	(*dest).description = _tmp3_;
	(*dest).category = (*self).category;
}

void
icon_collection_icon_destroy (IconCollectionIcon* self)
{
	_g_free0 ((*self).name);
	_g_free0 ((*self).description);
}

IconCollectionIcon*
icon_collection_icon_dup (const IconCollectionIcon* self)
{
	IconCollectionIcon* dup;
	dup = g_new0 (IconCollectionIcon, 1);
	icon_collection_icon_copy (self, dup);
	return dup;
}

void
icon_collection_icon_free (IconCollectionIcon* self)
{
	icon_collection_icon_destroy (self);
	g_free (self);
}

 G_GNUC_NO_INLINE static GType
icon_collection_icon_get_type_once (void)
{
	GType icon_collection_icon_type_id;
	icon_collection_icon_type_id = g_boxed_type_register_static ("IconCollectionIcon", (GBoxedCopyFunc) icon_collection_icon_dup, (GBoxedFreeFunc) icon_collection_icon_free);
	return icon_collection_icon_type_id;
}

GType
icon_collection_icon_get_type (void)
{
	static gsize icon_collection_icon_type_id__once = 0;
	if (g_once_init_enter (&icon_collection_icon_type_id__once)) {
		GType icon_collection_icon_type_id;
		icon_collection_icon_type_id = icon_collection_icon_get_type_once ();
		g_once_init_leave (&icon_collection_icon_type_id__once, icon_collection_icon_type_id);
	}
	return icon_collection_icon_type_id__once;
}

static void
value_icon_collection_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_icon_collection_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		icon_collection_unref (value->data[0].v_pointer);
	}
}

static void
value_icon_collection_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = icon_collection_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_icon_collection_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_icon_collection_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		IconCollection * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = icon_collection_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_icon_collection_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	IconCollection ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = icon_collection_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_icon_collection (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecIconCollection* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ICON_COLLECTION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_icon_collection (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_COLLECTION), NULL);
	return value->data[0].v_pointer;
}

void
value_set_icon_collection (GValue* value,
                           gpointer v_object)
{
	IconCollection * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_COLLECTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ICON_COLLECTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		icon_collection_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		icon_collection_unref (old);
	}
}

void
value_take_icon_collection (GValue* value,
                            gpointer v_object)
{
	IconCollection * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_COLLECTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ICON_COLLECTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		icon_collection_unref (old);
	}
}

static void
icon_collection_class_init (IconCollectionClass * klass,
                            gpointer klass_data)
{
	icon_collection_parent_class = g_type_class_peek_parent (klass);
	((IconCollectionClass *) klass)->finalize = icon_collection_finalize;
}

static void
icon_collection_instance_init (IconCollection * self,
                               gpointer klass)
{
	self->ref_count = 1;
}

static void
icon_collection_finalize (IconCollection * obj)
{
	IconCollection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_COLLECTION, IconCollection);
	g_signal_handlers_destroy (self);
}

 G_GNUC_NO_INLINE static GType
icon_collection_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_icon_collection_init, value_icon_collection_free_value, value_icon_collection_copy_value, value_icon_collection_peek_pointer, "p", value_icon_collection_collect_value, "p", value_icon_collection_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (IconCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconCollection), 0, (GInstanceInitFunc) icon_collection_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType icon_collection_type_id;
	icon_collection_type_id = g_type_register_fundamental (g_type_fundamental_next (), "IconCollection", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return icon_collection_type_id;
}

GType
icon_collection_get_type (void)
{
	static gsize icon_collection_type_id__once = 0;
	if (g_once_init_enter (&icon_collection_type_id__once)) {
		GType icon_collection_type_id;
		icon_collection_type_id = icon_collection_get_type_once ();
		g_once_init_leave (&icon_collection_type_id__once, icon_collection_type_id);
	}
	return icon_collection_type_id__once;
}

gpointer
icon_collection_ref (gpointer instance)
{
	IconCollection * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
icon_collection_unref (gpointer instance)
{
	IconCollection * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		ICON_COLLECTION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

